% vp_GISpro.m
% Group Invarient Subprofile ROI Map Processing
%___________________________________________________________________________
% vp_GISpro.m	ScAnVP C.4 	P. Spetsieris	 May. 11, 2000
%		rev 5.2		P.S.		Nov. 18, 2003

global RoiNo RoiTyp RegDef RoiThresh RoiChoice FI Lh
global ActRoi ActHand LabIds LabNames Picking herror herr roigui
global FName FNames RoiFName RoiFNames PlaneNo1 PlaneNo2
global gisfid SASRpt SAS_cRpt TemplRpt PlaneRpt SUMRpt CompRpt
global Means PlanarMeans CheckRois Automatic GOsignal
global NonStdLabs NonStdNo NonStdLabStr hmode hcont hrpt hgmnmx
global ThreshTime ThreshMode FixedThresh Thresholds MinMaxs Ecolor
global DIM VOX SCALE TYPE OFFSET ORIGIN DESCRIP GLMAX GLMIN DESCRIP
global EXPTIM DURATION GMIN GMAX FixedThMin GisWeight
global dim1 dim3 vox1 mtyp3 BgrndFName statFName or1 or3 scale3
global dimS voxS orS
global TaperFactor FILLType PreSmooth
global GMin1 GMax1 GMin3 GMax3 MinThresh MaxThresh DatOp MaskOn
global POpt CM GCM


%global hmapon

Message0=['............................................ '];
Message=Message0;

gisfid=0;
sasfid1=0; sasfid2=0;
sumfid1=0; sumfid2=0;

RoiChoice=1;
NameConvention=2;

%Local for each plane
LabNames=str2mat(blanks(40),blanks(40));
LabIds=str2mat(blanks(4),blanks(4)); 

%Global
NonStdLabs=str2mat('Non Standard Label                      ');
NonStdLabStr=['Non Standard Label                      '];
NonStdNo=101;

nplns=size(RoiFNames);
  
RoiFName=RoiFNames(1,:);

nnms=size(FNames);

%[roif,sfx]=strtok(RoiFNames(1,:),'.'); [pln,sfx]=strtok(sfx,'.');
%if isempty(sfx), NameConvention=1; q=max([find(isletter(roif)==1) 0]); 
%	sz=size(roif); plane1=str2num(roif(q+1:sz(2))) ; roif=roif(1:q);
%else, plane1=str2num(pln); end;
%if nplns(1) == 1
%   plane2=plane1;
%else
%  [roif,sfx]=strtok(RoiFNames(2,:),'.'); [pln,sfx]=strtok(sfx,'.');
%  if isempty(sfx), NameConvention=1; q=max([find(isletter(roif)==1) 0]); 
%  	sz=size(roif); plane2=str2num(roif(q+1:sz(2))) ; roif=roif(1:q);
%	if NameConvention ~=1,
% 		set(herror,'string','Inconsistent Second Roi Name');
%	return, end;
%  else, plane2=str2num(pln); end;
%end;
	
[dnm,dnm,dir,nm,sfx]=vp_nm('dnm',RoiFNames(1,:));
[roif,pln]=strtok(nm,'.');
if isempty(pln), NameConvention=1; q=max([find(isletter(roif)==1) 0]); 
	sz=size(roif); plane1=str2num(roif(q+1:sz(2))) ; roif=roif(1:q);
else, plane1=str2num(pln(2:length(pln))); end;
if nplns(1) == 1
   plane2=plane1;
else
  [dnm,dnm,dir,nm,sfx]=vp_nm('dnm',RoiFNames(2,:));
  [roif,pln]=strtok(nm,'.');
  if isempty(pln), NameConvention=1; q=max([find(isletter(roif)==1) 0]); 
  	sz=size(roif); plane2=str2num(roif(q+1:sz(2))) ; roif=roif(1:q);
	if NameConvention ~=1,
 		set(herror,'string','Inconsistent Second Roi Name');
	return, end;
  else, plane2=str2num(pln(2:length(pln))); end;
end;
roif=[dir,roif];
	

PlaneNo1=min(plane1,plane2);
PlaneNo2=max(plane1,plane2);

Bcolor = [.8,.8,.8];
Kcolor = [.8,1,1];
Fcolor = [.8,.8,1];


%CHECK DIMENSIONS
%P=strtok(FName,'.');
P=vp_nm('dnm',FName);
[dim1 vox1 scale1 type1 offset1 or1 descrip1 tim1 dur1 mtyp1 gentim1 subid1 expdate1 glmax1 glmin1] = vp_hread([P '.hdr']);

BgrndFName=deblank(BgrndFName);
%P=strtok(BgrndFName,'.');
P=vp_nm('dnm',BgrndFName);
[dim3 vox3 scale3 type3 offset3 or3 descrip3 tim3 dur3 mtyp3 gentim3 subid3 expdate3 glmax3 glmin3] = vp_hread([P '.hdr']);
BgrndFNAME=[P '.img'];

if vox1 ~= vox3, 
  	vp_message('ERROR: Incompatible Voxel sizes');
	vox1, vox3,
	return;
end

%Set PreSmooth dimensions. If PreSmooth==0, they will be the same as dim1,vox1,or1.

dimS=(2.^PreSmooth)*dim1; dimS(3)=dim1(3);
voxS=vox1/(2.^PreSmooth); voxS(3)=vox1(3);
orS=round((max(or1,1)-1)*(2.^PreSmooth) + 1); orS(3)=or1(3); orS=max(orS,1); orS=min(orS,dimS);
%orS=(2.^PreSmooth)*or1; orS(3)=or1(3);

gisprogui = figure('Color',Fcolor,'Name','gisprogui',...
'NumberTitle','off','Position',[100,370,270,210],...
'Pointer','watch',...
'Units','Pixels');
	
RoiTyp='r';
RoiThresh=100;

RegDef0 =[0 50 50 10 10 0] ;
RegDef = RegDef0;

RoiNo=0; ActRoi=0;

cbFName=['set(hnm,''string'',FName)'];

if ThreshMode<4, menustr=['move|reshape|rethresh'], else, menustr=['move|reshape']; end;

cbmode=['if Automatic, modestr=''SET AUTOMATIC OFF''; onoff=''off''; GOsignal=1; Picking=''OFF'';',...
'else modestr=''SET INTERACTIVE OFF'' ; onoff=''on''; GOsignal=0; Picking=''ON''; end;'];

eval(cbmode);


hpnm=uicontrol(gisprogui,'style','text','string', 'FNAME :',...
	'position',[10 180 45 15],'BackgroundColor',Fcolor,...
	'callback',cbFName);
	

hnm=uicontrol(gisprogui,'style','text','string', [FName],...
	'position',[55 180 235 15],'BackgroundColor',Fcolor,...
	'callback',cbFName);

hgmnmx=uicontrol(gisprogui,'Style','Text','string',...
	['Global Min,Max: (' sprintf('%.2f, ',GMIN) sprintf('%.2f',GMAX) ')'],...
	'position',[10 165 200 15],...
	'TooltipString','Global Data Minimum and Maximum',...
	'FontName','Times','FontSize',9,'FontAngle','normal',...
	'BackgroundColor',Fcolor);
	 

cbPlaneNo=['set(gco,''string'',num2str(PlaneNo)'];

cbRoiMenu = ['RoiChoice=get(hroimenu,''Value''); if RoiChoice==3, vp_rethresh; RoiChoice=6; end; figure(FI);'];

cbPRoiName=['',...
	'set(hname,''string'',RoiFName); '];
	
uicontrol(gisprogui,'style','text','string', 'TEMPLATE : ',...
	'position',[10 140 70 20],'BackgroundColor',Fcolor,...
	'callback',cbPRoiName);
	
hname=uicontrol(gisprogui,'style','text','string',RoiFName,...
	'position',[80 140 200 20],'BackgroundColor',Fcolor,'callback',cbPRoiName);

uicontrol(gisprogui,'style','text','string', 'PLANE No. :',...
	'position',[10 120 75 20],'BackgroundColor',Fcolor);
	
hpln=uicontrol(gisprogui,'style','text','string',PlaneNo,...
	'position',[85 120 30 20],'BackgroundColor',Fcolor,'callback',cbPlaneNo);


thrshtxt=strvcat('VARIABLE %of 2D REG MAX','VARIABLE %of 3D REG MAX',...
['FIXED ', num2str(FixedThresh), '% of 2D REG MAX'],...
['FIXED ', num2str(FixedThresh), '% of 3D REG MAX'],...
['FIXED THRES. MIN : ', num2str(FixedThMin)]);

uicontrol(gisprogui,'style','text','string', thrshtxt(ThreshMode,:),...
	'position',[110 120 150 20],'BackgroundColor',Fcolor);


hcont=uicontrol(gisprogui,'string', 'CONTINUE',...
	'Enable',onoff,...
	'position',[10 35 65 25],'BackgroundColor',Bcolor, 'callback',...
	['GOsignal=1;']);
	
hmode=uicontrol(gisprogui,'string', modestr,...
	'position',[78 35 120 25],'BackgroundColor',Bcolor,...
	'callback',['if Automatic, Automatic=0, else Automatic=1, end;',...
	'eval(cbmode); set(hcont,''Enable'',onoff);',...
	'set(hrpt,''Enable'',onoff); ',...
	'set(hroimenu,''Enable'',onoff); ',...
	'set(hgismap,''Enable'',onoff); ',...
	'set(gco,''string'',modestr);']);

%hroi=uicontrol(gisprogui,'style','edit','string',RoiTyp,'Tag','roied',...
%	'position',[210 90 40 25],'Enable','off','BackgroundColor',Kcolor,'callback',cbroi);

%hmapon=uicontrol(gisprogui,'string', 'THRESHOLD PIXEL MAP',...
%	'position',[80 90 150 25],'BackgroundColor',Bcolor,'Visible','on',...
%	'Enable',onoff,...
%	 'callback',...
%	 ['vp_roimap(''display'',0)']);
	 
hgismap=uicontrol(gisprogui,'string', 'UPDATE GIS MAP',...
	'position',[80 90 150 25],'BackgroundColor',Bcolor,'Visible','on',...
	'Enable',onoff,...
	 'callback',...
	 ['vp_gismap(''display'',0, 1)']);

uicontrol(gisprogui,'string', ['Set Tapering Factor ' num2str(TaperFactor) '%'],...
	'position',[10 65 150 20],'BackgroundColor',Bcolor,'Visible','on',...
	'Enable',onoff,...
	 'callback',...
	 ['tpfact=TaperFactor; vp_tapergui; waitfor(findobj(''Name'',''tapergui'')); ',...
	 'set(gco,''string'', [''Set Tapering Factor '', num2str(TaperFactor) ''%'']);',...
	 'FILLType=2; if TaperFactor ~= tpfact, vp_gismap(''display'',0,1); end; ']);
	 
	 
%hroimenu=uicontrol(FI,'Style','popup','Visible','off','String','move|modify|stat|delete',
%	'move|reshape|statistics|map|relabel|rethresh|delete'

hroimenu=uicontrol(gisprogui,'Style','popup','Visible','on',...
	'String',menustr,...
	'Tag','RoiMenu',...
	'Enable',onoff,...
    	'Position',[170 25 82 60],'callback',cbRoiMenu);

hrpt=uicontrol(gisprogui,'String','REPORT',...
	'Position',[10 90 60 25],...
	'Enable',onoff,...
	'CallBack',['set(gcbf,''Pointer'',''watch'');',...
	'vp_roigrpt; set(gcbf,''Pointer'',''arrow'');',...
	'set(herror,''string'',['' '',Message]);']);

%hsaver=uicontrol(gisprogui,'string','RESTART',...
%	'position',[90 35 75 25],'BackgroundColor',Bcolor,'Visible','on',...
%	'Enable','on',...
%	 'Callback',...
%	 ['set(findobj(''Name'',''GROUP ROIgui''),''Visible'',''on''); ',...
%	  'delete(gisprogui);']);
	
%	 'vp_grouprpt(''savexit''); ',...
%	 'set(herror,''string'',['' '',Message]);']);
	
uicontrol(gisprogui,'String','QUIT',...
	'Position',[200 35 50 25],...
	'CallBack',['delete(gisprogui);',...
  	'delete(findobj(''Name'',''REPORT''));',...
  	'delete(findobj(''Name'',''Threshold MAP''));',...
  	'delete(findobj(''Name'',''Statistics''));',...
  	'delete(findobj(''Name'',''LABELgui''));',...
  	'delete(findobj(''Name'',''Save Rois''));',...
  	'delete(findobj(''Name'',''GIS gui''));',...
	'delete(FI);']);
	
	
herror = uicontrol(gisprogui,'string', [' ..............................'],...
	'position',[10 10 240 25],...
	'CallBack',['set(herror,''string'',['' '',Message]);'],...
	'BackgroundColor',Ecolor);


if Automatic,
    	set(herror,'string',['PROCESSING']);
	set(gisprogui,'Pointer','watch');
	drawnow;
end


FName=FNames(1,:);

snm=1;

%if Automatic, jtimes=nnms(1), else jtimes=0; end;

for j=1:nnms(1) ;

  repeats=1; ThreshTime=0;
  % check for 3D modes
  if (ThreshMode==2 | ThreshMode==4) 
	repeats=2; %Additional time for 3D processing
	MinMaxs=zeros(101,3,2);
	ThreshTime=1;
  end

  FName=FNames(snm,:);
  snm =snm+1;
  
  %set(hnm,'string',['FNAME: ', FName]);
  set(hnm,'string',[FName]);
  
  if PlaneRpt | CompRpt
    q=max([find(FName=='\') 0]);
    q2=max([find(FName=='.') 0]);
    
    if q ~=0, 
     q=q+1;
    end
    
    if q2==0, 
    	q2=length(FName);
    else q2=q2-1;
    end
  
    subj=[FName(q:q2)] ;
  end
    
  
  [gisfid,Message]=vp_gisfun('opengis',FName); 
  statFName=Message;
  if gisfid == -1
  	set(herror,'string',[' ',Message]);
  return, end
  [out1,Message]=vp_gisfun('wzeros',gisfid,dimS,(PlaneNo1-1)); 
  
  if out1 == -1
  	set(herror,'string',[' ',Message]);
  return, end
  
  if CompRpt==1 
 	Means=zeros(101,3,3);
  end
  
  for k=1:repeats
    if k==repeats
    	ThreshTime=0;
    end
    
    for i=PlaneNo1:PlaneNo2
  
	if ThreshTime
	 set(herror,'string',['WAIT FOR INITIAL PROCESSING']);
	end

  	RoiNo=0; ActRoi=0;
	LabNames=[]; LabIds=[];
  	LabNames=str2mat(blanks(40),blanks(40));
  	LabIds=str2mat(blanks(4),blanks(4)); 
	
	PlaneNo=i,
	
 	vp_fimage;
	
	if isempty(Message)
		PlaneNo=max(PlaneNo-1,1) ;
	end;
	
	if i==PlaneNo1 & k==1,
	  [GMAX GMIN]=vp_roifuns('gminmax'), 
	  set(hgmnmx,'String',...
	    ['Global Min,Max: (' sprintf('%.2f, ',GMIN) sprintf('%.2f',GMAX) ')']);
	end
	
	if NameConvention==1
	  RoiFName=[roif,num2str(i),'.roi']
	else
	  RoiFName=[roif,'.',num2str(i),'.roi']
	end
	
 	set(hname,'string', RoiFName);
	
	set(hpln,'string',num2str(PlaneNo));
	%set(hthr,'string',num2str(RoiThresh));
	
        drawnow;
	
        roino=RoiNo;
	
	[out1,Message]=vp_grouprpt('read',RoiFName); 
	
	if out1 < 0 , 
		s=RoiFName;
		while ~isempty(s), [x,s]=strtok(s,'\'); end;
		set(herror,'string',[x,': ',Message]);
		vp_message(Message);
		if out1==-1, pause(2); delete(findobj('Name','Message')); 
		else,
			while(findobj('Name','Message')),pause(1),end;
		end;
		%return; Do not exit if an intermediate file doesn't exist;
		
  		[out1,Message]=vp_gisfun('wzeros',gisfid,dimS,1); 
	        set(herror,'string',[' ',Message]);
	    
	end;
	
	if ThreshMode > 2  & ThreshMode < 5 & RoiNo > 0 
		for rno=1:RoiNo
			Thresholds(rno)=FixedThresh;
		end
	end
	
	%	set(hmapon,'Enable','on');
	
        if RoiNo~=roino    % Not 0
	  if PreSmooth,
			Fitting=1;
			DATA=vp_interp2D(DATA,PreSmooth);
			if (DATAMIN==DATAMAX & DATAMIN==0),
	 		  figure(FI);
	 		  imh=image(DATA);
			else
	 		  imh=imagesc(DATA,[DATAMIN DATAMAX]);
			end;
			
			axis off image xy ;
			
			DIM=dimS; ORIGIN=orS; VOX=voxS;
			%Correct for aspect ratio
			vp_aspect(1,VOX);
			[out1,Message]=vp_grouprpt('read',RoiFName); 
	  end
          if ~Automatic 
	    
		GOsignal=0;
    		set(herror,'string',['WAIT FOR PROCESSING']);
		set(gisprogui,'Pointer','watch');
		drawnow;
		set(hcont,'Enable','on');
		set(hmode,'Enable','on');
		set(hrpt,'Enable','on');
		set(hroimenu,'Enable','on');
		
	 	vp_gismap('display',0, 0);
    		set(herror,'string',['Press CONTINUE to resume processing']);
		set(gisprogui,'Pointer','arrow');
		drawnow;
	
		while ~GOsignal 
				
			pause(1);
			
		end;
		
		
  		delete(findobj('Name','REPORT'));
  		delete(findobj('Name','Threshold MAP'));
  		delete(findobj('Name','GisMap'));
		set(gisprogui,'Pointer','watch');
    		Message=['WAIT FOR PROCESSING'];
          end   
	end
	
	set(herror,'string',[' ',Message]);
	
        if out1 >= 0 
	  if ThreshTime
	    [out1,Message]=vp_grouprpt('getmax'); 
	  else
	    if ThreshMode == 2 & RoiNo > 0
		for rno=1:RoiNo
			[labno labLR]=strtok(LabIds(rno,:),'LR');
			labno=str2num(labno);
		
			if findstr(labLR,'L'), ori = 1;
			elseif findstr(labLR,'R'), ori=2; else ori=3; end;
			Thresholds(rno)=MinMaxs(labno,ori,1) ;
		end
	    end
	
	    out1=vp_gismap('save',0,gisfid); 
	    set(herror,'string',[' ',Message]);
	    
	  end
	end %if out1
	
    end  %for i planes	
	
  end %for k repeats
     
	
  if (PlaneNo2+1) <= dim1(3),
    [out1,Message]=vp_gisfun('wzeros',gisfid,dimS,(dim1(3)-PlaneNo2)); 
    set(herror,'string',[' ',Message]);
  end     
  
  [out1,Message]=vp_gisfun('closegis',gisfid); 
  
  vp_hwrite(statFName,dimS,voxS,1.0,64,offset1,orS,'GIS image file',...
  tim1,dur1,gentim1,subid1,expdate1,round(max(GisWeight)),round(min(GisWeight)));
 
end % for j names

%set(herror,'string',[' ','PROCESSING COMPLETE - ',statFName,' SAVED']);
set(herror,'string',[' ','PROCESSING COMPLETE - ROI GIS VOL SAVED']);
vp_note(['PROCESSING COMPLETE - ROI GIS VOL SAVED: ', statFName]);

set(hmode,'Enable','off');

set(gisprogui,'Pointer','arrow');


POpt='Help';

opt1=['SAVE GIS & GIS/MRI WEIGHTED ROI VOL Images'];
opt2=['SAVE Only GIS WEIGHTED ROI VOL Image'];

while strcmp(POpt,'Help')
 POpt=vp_opt('X','SAVE GIS/MRI ROI WEIGHTED VOL IMAGE?','YES',opt1,'NO',opt2,'EXIT','','Help','');
end %while

if(strcmp(POpt,'YES')),

  vp_note(['WAIT FOR AUTO GIS MAP OVERLAY'],4);

  FName=statFName; vp_fimage;
  [GMax1 GMin1]=vp_roifuns('gminmax');
  MinThresh=GMin1; MaxThresh=GMax1;
  FName=BgrndFName; vp_fimage;
  [GMax3 GMin3]=vp_roifuns('gminmax');
  MaskOn=0; DatOp=1; 
  set(FI,'name','Statistical Map');
  vp_statmapro;

end


	   
