% vp_anahdr
% Read headers of ANALYZE Format images
%_______________________________________________________________________
% vp_anahdr (ANAHDR) allows the user to read the header of an ANALYZE 
% format image and display the results in the matlab window. Results
% are saved in the 'hdroutput.txt' file. The 'anahdr' routine can also
% be run in a DOS window. See also FIXHDR.
% Nifti and UNIX format files are flagged as errors.
%_______________________________________________________________________
% vp_anahdr	ScAnVP	C.0	P. Spetsieris	7/12/99
% 		ScAnVP Rev.5.9	P. Spetsieris	4/1/08


global HelpMode FMenu NameLst

if HelpMode, vp_help(mfilename), return ; end;

if vp_filesui(Inf,'.img','Select images to read headers',mfilename) < 0 ,return; end;

m= size(NameLst,1);

if vp_checkNIFU(NameLst)
return, end;

set(FMenu,'Pointer','Watch');

for i=1:m
  FName=deblank(NameLst(i,:));
  DosCmd = ['anahdr ',FName];
  %unix(DosCmd);
  %vp_dos(DosCmd);
  

  [s, w]=vp_dos(DosCmd);


  if s < 0,
     vp_note(['Check Command Window and hdroutput.txt for ',FName, ' file ERROR'],3 );
  end


  if i==1
  	DosCmd = ['anahdr ',FName,' > hdroutput.txt'];
  else
  	DosCmd = ['anahdr ',FName,' >> hdroutput.txt'];
  end
  
  vp_dos(DosCmd);
  disp(' ');

end

set(FMenu,'Pointer','Arrow');
vp_note('END anahdr - Check Matlab window and hdroutput.txt');

