function vp_aspect(viewno,vox)
%
% function vp_aspect.m (viewno,vox)
% 
% Correct Aspect ratio
% This routine corrects the current image's aspect ratio in
% accordance to the input view number and voxel dimensions.
% viewno: 1=Axial, 2=Sagittal, 3=Coronal
% vox: voxel sizes [dx dy dz]
%_______________________________________________________________________
% 		 	C.4.7.1 Phoebe Spetsieris  Oct. 25, 2001

	v=axis;
	if viewno == 1
		if vox(2) == vox(1), return, end;
		%if v(2)*vox(1) > v(4)*vox(2),
		 %v(4)= v(2)*(vox(1)/vox(2));
		%else
		 %v(2)= v(4)*(vox(1)/vox(2));
		%end
		if v(2)*vox(1) > v(4)*vox(2),
		 v(4)= v(2)*(vox(1)/vox(2));
		else
		 v(2)= v(4)*(vox(2)/vox(1));
		end
	elseif viewno == 2
		if vox(3) == vox(2), return, end;
		if v(2)*vox(2) > v(4)*vox(3),
		 v(4)= v(2)*(vox(2)/vox(3));
		else
		 v(2)= v(4)*(vox(3)/vox(2));
		end
	elseif viewno == 3
		if vox(3) == vox(1), return, end;
		if v(2)*vox(1) > v(4)*vox(3),
		 v(4)= v(2)*(vox(1)/vox(3));
		else
		 v(2)= v(4)*(vox(3)/vox(1));
		end
	else, return,
	end
	axis(v)
	axis square;
