function [out1, Message]=vp_atlaslabel(atlasnm,index)
%
% Given Atlas Name and index, read the corrsponding template
% text label file and find label corresponding to given index.
% The names of the regions are listed numerically in the text
% file AtlasNameLabs.txt that accompanies the atlas.
% Following an initial text line defining the file, each region is 
% listed in numerical order as num name or num name_L or num name_R.
%
%_______________________________________________________________________
% function vp_atlaslabel.m   ScAnVP ver 6.2  P. Spetsieris Jul. 5, 2011
% 	

global LabIds LabNames PlaneNo
global Message RoiNo FI
global NonStdLabs NonStdNo NonStdLabStr
global DIM ORIGIN VOX TemplDIM TemplORIGIN TemplVOX Fitting Flipping
global ALabNames ALabNos AVolXYZ LabAIds Keyin

   out1=0;
   Message=['Label Not Found'];

  
   [atnm,atdnm]=vp_nm('nm',atlasnm);
   labfile=[atdnm,'Labs.txt'],

   fp = fopen(labfile,'rt');
   if fp <= 0, Message=['READ LABEL FILE: fopen error'],
   out1=-2;
   return; end;

   dumpstr=fscanf(fp,'%s',1); %Skip First String
   
   while(isempty(str2num(dumpstr)) | isempty(dumpstr))
   	if isempty(dumpstr), out1=-2;
	  Message=['No Label Found']; fclose(fp); return, end;
   	dumpstr=fscanf(fp,'%s',1);
   end;

   no=str2num(dumpstr); alabname=fscanf(fp,'%s',1);    
   if (no==index), Message=alabname; fclose(fp); return; end;

   while(~isempty(dumpstr)),
   	no=fscanf(fp,'%d',1);
	if isempty(no), out1=-2; break; end;
 	dumpstr=fscanf(fp,'%s',1);    %file roi label
        if (no==index), Message=dumpstr;  break; end;

   end %while

   fclose(fp);

