function [axorx, axory] = vp_axorigin(vporx, vpory, adimx, adimy, fdimx, fdimy)
% Converts ScAnVP coordinates to the normalized axis origin given
% figure and axes dimensions
%
% vporx - x coord in scanvp pixel coordinates
% vpory - y coord in scanvp pixel coordinates
% adimx - X dimension of axes
% adimy - Y dimension of axes
% fdimx - X dimension of figure
% fdimy - Y dimension of figure
%___________________________________________________________________________
%
% vp_axorigin	C.0 	P.Spetsieris  May 20, 1998

axorx = vporx/fdimx ;
axory = (fdimy-vpory-adimy)/fdimy ;

