% function flag=vp_checkNIFU(filenames,mode);
%
% Checks if any file in a list of names is NIFTI or UNIX
% and returns a flag value.
% flag = 0: No NIFTI or UNIX files found or
%	    USER selects to proceed despite found NIFTI file(s)
% flag = 1: NIFTI file found and do not proceed.
% flag = 2; UNIX format file either NIFTI or ANALYZE
% mode = 0; Exit for Unix files and User decision for NIFTI files
% mode = 1; Exit for Unix files and for NIFTI files
% mode = 2; Exit for Unix files and Note only for NIFTI files
% mode = 3; Exit for Unix files and for NIFTI OFFSET not 0 files
% mode = 4; Exit for Unix files only and No Note for NIFTI files
% mode = 5; Exit for Unix files and for .nii TYPE NIFTI files
%_______________________________________________________________________
% ScAnVP ver. 5.8.5	Phoebe Spetsieris  Mar. 5,  2008
% 	 ver. 6.2	P.S.  Nov. 12, 2012
% 	 ver. 6.2.1	P.S.  Apr. 29, 2013
% 	 ver. 6.4	P.S.  Jan. 04, 2015

function flag = vp_checkNIFU(filenames, mode)

global HelpMode KEYIN HDRTYPE MATYPE VAL_OFFSET NIFTITYPE

if HelpMode, vp_help(mfilename), return ; end;

flag=0; 

if nargin < 2, mode=0; end;

m=size(filenames,1);
for i=1:m,
 filnm=filenames(i,:);
 vp_hread(filnm);
 if strcmp(HDRTYPE,'NIFTI')flag=1; end;
 if strcmp(MATYPE,'UNIX')flag=2; end;
end

if (flag==1)
 if mode==0
   if(vp_keyin('NOTE ONE or MORE NIFTI FILE(S), EXIT Y or N?','N')~='Y'), flag=0; end;
 elseif mode==1
   vp_note('ERROR CONVERT NIFTI FILE(S) - EXIT');  
 elseif mode==2
   vp_note('NIFTI FILE(S) FOUND', 2); flag=0;  
 elseif mode==3
   if (VAL_OFFSET) ~= 0
     vp_note('CONVERT NIFTI FILE(S) TO ANALYZE, VAL_OFFSET Not 0 For ',filnm);  
     VAL_OFFSET,
   else
	flag=0;
   end
 elseif mode==4
   flag=0;
 elseif mode==5
   if NIFTITYPE==1
     vp_note('CONVERT NIFTI .nii FILE(S) TO ANALYZE For ',filnm);  
     
     else vp_note('NIFTI FILE(S) FOUND', 2); flag=0;  
   end;
   
 end
end

if (flag==2)
 vp_note('ERROR CONVERT UNIX FILE(S) TO DOS ANALYZE - EXIT');  
 filnm,
end

