% vp_compress
% Compress files.
%_______________________________________________________________________
% User selects compression or decompression. The GNU routine 'gzip'
% is used to process the files and must be installed. (see www.gzip.org)
% For additional options, this routine can also be run in a DOS 
% command window.
% For further help type: dos('...\gzip -h').
%_______________________________________________________________________
% vp_compress		C.4.6	P. Spetsieris	12/12/00
% 			Rev. 5.9 P. Spetsieris	3/26/08	

global HelpMode FMenu Message Ecolor Op herr

if HelpMode, vp_help(mfilename), return ; end;

IdentGroup=0;
DefMode=0;
out1=0;
Op='f';
Message=[];
Bcolor=[0.8 .8 .8];

set(FMenu,'Pointer','Watch');

compressgui = figure('Color',[0.9 .8 .8],'Name','Compress','Tag','compressgui',...
'NumberTitle','off','Position',[100,200,350,75],'UserData',0,...
'Units','Pixels');
	
pcbnames=['NameLst = get_file(Inf,''*'',''Select Files '',[]);',...
	  'if ~isempty(NameLst),',...
	  'set(herr,''string'',['' '',NameLst(1,:) '',...'' ]);',...
	  'IdentGroup=1; end;'];
	
uicontrol(compressgui,'string', 'SELECT FILES',...
	'TooltipString','Pick Files to Compress/Decompress',...
	'position',[10 50 100 20],'BackgroundColor',Bcolor,'callback',pcbnames);
	
cbModemenu = ['val=get(hModemenu,''Value''); if val==2, Op=''f''; ',...
	'elseif val == 3, Op=''d''; ',...
	'end; if(val ~=1), DefMode=1;',...
	'Message=[''Mode: '' Op ''   (f=Compress, d=Decompress)''];',...
	'set(herr,''string'',Message); else, end; '];

hModemenu=uicontrol(compressgui,'Style','popup','Visible','on',...
	'position',[112 50 128 20],'BackgroundColor',Bcolor,...
	'TooltipString','Select Mode',...
	'String',...
	['Conversion Mode...|Compress| Decompress '],...
	'Tag','ModeMenu',...
    	'callback',cbModemenu);

uicontrol(compressgui,'string', 'Help',...
	'TooltipString','Help displayed in MATLAB window',...
	'BackgroundColor',Ecolor,...
	'callback',['help vp_compress;',...
	'set(herr,''string'',['' '',''Help displayed in MATLAB window'']);'],...
	'position',[280 50 60 20]);
	
%	'if FName(2)=='':'', FName=FName(3:length(FName)), FName=strrep(FName,''\'',''/''), end ;'
%	'k=size(dir,2); if strcmp(dir(k),''\''), dir(k)='''', end;',...
%	'unixcmd=[''cd '',dir,''; gzip -'' Op '' '' FName], [status,Message]=dos(unixcmd); ',...
%
uicontrol(compressgui,'String','PROCESS',...
	'TooltipString','Initiate Processing.',...
	'Position',[10 25 65 20],...
	'CallBack',[ 'if ~IdentGroup, set(herr,''string'',''ERR: Files Not Defined''); return; end; ',...
	'if ~DefMode, set(herr,''string'',''ERR: Mode Not Defined''); return; end; ',...
	'curdir=pwd;',...
	'm=size(NameLst,1);',...
	'for i=1:m, FName=deblank(NameLst(i,:));',...
	'[nm,dnm,dir,nm,sfx]=vp_nm(''nm'',FName); FName=[nm,''.'',sfx],',...
	'eval([''cd '',dir]); ',...
	'doscmd=[''gzip -'' Op '' '' FName], s=dos(doscmd); if(s ~= 0), [status,Message]=vp_dos(doscmd); end; ',...
	'if isempty(Message), Message=[FName '' - Done''], end;',...
	'set(herr,''string'',['' '',Message]); pause(2);',...
	' end; eval([''cd '', curdir]); set(FMenu,''Pointer'',''Arrow'')';] );
	
uicontrol(compressgui,'String','QUIT',...
	'TooltipString','Quit and exit.',...
	'Position',[180 25 60 20],...
	'CallBack',['delete(compressgui);',...
	'set(FMenu,''Pointer'',''Arrow'')';] );

herr = uicontrol(compressgui,'string', [' ',Message],...
	'TooltipString','Report error or message field',...
	'position',[10 0 335 20],...
	'CallBack',['set(herr,''string'',['' '',Message]);'],...
	'BackgroundColor',Ecolor);


