% vp_cvtunix (function)
% Convert ANALYZE images from Unix <> Dos
% Promts for a series of Analyze format images and converts 
% their headers from sun (UNIX) to PC-NT (DOS) format and vice-versa.
% If data pixels have greater than 8bits per pixel,
% the corresponding data file will also be converted.
% Nifti files are directed to the NIFTI to ANALYZE routine.
% 
%
% FORMAT vp_cvtunix
%_______________________________________________________________________
% vp_cvtunix calls vp_unixcvt.dll to convert values stored in each ANALYZE
% header and image by swapping bytes. The resulting file(s) are rewritten
% and overwrite previous versions. The names of the files are not
% changed. To restore the original, convert back using the same routine.
%_______________________________________________________________________
% vp_unixhdt.m  	1.0 Phoebe Spetsieris  Mar. 6, 1998
% vp_cvtunix		C.4.7 Sept. 2001
%			Rev. 5.8.5	Mar. 6, 2008	

function vp_cvtunix

global HelpMode FMenu NameLst
global HDRTYPE % NIFTI or ANALYZE

if HelpMode, vp_help(mfilename), return ; end;

%-Select image headers
%----------------------------------------------------------------------------
%P = get_file(Inf,'.hdr','Select UNIX or DOS image headers to be converted');

if vp_filesui(Inf,'.hdr','Select UNIX or DOS image headers to be converted',mfilename) < 0,
return; end;

m=size(NameLst,1);

set(FMenu,'Pointer','Watch');
h=waitbar(0,'Processing Header Files ...');

for i=1:m
  	waitbar((i-.8)/m,h);
	filename = deblank(NameLst(i,:));
	vp_note(['Processing ',filename]);
	vp_hread(filename);
	if strcmp(HDRTYPE,'NIFTI'), vp_cvtNIF2ANA('convert',filename);
	else
	  ret = vp_unixcvt(filename);
	end;
	
% unix(['unixcvt ',filename]);
end

set(FMenu,'Pointer','Arrow');
waitbar(1,h); pause(1); close(h);

vp_note('UNIX <-> DOS Conversion Completed',3);

