function out1 = vp_dispfile(fname)
%_______________________________________________________________________
% function vp_dispfile.m		C.4.6 Phoebe Spetsieris  Jan. 5, 2001
%
% read a text file and display it in a matlab window	
%_______________________________________________________________________
% rev. ScAnVP ver. 5.8 Jan. 16, 2007


global HelpMode Message SSize

if HelpMode, vp_help(mfilename), return ; end;

Message='MSG: ...';

txcolor=[0.6 0.2 0.5];

out1=0;

fp = fopen(fname,'rt');
if fp <= 0, vp_message(['READ File: fopen error']); out1=fp; return; end;
  
no=0;
dumpstr=fgetl(fp);
maxlen=length(dumpstr);
while isstr(dumpstr),
  no=no + 1;,
  dumpstr=fgetl(fp);
  len=length(dumpstr);
  maxlen=max(len,maxlen);
end;

if no==0,
	vp_message(['File: read error']); fclose(fp); out1=-1;
	return;
end;

fclose(fp);

out1=1; Message=['File read ' num2str(no) ' lines'],
  
dy=15;
  
delete(findobj('Name',fname));

%	'NumberTitle','off','Position',[25,50,740,dy*(1+no)]
%	'NumberTitle','off','Position',[25,max(0,SSize(4)-dy*(2+no)),maxlen*8+90,dy*no],...
%
yo=(SSize(4)-dy*(2+no)); hgt =dy*no;
if yo < 0, yo= 20; hgt=SSize(4) -20; end;
hfile = figure('Color','w','Name',fname,...
	'NumberTitle','off','Position',[25,yo,maxlen*8+50,hgt],...
	'Units','Pixels','Visible','on');
	
axis off;
	
%dy=1/(1+no);
dy=1/no;
pos=1.0-dy;

fp = fopen(fname,'rt');
if fp <= 0, vp_message(['READ File: fopen error']); out1=fp; return; end;
  
for i=1:no,
 textstr=fgetl(fp);
 %d=strrep(textstr,'	','        '); %tabs
 d = strrep(textstr,'\','\\');
 d = strrep(d,'|','I');
 d = strrep(d,'	','    '); %tabs
 textstr = strrep(d,'_','\_');
 disp(textstr);
 text(0.0,pos, textstr,...
	'FontName','Times','FontSize',8,...
	'VerticalAlignment','Middle',...
	'HorizontalAlignment','Left',...
	'Color',txcolor);
 pos=pos-dy;
end;
	
fclose(fp);


%   'Position',[550 7 80 20],
uicontrol(hfile,'String','RETURN',...
   'Position',[maxlen*6 7 80 20],...
   'CallBack',[' ',...
   'delete(gcf);']);
   
   
set(hfile,'Pointer','arrow');

drawnow;
    
	



