% ScAnVP Scan Analysis and Visualization Processor Ver. 7.0
% NSUH Functional Brain Imaging Laboratory, Center for Neurosciences, FIMR 
%
%                                  - ERROR LIST -
%
% CORRECTIONS 2016: 
% Orientation:	The new version allows of ScAnVP allows the user to specify
%       the input orientation of an image file on disk and automatically
%       flips to Neurological if necessary, for display purposes. Thus,
%       X, Y, Z displayed coordinates represent mm distance from the origin
%       and correspond to Talairach or MNI coordinates. If it is normalized   
%       and saved in the Radiological orientation and not specified as such
%       on the menu, X coordinates correspond to -X in the Talairach
%       coordinate system. Proper selection corrects for errors that previously
%       occured in routines that required X,Y coordinates in Talairach
%       space.
%
% Imview:
%       Plane "Out of Range" error fixed in dynamic display option of imview.
%
% GROUP ROI:
%       Fixed GROUP ROI, read error for cases where the ScAn Mid Time field
%       or global max was missing in newer reports.
%       Atlas Label file was corrected for containing two different sets of
%       regions labeled Frontal_Mid_Orb (L and R). One set was relabeled
%       Frontal_Med_Orb (L and R).
%
% Transparency:
%       Program gave an error when color range was modified.
%
% Directory:
%       The default browser directory was not reinstated after colorbar selection.
%
% Masks: 
%       Modified image processing mask creation routine to save 8bit masks
%       rather than integer.
%
% Helpwin:
%       Corrected for sporadic MATLAB crashes when the help window was invoked
%       by the user on some windows 7 systems. 
%
% ACTIVE LIST
%
% File Names: Some routines cannot find files if their directory address or
%		name contains space, periods or other special characters. Entering
%       one file at a time sometimes eliminates the problem.
%
% Menu Display: Some menu labels are displaced when the computer screen
%		dimentsions are small. Not all menus can be interactively resized.
%		Uicontrol buttons do not all have relative units needed for resizing.
%
% Memory use:   Some routines may not be optimized for memory usage.
%
% Browser:	The new browser (get_file.m) alphabetizes each selection set and the 
%		resulting order is not necessarily in the order picked unless performed 
%		in additive selections. The get_file routine still does not eliminate
%       double specifications of directories in some cases that need to be
%       determined.In addition, some programs might not exit cleanly if a
%		get_file operation is aborted.
%
%
% multiple tasks: 
%		. Some routines may interfere with each other if another 
%		routine is still active because of the use of common variables. 
%		Exit each routine once it has completed and is no longer needed
%		until this problem is addressed. (Notable with display routines.)
%
% Dimension Mismatch Error:
%       This error can occur if parameters are not initialized for a new
%       task. Press RESTART to clear commonly used variables.
%
% text:
%		. Parts of the axis cursor may be visible in the text placement window.
%		This can be corrected by moving another window on top momentarilly.
%		. Size change does not take effect till after the second placement.
%		Position of text may be displaced in a file saved in a different format
%		or in printout.
%
% Gismap:	
%		. Gismap smoothing creates some artifacts.
%
% ROI GIS Image. The vp_GISimg routine cannot handle one ROI with CONSTANT weight
%		  (must select TAPERED).
%
% Rois:
%		. The roi outline will not show up if it is exactly the same on top of a
%		previously created one on the same image and will render both invisible
%		creating erroneous statistical output.
%	
% Imview:
%		. If another graphics window is clicked while 'imview' is processing, images
%		are written on the clicked window instead of the intended.
%
% Statmap:
%		. Semi-range colormap routines do not label bar limits properly if 
%		no values are found within the 'statmap' routine threshold limits. 
%		Statistical bars do not smooth properly.
%
% Colorbars:
%		. Thresholding and normalization operations do not rescale any existing
%		colorbars on the display. Using the provided option the user should 
%		delete and replace bars after such operations have been performed.
%		The set colorbar button deletes any existing bars before placing
%		bars to avoid problems created by the MATLAB placement of bars on bars.
%
% Transparency:	
%		. Some controls such as thresholding and smoothing do not work properly
%		on images that display 3D data such as those produced by transparency.
%
%________________________________________________________________________________________
%	vp_errata.m  7.0                         P. Spetsieris,	Dec. 08, 2015


	vp_help('vp_errata');
