function out2=vp_filesui(nf,sfx,prompt,callfun,proc);
% FORMAT function out2=vp_filesui(nf,sfx,prompt,callfun,proc);
% creates a user interface to get nf filenames of type 'sfx',
% set the global NameLst, and provide help and cancel controls
% for the function 'callfun'.
% If proc==1, it initiates 'callfun' on exit; 
%___________________________________________________________________________
% vp_filesui.m	C.4.6	P. Spetsieris  Jan. 27, 2001

global Ecolor NameLst 
global HelpMode

if HelpMode,
  if nargin > 3, vp_help(callfun), else vp_help(mfilename), end;
return ; end;

NameLst=[];
out2=0;
if nargin < 5, proc=0; end;
if nargin < 4, callfun=[]; end;
if nargin < 3, prompt=['SELECT FILES']; end;
if nargin < 2, sfx='.*'; end;
if nargin < 1, nf=Inf; end;

if nargin> 3,
 namefun=[callfun(4:length(callfun)) 'get'];
else namefun='filesui'; end;
delete(findobj('Name',namefun));

wid=max(200,length(prompt)*8+30); 

hfiles = figure('Color','w','Name',namefun,...
'NumberTitle','off','Position',[100,200,wid,95],...
'UserData',{num2str(nf),sfx,prompt,callfun,'0'},...
'Units','Pixels') ;
	

%	'CallBack',['namefun=get(gcbf,''name'');',...
%	'callfun=[''vp_'' namefun], vp_help(callfun);']);
uicontrol(hfiles,'string', 'HELP',...
	'TooltipString','Help displayed in MATLAB window',...
	'BackgroundColor',Ecolor,...
	'position',[wid-50 70 40 20],...
	'CallBack',['ud=get(gcbf,''UserData'');',...
	'callfun=char(ud(4));, vp_help(callfun);']);

uicontrol(hfiles,'string', prompt,...
	'position',[10 40 wid-20 25],...
	'FontName','Times','FontSize',10,...
	'FontAngle','Italic','FontWeight','bold',...
	'callback',...
	['ud=get(gcbf,''UserData''); sfx=char(ud(2)); prompt=char(ud(3));',...
	'nf=str2num(char(ud(1)));',...
	'NameLst=get_file(nf,sfx,prompt,[]), if ~isempty(NameLst),',...
	'ud(5)={''1''}; set(gcbf,''UserData'',ud); end;',...
	]);
	
uicontrol(hfiles,'String','CANCEL',...
	'Position',[10 10 60 25],...
	'callback',...
	['ud=get(gcbf,''UserData'');',...
	'if str2num(char(ud(5)))==-1,delete(gcbf);',...
	'else, ud(5)={''-1''};',...
	'set(gcbf,''UserData'',ud); end;',...
	]);
	

waitfor(findobj('Name',namefun),'UserData');
 
ud=get(findobj('Name',namefun),'UserData');
out2=str2num(char(ud(5)));

if proc==1
	eval(callfun);
end

delete(findobj('Name', namefun)); 

%uicontrol(hfiles,'String','PROCESS',...
%	'Position',[130 10 60 25],...
%	'CallBack',['if isempty(NameLst), vp_note(''Select Names'',2);',...
%	'else, namefun=get(gcbf,''name''),',...
%	'callfun=[''vp_'' namefun], eval(callfun);',...
%	'delete(findobj(''Name'', namefun)); end;']);
	
	
