% vp_fimage
% ScanVP Frame window image display 
%_______________________________________________________________________
% vp_fimage allows the user to display single slice scans in a subwindow
% of a previously defined variable size multi-subwindow display.
%_______________________________________________________________________
% vp_fimage		C.0	P. Spetsieris	5/20/98
% 			rev. 5.8 P.S. 1/5/07
% 			rev. 6.2 P.S. 4/27/12
% 			rev. 7.0 P.S. 10/8/15

% get the image's filename {FName} 
%-----------------------------------------------------------------------

global DATA DATAMIN DATAMAX PlaneNo FName FI
global DIM VOX SCALE TYPE OFFSET ORIGIN DESCRIP GLMAX GLMIN DESCRIP
global EXPTIM DURATION MATYPE Message XYZOR GENTIM SUBID EXPDATE
global VAL_OFFSET DisplayOrient InputOrient


if(isempty(FName))Message= 'Reference File Not Specified';, return, end;


vp_hread(FName);
 
XYZOR=ORIGIN;

XYZOR(1) = max(XYZOR(1), 1);
XYZOR(2) = max(XYZOR(2), 1);
XYZOR(3) = max(XYZOR(3), 1);

P=FName;
P=P(P ~=' '),
q     = length(P);
if P(q - 3) == '.'; P = P(1:(q - 4)); end
FName=P;

FNimg = [FName '.img'];
[fid,Message] = fopen(FNimg,'r');
if (fid ~= -1 )

	if WndScl == 1 ; WndMax = 9; end;
	if WndScl == 2 ; WndMax = 4; end;
	if WndScl == 4 ; WndMax = 1; end;

	WinView=1;	% Axial

	if WndNo > WndMax,
	Message= 'Window No Exceeds Limit', return, end;

	ImageSize=DIM(1)*DIM(2)*vp_roifuns('bytes',MATYPE) ;

	DATA=zeros(DIM(1),DIM(2));
 
	if(PlaneNo > DIM(3) | PlaneNo <= 0),
	 Message = 'Plane Out of Bounds',
		return;
	end;
  	fseek(fid,ImageSize*(PlaneNo-1),'bof');

	figure(FI);
	set(FI,'Tag','image');
	set(FI,'Name',FName);
	
	%DATA	= fread(fid,[DIM(1),DIM(2)],'uchar');
	DATA	= fread(fid,[DIM(1),DIM(2)],MATYPE);
	
	DATA = SCALE*DATA';
    if (DisplayOrient~=InputOrient)
        DATA = fliplr(DATA); end;
	if VAL_OFFSET ~=0, DATA=DATA+VAL_OFFSET; end; 

	DATAMAX=max(max(DATA)),
	DATAMIN=min(min(DATA)),
	
	%DATA=flipud(DATA);

	if WndNo==0,
		if WndScl == 1, axes(AxI01), 
		elseif WndScl == 2, axes(AxI02), 
		elseif WndScl == 4, axes(AxI04), end; % if WndScl	
	else
		if WndScl == 1, axes(AxI1(WndNo)) ;
		else if WndScl == 2, axes(AxI2(WndNo)) ; 
		elseif WndScl == 4, axes(AxI04), WndNo=0, end; end % if WndScl	
	end	
		
	%imh=image(DATA);
	%imh=imagesc(DATA,[0 GLMAX]);
	if (DATAMIN==DATAMAX),
	  if ( DATAMIN==0),
	    %vp_message(['WARNING: ZERO DATA Plane:',num2str(PlaneNo)]);
	    %pause(2);
	    vp_note(['WARNING: ZERO DATA Plane:',num2str(PlaneNo)],2);
	  else,
	    vp_note(['WARNING: DATAMIN = DATAMAX = ',num2str(DATAMIN),', Plane:',num2str(PlaneNo)],2);
	  end
	  figure(FI);
	  imh=image(DATA);
	  Message=[];
	 
	else
	 imh=imagesc(DATA,[DATAMIN DATAMAX]);
	end;
	
	%axis off image
	axis off image xy
	
	%Correct for aspect ratio
	vp_aspect(WinView,VOX);
		
	set(gca,'UserData',[WinView PlaneNo VOX XYZOR]);
	
	PlaneNoStr=num2str(PlaneNo);
	%thdl=text(i+.5,j+1,PlaneNoStr,'Color',[1.0 1.0 1.0]);
	thdl=text(1,DIM(2)-1,PlaneNoStr,'Color',[1.0 1.0 1.0]);
	
	%colorbar vert ;
	drawnow;
	if(WndNo ~= 0),WndNo = WndNo+1; end;
	if(WndNo > WndMax)WndNo = 1; end;
	if(PlaneNo < DIM(3))PlaneNo = PlaneNo + 1;
	else Message = 'Maximum Plane Reached',
	end;
	
	fclose(fid);
else
	Message
	vp_message(Message);
end

%   fprintf('\n\n> '); 

