% vp_fixorigins
% Reset ScAnVP Header Voxel Origins
%_______________________________________________________________________
% The user selects a number of files and the header information for
% the origin X Y Z Voxel coordinates is reset from key in values.
% It is assumed that all files have been previously coregistered.
%_______________________________________________________________________
% vp_fixorigins		C.4.7.8	P. Spetsieris	11/4/02

global HelpMode FMenu Message Ecolor

if HelpMode, vp_help(mfilename),  return ; end;

IdentGroup=0;
IdentOrigin=0;
out1=0;
Message=['MSG:.................'];
Bcolor=[0.8 .8 .9];

set(FMenu,'Pointer','Watch');

fixoriginsgui = figure('Color',[0.9 .8 .8],'Name','Fix origins','Tag','fixoriginsgui',...
'NumberTitle','off','Position',[100,200,260,75],'UserData',0,...
'Units','Pixels');
	
uicontrol(fixoriginsgui,'style','text','string','SET ORIGIN: ',...
	'position',[112 48 70 20],'BackgroundColor',[0.9 .8 .8],...
	'ToolTipString',['X Y Z Origin Voxel Coordinates']);

cboreset=['ss=get(gco,''string''); [Coords num]= sscanf(ss, ''%d'');',...
	 ' if num==3,Origin=Coords'', Message=''Origin Read''; IdentOrigin=1;',...
	 ' else, vp_message(''Ivalid Entry'');  end;  ',...
	 ' set(herr,''string'',['' '',Message]);  '];
	 
uicontrol(fixoriginsgui,'style','edit','string',['1 1 1'],...
	'position',[182 50 68 20],'BackgroundColor',Bcolor,...
	'ToolTipString',['X Y Z Origin Voxel Coordinates'],...
	'CallBack', cboreset );
	
pcbnames=['NameLst = get_file(Inf,''.img'',''Select Images '',[]);',...
	  'if ~isempty(NameLst),',...
	  'IdentGroup=1; end;'];
	
uicontrol(fixoriginsgui,'string', 'SELECT IMAGES',...
	'TooltipString','Pick Images ',...
	'position',[10 50 100 20],'callback',pcbnames);
	

uicontrol(fixoriginsgui,'String','PROCESS',...
	'TooltipString','Initiate Processing.',...
	'Position',[10 25 65 20],...
	'CallBack',[ 'if ~IdentGroup, set(herr,''string'',''ERR: Images Not Defined''); return; end; ',...
	'if ~IdentOrigin, set(herr,''string'',''ERR: Origin Not Defined''); return; end; ',...
	'out1=vp_fixoriginspro(NameLst,Origin);',...
	'if out1<0, set(herr,''string'',['' '',Message]); pause(2); ',...
	'else, set(herr,''string'',[''Files Processed'']); pause(2); end;',...
	'set(FMenu,''Pointer'',''Arrow'')';] );
	
uicontrol(fixoriginsgui,'string', 'HELP',...
	'TooltipString','Help displayed in MATLAB window',...
	'BackgroundColor',Ecolor,...
	'position',[110 25 50 20],'callback','vp_help(''vp_fixorigins'');');
	
uicontrol(fixoriginsgui,'String','QUIT',...
	'TooltipString','Quit and exit.',...
	'Position',[190 25 60 20],...
	'CallBack',['delete(fixoriginsgui);',...
	'set(FMenu,''Pointer'',''Arrow'')';] );

herr = uicontrol(fixoriginsgui,'string', [' ',Message],...
	'TooltipString','Report error or message field',...
	'position',[10 0 240 20],...
	'CallBack',['set(herr,''string'',['' '',Message]);'],...
	'BackgroundColor',Ecolor);


