% vp_fixtimes
% Save/Reset ScAnVP Header Time Information
%_______________________________________________________________________
% The user selects a number of files and the ANALYZE header information
% for the time parameters listed below is either saved in a file or reset
% from a file. These operations can help set or restore time data that is
% used by ScAnVP routines that may be missing or corrupted by operations
% using other image processing packages.
%
% EXPTIM:	Relative frame start time HR:MN:SC
% DURATION:	Scan duration in seconds
% GENTIM:	Actual Frame Start Time HR:MN:SC
% EXPDATE:	Date of experiment YrMoDa
%
% OP:
%  S=Save
%  R=Reset
%_______________________________________________________________________
% vp_fixtimes		C.4.6	P. Spetsieris	3/21/01

global HelpMode FMenu Message Ecolor Op

if HelpMode, vp_help(mfilename),  return ; end;

IdentGroup=0;
DefOp=0;
out1=0;
Op='S';
OpS='Save';
Message=['MSG:.................'];
Bcolor=[0.8 .8 .9];

set(FMenu,'Pointer','Watch');

fixtimesgui = figure('Color',[0.9 .8 .8],'Name','Fix Times','Tag','fixtimesgui',...
'NumberTitle','off','Position',[100,200,250,75],'UserData',0,...
'Units','Pixels');
	
cbtimesmenu = ['val=get(htimesmenu,''Value''); if val==2, Op=''S''; OpS=''Save''; ',...
	'elseif val == 3, Op=''R''; OpS=''Reset'';',...
	'end; if(val ~=1), DefOp=1;',...
	'Message=[''Header Operation: '' OpS];',...
	'set(herr,''string'',Message); else, end; '];

htimesmenu=uicontrol(fixtimesgui,'Style','popup','Visible','on',...
	'position',[112 50 128 20],'BackgroundColor',Bcolor,...
	'TooltipString','Select Time Header Operation',...
	'String',...
	['Time Data Operation...|Save in File |Reset from File '],...
	'Tag','TimesMenu',...
    	'callback',cbtimesmenu);

pcbnames=['NameLst = get_file(Inf,''.img'',''Select Images '',[]);',...
	  'if ~isempty(NameLst),',...
	  'IdentGroup=1; end;'];
	
uicontrol(fixtimesgui,'string', 'SELECT IMAGES',...
	'TooltipString','Pick Images ',...
	'position',[10 50 100 20],'callback',pcbnames);
	

uicontrol(fixtimesgui,'String','PROCESS',...
	'TooltipString','Initiate Processing.',...
	'Position',[10 25 65 20],...
	'CallBack',[ 'if ~IdentGroup, set(herr,''string'',''ERR: Images Not Defined''); return; end; ',...
	'if ~DefOp, set(herr,''string'',''ERR: Operation Not Defined''); return; end; ',...
	'out1=vp_fixtimespro(NameLst,Op);',...
	'if out1<0, set(herr,''string'',['' '',Message]); pause(2); ',...
	'else, set(herr,''string'',[''Files Processed'']); pause(2); end;',...
	'set(FMenu,''Pointer'',''Arrow'')';] );
	
uicontrol(fixtimesgui,'string', 'HELP',...
	'TooltipString','Help displayed in MATLAB window',...
	'BackgroundColor',Ecolor,...
	'position',[100 25 50 20],'callback','vp_help(''vp_fixtimes'');');
	
uicontrol(fixtimesgui,'String','QUIT',...
	'TooltipString','Quit and exit.',...
	'Position',[180 25 60 20],...
	'CallBack',['delete(fixtimesgui);',...
	'set(FMenu,''Pointer'',''Arrow'')';] );

herr = uicontrol(fixtimesgui,'string', [' ',Message],...
	'TooltipString','Report error or message field',...
	'position',[10 0 230 20],...
	'CallBack',['set(herr,''string'',['' '',Message]);'],...
	'BackgroundColor',Ecolor);


