% function out1=vp_fixtimespro(namelst, op)
% Save/Restore ScAnVP ANALYZE header time parameters.
%_______________________________________________________________________
%
% op:
%  S=Save Time Parameters in File
%  R=Restore Time Parameters from File
%
% out1:  Return status
%_______________________________________________________________________
% vp_fixtimespro		C.4.6	P. Spetsieris	3/21/01

function out1=vp_fixtimespro(namelst, op)

global DIM VOX SCALE TYPE OFFSET ORIGIN DESCRIP GLMAX GLMIN
global EXPTIM DURATION MATYPE Message GENTIM SUBID EXPDATE
global HelpMode

if HelpMode, vp_help(mfilename), return ; end;

out1=0;

m= size(namelst,1);

op,

	
for i=1:m

  	FName=deblank(namelst(i,:));
  	%P=strtok(FName,'.');
	P=vp_nm('dnm',FName);
	
	vp_hread([P '.hdr']);
	
        if i==1,
	  if strcmp(op,'S'),
		q=max([find(P=='\') 0]);
		filnm=[P(1:q) 'TimeDat.txt']
		out1 = fopen(filnm,'wt');
	  	if out1 <= 0, vp_message(['fopen error']); return; end;
		fp=out1;
		fprintf(fp,'%s\n',['EXPTIM  DURATION  GENTIM  EXPDATE (',P,'...)']);
		fprintf(fp,'%s %d\n','NFiles: ',m);
		fprintf(fp,'\n');
		
		
	  elseif strcmp(op,'R') 
		filnm = get_file(1,'.txt','Select Time Data File ',[]);
		out1 = fopen(filnm,'rt');  fp=out1;
	  	if out1 <= 0, Message=['fopen error'], return; end;
		
  		dumpstr=fscanf(fp,'%s',1);
 		while(~strcmp(dumpstr,'NFiles:')),dumpstr=fscanf(fp,'%s',1);
	  	  if isempty(dumpstr), 
  			vp_message(['Time Data File: read error']); close(fp); out1=-1;
			break;
	          end;
  		end;
  		if out1 < 0, return, end;
  		nfiles=fscanf(fp,'%d',1); 
  		if isempty(nfiles),
  			vp_message(['Time Data File: read NFiles error']); close(fp); out1=-1;
		return; end;
  		if nfiles < m,
  			vp_message(['Time Data File: Not enough data!']); close(fp); out1=-1;
		return; end;
  
	  end

	end
  
 
	if strcmp(op,'S'),
		EXPTIM, GENTIM, DURATION, EXPDATE,
		if isempty(str2num(EXPTIM(1))), EXPTIM='00:00:00'; end;
		if isempty(str2num(GENTIM(1))), GENTIM='00:00:00'; end;
		if isempty(DURATION), DURATION=0; end;
		if isempty(str2num(EXPDATE(1))), EXPDATE='0000000000'; end;
		fprintf(fp,'%s %d %s %s\n',EXPTIM,DURATION,GENTIM,EXPDATE);
	
	elseif strcmp(op,'R') 
		EXPTIM=fscanf(fp,'%s',1),
		DURATION=str2num(fscanf(fp,'%s',1)),
		GENTIM=fscanf(fp,'%s',1),
		EXPDATE=BLANKS(10);
		date=fscanf(fp,'%s',1),
		len=length(date);
		EXPDATE(1:len)=date(1:len);
		
		vp_hwrite(FName,DIM,VOX,SCALE,TYPE,OFFSET,ORIGIN,DESCRIP,...
		EXPTIM,DURATION,GENTIM,SUBID,EXPDATE,GLMAX,GLMIN);

	end;

end 


if m > 0, fclose(fp); end;

if strcmp(op,'S') 
	vp_dispfile(filnm);
elseif strcmp(op,'R') 
	vp_message('Time Data Restored');
end

