function [out1, Message]=vp_gisfun(action,in1,in2,in3)
%_______________________________________________________________________
% vp_gisfun.m  		C.4.6 Phoebe Spetsieris  Jun. 15, 2000
%
% GIS image functions
% Opens and closes files,
% Reads GIS files
% calls write routines and saves data
%
% FORNAT function [out1, Message]=vp_gisfun(action,in1,in2,in3)

global Message
global GisOri GisLab GisWeight

out1=0;
Message=['...........................'];

if strcmp(action,'readgis') 
  fp = fopen(in1,'rt');
  if fp <= 0, vp_message(['READ GIS File: fopen error']); out1=fp; return; end;
  
  GisOri=[]; GisLab=[]; GisWeight=[];
  dumpstr=fscanf(fp,'%s',1);
  while(~strcmp(dumpstr,'NRois:')),dumpstr=fscanf(fp,'%s',1);
	  if isempty(dumpstr), 
  		vp_message(['GIS File: read NRois error']); close(fp); out1=-1;
		break;
	  end;
  end;
  if out1 < 0, return, end;
  nrs=fscanf(fp,'%d',1); 
  if isempty(nrs),
  	vp_message(['GIS File: read NRois error']); close(fp); out1=-1;
  return; end;
  %GisLab=strvcat(blanks(40),blanks(40));
  for i=1:nrs
  	dumpstr=fscanf(fp,'%s',1);
	if (~strcmp(dumpstr,'R') & ~strcmp(dumpstr,'L') & ~strcmp(dumpstr,'C'))
		GisOri(i,:)='C'; labname=dumpstr ; 
		
	else GisOri(i,:)=dumpstr; labname=[]; end;
	
	dumpnum=[];
	while isempty(dumpnum)
  	  dumpstr=fscanf(fp,'%s',1);
	  if isempty(dumpstr), 
  		vp_message(['READ GIS File: read error']); close(fp); out1=-1;
	  return; end;
	  dumpnum=str2num(dumpstr);
	  if isempty(dumpnum),
		labname=[labname ' ' dumpstr];
	  end;
	end;
	GisWeight(i)=dumpnum; len=length(labname);
	while isspace(labname(1)), labname= [labname(2:len) blanks(1)]; end;
	labname=[labname blanks(40-len)];
	if (i==1), GisLab(i,:)=labname; else GisLab = strvcat(GisLab,labname); end;
		
  end
  
  GisOri=char(GisOri); GisLab; GisWeight;
  
  
  fclose(fp);
  out1=1; Message=['GIS File read'];
  
elseif strcmp(action,'opengis') 
	q=max([find(in1=='.') 0]);
	gisimg=[in1(1:q-1) 'gisroi.img'];
	out1 = fopen(gisimg,'wb');
	Message=gisimg;
	if out1 <=0, vp_message(['GIS OUTPUT IMAGE: fopen error']); return; end;
	
elseif strcmp(action,'opengmap') 
	q=max([find(in1=='.') 0]);
	gismap=[in1(1:q-1) 'gmap.img'];
	out1 = fopen(gismap,'wb');
	Message=gismap;
	if out1 <=0, vp_message(['GISMAP OUTPUT IMAGE: fopen error']); return; end;
	
elseif strcmp(action,'closegis') 
  	fclose(in1);
	%q=max([find(in2=='.') 0]);
	%out1=[in2(1:q-1) 'gis.hdr'];
  
elseif strcmp(action,'wzeros') 
	dat=zeros(in2(1),in2(2),in3);
  	out1=fwrite(in1,dat,'double');
  	if out1 <=0,
  	   vp_message(['gisimg write ERROR no: ' num2str(out1) ' pixels']);
	return; end;
   
elseif strcmp(action,'close') 
	out1 = fclose(in1) ;
	if out1 ~= 0, vp_message(['gisfun: fclose error']); return; end;
	
    
end
