% vp_gmask.m
% Create Region of interest mask gui interface
%___________________________________________________________________________
% vp_gmask.m	ScAnVP Ver. C.0	P. Spetsieris  Jan. 11, 1999
%                      Rev. 7.0 P. Spetsieris  Jan. 19, 2016

global RoiNo RoiTyp RegDef RoiChoice RoiThresh FI DATA WTotal NRTotal
global Ecolor FI

Message0=['............................................ '];
Message=Message0;
WTotal=0;
NRTotal=0;

RoiFName=[];

RoiChoice=1;

maskgui = figure('Color','w','Name','maskgui',...
'NumberTitle','off','Position',[100,200,250,120],...
'Units','Pixels');
	
bkgcolor = [.8,.8,1];
RoiTyp='r';

RegDef0 =[0 50 50 10 10 0] ;
RegDef = RegDef0;

RoiNo=0;
RoiThresh=100;

Fid=vp_savmask('open',FName);

%cbRoiFName=['RoiFName=get(hname,''string'');'];
cbRoiFName=['RoiFName=get(hname,''string'');','Message=Message0 ;',...
	'set(herror,''string'',[''MSG: '',Message]);'] ;
	
cbPRoiName=['RoiFName=get_file(1,''.dat'',''please select roi file'',[]); ',...
	'if ~isempty(RoiFName),',...
	'set(hname,''string'',RoiFName); ','Message=Message0 ;',...
	'set(herror,''string'',[''MSG: '',Message]); end;'] ;
	

cbroi=['RoiTyp=get(hroi,''string''); ',...
	['if(RoiTyp ~= ''r'') & (RoiTyp ~= ''e'') & (RoiTyp ~= ''i'')Message=''Invalid Roi Type'';',...
	'else Message=Message0; end; '],...
		'set(herror,''string'',[''MSG:'',Message]);, vp_maskcb(RoiTyp);'];

cbRoiMenu = ['RoiChoice=get(hroimenu,''Value'');';];

	
uicontrol(maskgui,'string', 'RECT',...
	'position',[10 90 70 25],'BackgroundColor',bkgcolor, 'callback',...
	['RoiTyp=''r''; vp_maskcb(''r'');',...
	'Message=lasterr('''');, set(herror,''string'',[Message]);',...
	]);
	
%	['RoiTyp=''r''; figure(FI); set(FI,''ButtondownFcn'',''nrect=rbbox(1)'');, waitforbuttonpress;']);
uicontrol(maskgui,'string', 'ELLI','position',[80 90 70 25],...
	'BackgroundColor',bkgcolor, 'callback', 'RoiTyp=''e''; vp_maskcb(''e'');' );
	
uicontrol(maskgui,'string', 'IRR ',...
	'position',[150 90 70 25],'BackgroundColor',bkgcolor, 'callback',...
	['RoiTyp=''i''; vp_maskcb(''i'');'] );

hroi=uicontrol(maskgui,'style','edit','string',RoiTyp,'Tag','roied',...
	'position',[210 90 30 25],'BackgroundColor',bkgcolor,'callback',cbroi);

	
hroimenu=uicontrol(maskgui,'Style','popup','Visible','on','String','move|reshape|delete',...
	'Tag','RoiMenu',...
    	'Position',[170 22 72 60],'callback',cbRoiMenu);

hnxtpln=uicontrol(maskgui,'String',['SAVE / NEXT PLANE <',num2str(PlaneNo),'>'],...
	'Position',[10 60 130 25],'CallBack',...
	['vp_savmask(''save'',Fid);',...
	'RoiNo=0; vp_fimage; set(FI,''Tag'',''mask''); if isempty(Message), ',...
	'set(hnxtpln,''string'', [''NEXT PLANE <'',num2str(PlaneNo),''>'']);',...
	'set(hplane,''string'', num2str(PlaneNo)); ',...
	'else set(herror,''string'',[''Error: '',Message]);',...
	' end; '] );
%	'PlaneNo=PlaneNo+1; RoiNo=0; vp_fimage; if isempty(Message), ',
%	'CallBack',['set(maskgui,''UserData'',1)']);


cbplane=['PLNo=str2num(get(hplane,''string'')); ',...
	'if PLNo <= PlaneNo, vp_note(''Increase Plane No'',2);',...
	' set(hplane,''string'', num2str(PlaneNo)); ',...
	'else, PLNo=min(DIM(3),PLNo);',... 
	' vp_savmask(''skip'',Fid,(PLNo-PlaneNo+1));',...
	' PlaneNo=PLNo+1;',...
	' set(hplane,''string'', num2str(PlaneNo)); ',...
	' set(hnxtpln,''string'', [''NEXT PLANE <'',num2str(PlaneNo),''>'']);',...
	'end; ' ];

hplane=uicontrol(maskgui,'style','edit','string',PlaneNo,...
	'TooltipString','Key in Plane No.',...
	'position',[140 60 30 25],'callback',cbplane);

uicontrol(maskgui,'String','SAVE / CLOSE & QUIT',...
	'Position',[10 35 130 25],'CallBack',...
	['vp_savmask(''save'',Fid);',...
	'vp_savmask(''skip'',Fid,(DIM(3)-PlaneNo + 1));',...
	'vp_savmask(''close'',Fid, FName); ','delete(maskgui);','delete(FI);']);
	
uicontrol(maskgui,'String','ABORT',...
	'Position',[190 35 50 25],'CallBack',...
	['vp_savmask(''abort'',Fid, FName);',...
	'delete(maskgui);','delete(FI);']);
	
herror = uicontrol(maskgui,'string', ['MSG : ',Message],...
	'position',[10 10 230 25],...
	'CallBack',['set(herror,''string'',[''MSG: '',Message]);'],...
	'BackgroundColor',Ecolor);


