function [out1,out2,out3,out4] = vp_graphics(action, in1,in2,in3,in4,in5)
%_______________________________________________________________________
% vp_graphics.m  		C.0 Phoebe Spetsieris  Oct. 1998
%
% Graphics utilities
%_______________________________________________________________________

out1=0;

out2=0;

out3=0;

out4=[action, ' evaluated.'];

if strcmp(action,'dist') 
	out1=sqrt((in3-in1)^2 + (in4-in2)^2);
	
elseif strcmp(action,'elli') 
	x0=in1; y0=in2; xr=in3; yr=in4; r2=in5;
	[r1,dmp]=vp_graphics('dist',x0,y0,xr,yr,0);
	
	%if r1 <= 0, r1=1, end;
	%if r2 <= 0, r2=1, end;
	
	if r1 <= 0, out3=-1; out4=['invalid radius r1:' num2str(r1)]; return; end;
	if r2 <= 0, out3=-1; out4=['invalid radius r2:' num2str(r2)]; return; end;
	
	%x2 = x0 - (r2/r1)*(yr-y0) ;
	%y2 = y0 - (r2/r1)*(xr-x0) ;
	x2 = x0 + (r2/r1)*(yr-y0) ;
	y2 = y0 + (r2/r1)*(xr-x0) ;
	x1 = xr ;
	y1 = yr ;
	% rename
	if r1>r2
		yr = y2 ;
		xr = x2 ;
		x2 = x1 ;
		y2 = y1 ;
		r0=r1;
		r1=r2;
		r2=r0;
	end
	
	
	i=1;
	
	for xi=-r2:0.2:+r2
		x(i)=xi;
		y(i)=r1*sqrt(1-xi^2/r2^2);
		i=i+1;
	end;	
	for xi=r2:-0.2:-r2
		x(i)=xi;
		y(i)=-r1*sqrt(1-xi^2/r2^2);
		i=i+1;
	end;	
	
	if i <= 1, out3=-1; out4=['invalid outline points:' num2str(i)]; return; end;
	
	if ( x(i-1) ~= x(1) | y(i-1) ~= y(1) )
		x(i)=x(1); y(i)=y(1);
	end
	
	%theta=acos((y0-yr)/r1);
	theta=acos((yr-y0)/r1);
	atheta=theta*360/(2*pi) ;
	
%	if yr > y0 & xr < x0 theta = theta + pi/2;
%	elseif yr < y0 & xr < x0 theta = theta + pi;
%	elseif yr < y0 & xr >= x0 theta = theta + 3*pi/2;
%	end

	
        rotA=[cos(theta) -sin(theta); sin(theta) cos(theta)];
        elli = rotA*[x;y] ;
	
	
        out1=elli(1,:) + x0;
        out2=elli(2,:) + y0 ;
	
	if y1 < y0 
        	out2= 2*y0 - out2 ;
	end
	
elseif strcmp(action,'circ') 
	x0=in1; y0=in2; r2=in3;
	%if r2 <= 0, r2=1, end;
	if r2 <= 0, out3=-1; out4=['invalid radius r2:' num2str(r2)]; return; end;
	
	i=1;
	
	for xi=-r2:0.2:+r2
		x(i)=xi;
		y(i)=sqrt(r2^2 -xi^2);
		i=i+1;
	end;	
	
	%k=i-1;
	%if k>0
	%  for j=i+1:2*i-1
	%	x(j)=x(k);
	%	y(j)=-y(k);
	%	k=k-1;
	%  end
	%end
	
	
	for xi=r2:-0.2:-r2
		x(i)=xi;
		y(i)=-sqrt(r2^2 -xi^2);
		i=i+1;
	end;	
	
	if i > 1 
	  if ( x(i-1) ~= x(1) | y(i-1) ~= y(1) )
		x(i)=x(1); y(i)=y(1);
	  end
	else
	 out3=-1; out4=['invalid outline points:' num2str(i)]; return;
	end
	
	
        %elli=[x;y] ;
	
        %out1=elli(1,:) + x0;
        %out2=elli(2,:) + y0 ;
	
        out1= x + x0;
        out2= y + y0;
	
	
end	



