% vp_groupro.m
% Group Region of Interest Processing
%
% This routine handles processing for the vp_grouproi routine.
%___________________________________________________________________________
% vp_groupro.m	C.0 	P. Spetsieris	 Mar. 29, 1999
%		Rev. 5.2	P.S.	Sept. 25, 2003
%          	Rev. 5.8	P.S.	Feb. 22, 2007
%          	Rev. 5.9.1	P.S.	May 14, 2008
%          	Rev. 6.0	P.S.	Nov. 20, 2008
%          	Rev. 6.2	P.S.	Apr. 27, 2012
%          	Rev. 6.4	P.S.	Jan. 13, 2015
%          	Rev. 7.0	P.S.	Oct. 19, 2015

global RoiNo RoiTyp RegDef RoiThresh RoiChoice FI Lh
global ActRoi ActHand LabIds LabNames Picking herror herr roigui
global FName FNames RoiFName RoiFNames PlaneNo1 PlaneNo2 PlaneNo
global sasfid1 sasfid2 SASRpt SAS_cRpt TemplRpt PlaneRpt SUMRpt CompRpt
global Means PlanarMeans MockTime CheckRois Automatic GOsignal
global NonStdLabs NonStdNo NonStdLabStr hmode hcont hrpt hmapon hgmnmx
global ThreshTime ThreshMode FixedThresh Thresholds MinMaxs Ecolor
global DIM VOX SCALE TYPE OFFSET ORIGIN DESCRIP GLMAX GLMIN DESCRIP
global EXPTIM DURATION GMIN GMAX FixedThMin VAL_OFFSET
global GNop GNStr MaskOpt MaskImg MaskStr Keyin
global AtlasNm AtlasDIM TemplateOpt AVolXYZ ALabNames LabAIds

Message0=['............................................ '];
Message=Message0;

MockTime=0;
Means=[]; PlanarMeans=[]; CheckRois=[]; 

sasfid1=0; sasfid2=0;
sumfid1=0; sumfid2=0; sumnfid2=0;

RoiChoice=1;
NameConvention=2;

%Local for each plane
LabNames=str2mat(blanks(40),blanks(40));
LabIds=str2mat(blanks(4),blanks(4)); 
ALabNames=[]; AVolXYZ=[]; LabAIds=[];

%Global
NonStdLabs=str2mat('Non Standard Label                      ');
NonStdLabStr=['Non Standard Label                      '];
NonStdNo=101;

nnms=size(FNames);
if TemplateOpt == 4  % ATLAS
 nplns=AtlasDIM(3);
 PlaneNo1=1; PlaneNo2=nplns;
 planestr=num2str([PlaneNo1,PlaneNo2]),
 vp_keyin('Enter Planar Range [Plane1, Plane2] | q',planestr);
 if (isempty(Keyin) | strcmp(Keyin,'q') | strcmp(Keyin,'quit')), return,
 else planes=str2num(Keyin); PlaneNo1=planes(1); PlaneNo2=planes(2); 
	if (PlaneNo2 > nplns) vp_message('Plane exceeds limit'); return;  end;
	if (PlaneNo1 < 1 ) vp_message('Plane entry error'); return; end; 
	if (PlaneNo1 > PlaneNo2 ) vp_message('Plane entry error'); return; end;  
 end;

 RoiTyp='v'; % voxel
 RoiFName=AtlasNm;
 NameConvention=3;

else  %Not Atlas
 nplns=size(RoiFNames);
 RoiFName=RoiFNames(1,:);
  
 [dnm,dnm,dir,nam,sfx]=vp_nm('dnm',RoiFNames(1,:));
 [roif,pln]=strtok(nam,'.');
 if isempty(pln), NameConvention=1; q=max([find(isletter(roif)==1) 0]); 
	sz=size(roif); plane1=str2num(roif(q+1:sz(2))) ; roif=roif(1:q);
 else, plane1=str2num(pln(2:length(pln))); end;
 if nplns(1) == 1
   plane2=plane1;
 else
  [dnm,dnm,dir,nam,sfx]=vp_nm('dnm',RoiFNames(2,:));
  [roif,pln]=strtok(nam,'.');
  if isempty(pln), NameConvention=1; q=max([find(isletter(roif)==1) 0]); 
  	sz=size(roif); plane2=str2num(roif(q+1:sz(2))) ; roif=roif(1:q);
	if NameConvention ~=1,
 		set(herror,'string','Inconsistent Second Roi Name');
	return, end;
  else, plane2=str2num(pln(2:length(pln))); end;
 end;
 roif=[dir,roif];
	

  PlaneNo1=min(plane1,plane2);
  PlaneNo2=max(plane1,plane2);
  RoiTyp='r';

end  % End Not Atlas

Bcolor = [.8,.8,.8];
Kcolor = [.8,1,1];
Fcolor = [.8,.8,1];

grprogui = figure('Color',Fcolor,'Name','grprogui',...
   'NumberTitle','off','Position',[100,370,400,220],...
   'Pointer','watch',...
   'Units','Pixels');
	
RoiThresh=100;

RegDef0 =[0 50 50 10 10 0] ;
RegDef = RegDef0;

RoiNo=0; ActRoi=0;

cbFName=['set(hnm,''string'',FName)'];

cbmode=['if Automatic, modestr=''SET AUTOMATIC OFF''; onoff=''off''; GOsignal=1; Picking=''OFF'';',...
'else modestr=''SET INTERACTIVE OFF'' ; onoff=''on''; GOsignal=0; Picking=''ON''; end; '];

eval(cbmode);


hpnm=uicontrol(grprogui,'style','text','string', 'FNAME :',...
	'position',[10 200 45 15],'BackgroundColor',Fcolor,...
	'callback',cbFName);
	

hnm=uicontrol(grprogui,'style','text','string', [FName],...
	'position',[55 200 315 15],'BackgroundColor',Fcolor,...
	'callback',cbFName);
	
if (MaskOpt == 1)
  MaskStr=['MASK: ',vp_nm('nm',MaskImg)]; mskpos=[10 180 300 15];
else
  MaskStr='MASK OFF'; mskpos=[10 180 80 15];
end
hmnm=uicontrol(grprogui,'style','text','string', MaskStr,...
	'position',mskpos,'BackgroundColor',Fcolor);

if (GNop == 1)
 GNStr=	['GNormalization ON'];
else
 GNStr=	['GNormalization OFF'];
end

hgnorm=uicontrol(grprogui,'Style','Text','string',...
	GNStr,...
	'position',[200 165 135 15],...
	'TooltipString','Global Normaliziation ON/OFF',...
	'FontName','Times','FontSize',9,'FontAngle','normal',...
	'BackgroundColor',Fcolor);
	 
hgmnmx=uicontrol(grprogui,'Style','Text','string',...
	['Global Min,Max: (' sprintf('%.2f, ',GMIN) sprintf('%.2f',GMAX) ')'],...
	'position',[10 165 190 15],...
	'TooltipString','Global Data Minimum and Maximum',...
	'FontName','Times','FontSize',9,'FontAngle','normal',...
	'BackgroundColor',Fcolor);
	 
hmode=uicontrol(grprogui,'string', modestr,...
	'position',[160 90 128 25],'BackgroundColor',Bcolor,...
	'callback',['if Automatic, Automatic=0, else Automatic=1, end;',...
	'eval(cbmode); set(hcont,''Enable'',onoff);',...
	'set(hrpt,''Enable'',onoff); set(hmapon,''Enable'',onoff);',...
	'set(gco,''string'',modestr); set(hroimenu,''Enable'',onoff);']);

%cbRoiFName=['RoiFName=get(hname,''string'');'];
%cbRoiThresh=['set(gco,''string'',num2str(RoiThresh)'];

cbPlaneNo=['set(gco,''string'',num2str(PlaneNo)'];

cbRoiMenu = ['RoiChoice=get(hroimenu,''Value'');';];

cbPRoiName=['',...
	'set(hname,''string'',vp_nm(''nm'',RoiFName)); '];
	
uicontrol(grprogui,'style','text','string', 'TEMPLATE : ',...
	'position',[10 140 70 20],'BackgroundColor',Fcolor,...
	'callback',cbPRoiName);
	
hname=uicontrol(grprogui,'style','text','string',RoiFName,...
	'position',[80 140 280 20],'BackgroundColor',Fcolor,'callback',cbPRoiName);

uicontrol(grprogui,'style','text','string', 'PLANE No. :',...
	'position',[10 120 75 20],'BackgroundColor',Fcolor);
	
hpln=uicontrol(grprogui,'style','text','string',PlaneNo,...
	'position',[85 120 30 20],'BackgroundColor',Fcolor,'callback',cbPlaneNo);


thrshtxt=strvcat('VARIABLE %of 2D REG MAX','VARIABLE %of 3D REG MAX',...
['FIXED ', num2str(FixedThresh), '% of 2D REG MAX'],...
['FIXED ', num2str(FixedThresh), '% of 3D REG MAX'],...
['FIXED THRES. MIN : ', num2str(FixedThMin)]);

uicontrol(grprogui,'style','text','string', thrshtxt(ThreshMode,:),...
	'position',[130 120 150 20],'BackgroundColor',Fcolor);


%uicontrol(grprogui,'style','text','string', 'Thresh % :',...
%	'position',[160 120 50 25],'BackgroundColor',Bcolor);
%hthr=uicontrol(grprogui,'style','text','string',RoiThresh,...
%	'position',[210 120 30 25],'BackgroundColor',Bcolor,'callback',cbRoiThresh);


hcont=uicontrol(grprogui,'string', 'CONTINUE',...
	'Enable',onoff,...
	'position',[10 35 70 25],'BackgroundColor',Bcolor, 'callback',...
	['GOsignal=1;']);
	
%hroi=uicontrol(grprogui,'style','edit','string',RoiTyp,'Tag','roied',...
%	'position',[210 90 40 25],'Enable','off','BackgroundColor',Kcolor,'callback',cbroi);

hmapon=uicontrol(grprogui,'string', 'THRESHOLD PIXEL MAP',...
	'position',[10 65 150 25],'BackgroundColor',Bcolor,'Visible','on',...
	'Enable',onoff,...
	 'callback',...
	 ['vp_roimap(''display'',0)']);
	 
	 
%hroimenu=uicontrol(FI,'Style','popup','Visible','off','String','move|modify|stat|delete',
%	'move|reshape|statistics|map|relabel|rethresh|delete'
hroimenu=uicontrol(grprogui,'Style','popup','Visible','on','String',...
	'move|reshape|',...
	'Tag','RoiMenu',...
	'Enable',onoff,...
    	'Position',[205 25 82 60],'callback',cbRoiMenu);

hrpt=uicontrol(grprogui,'String','REPORT',...
	'Position',[10 90 60 25],...
	'Enable',onoff,...
	'CallBack',['set(gcbf,''Pointer'',''watch'');',...
	'vp_roidrpt; set(gcbf,''Pointer'',''arrow'');',...
	'set(herror,''string'',['' '',Message]);']);

%hsaver=uicontrol(grprogui,'string','RESTART',...
%	'position',[90 35 75 25],'BackgroundColor',Bcolor,'Visible','on',...
%	'Enable','on',...
%	 'Callback',...
%	 ['set(findobj(''Name'',''GROUP ROIgui''),''Visible'',''on''); ',...
%	  'delete(grprogui);']);
	
%	 'vp_grouprpt(''savexit''); ',...
%	 'set(herror,''string'',['' '',Message]);']);
	
uicontrol(grprogui,'String','QUIT',...
	'Position',[227 35 60 25],...
	'CallBack',['GOSignal=1;',...
  	'delete(findobj(''Name'',''REPORT''));',...
  	'delete(findobj(''Name'',''Threshold MAP''));',...
  	'delete(findobj(''Name'',''Statistics''));',...
  	'delete(findobj(''Name'',''LABELgui''));',...
  	'delete(findobj(''Name'',''Save Rois''));',...
  	'delete(findobj(''Name'',''grprogui''));',...
  	'delete(findobj(''Name'',''GROUP ROIgui''));',...
	'delete(FI);']);
	
	
herror = uicontrol(grprogui,'string', [' ..............................'],...
	'position',[10 10 340 25],...
	'CallBack',['set(herror,''string'',['' '',Message]); vp_note(Message,3);'],...
	'BackgroundColor',Ecolor);

     SUMRpt
     PlaneRpt
     CompRpt
     SASRpt
     SAS_cRpt 
      
if Automatic,
    	set(herror,'string',['PROCESSING']);
	set(grprogui,'Pointer','watch');
	drawnow;
end

if SUMRpt==1

  studyname = vp_nm('nm',FNames(1,:));
  vp_keyin('[Assign SUM Report Study Name | q]',studyname);
  if (isempty(Keyin) | strcmp(Keyin,'q') | strcmp(Keyin,'quit')),
    return,
  else studyname=Keyin, end;
  len=size(studyname,2); if studyname(len) ~= '.', 
    studyname= [studyname, '.']; end;
  studyname= [pwd,'\',studyname]; 


  if PlaneRpt
  
	%Scan all planes for complete set of Non-Standard Labels
  	MockTime=1;
	
  	[sumfid1,Message]=vp_grouprpt('opensum', studyname); 
  	if sumfid1 == -1
	 set(herror,'string',[' ',Message]);
	return, end
	
	set(herror,'string',['WAIT FOR INITIAL PROCESSING']);
	set(hcont,'Enable','off');
	set(hmode,'Enable','off');
	set(hmapon,'Enable','off');
	set(hrpt,'Enable','off');
	set(hroimenu,'Enable','off');
	
  end

  if CompRpt
  	[sumfid2,Message]=vp_grouprpt('opensum_c', studyname); 
  	if sumfid2 == -1
	  set(herror,'string',[' ',Message]);
	return, end
  	[sumnfid2,Message]=vp_grouprpt('opensumn_c', studyname); 
  	if sumnfid2 == -1
	  set(herror,'string',[' ',Message]);
	return, end
  end
end 
  

snm=1;

FName0=[];
if MaskOpt
      disp('Before maskvect');
      % No need to flip since image and mask are assumed to be in the same
      % orientation for creating a temporary masked file on disk.
      [out1 mask]= vp_volfuns('volvect', MaskImg);
      if out1<0, vp_note(['Error reading : ',Maskimg]), return, end;
end

for j=1:nnms(1) + MockTime ; % Do for all Names and First is MockTime

  if j==2 & MockTime, % The first time is the mock time, start at 2
  	CheckRois=Means(:,:,3) ; % Go by total pxls. not total thresh pxls.
  	MockTime=0; snm=snm-1;   % Does not know thresh at this point. 
  end;

  repeats=1; ThreshTime=0;
  % check for 3D modes
  if (ThreshMode==2 | ThreshMode==4) & ~MockTime  %3D, Not Mock subj.
	repeats=2;               % Additional time for 3D processing
	MinMaxs=zeros(101,3,2); %for Atlas first 101 values always 0
	ThreshTime=1;     % Because Atlas only has Non-Standard Rois
  end

  FName=FNames(snm,:);
  snm =snm+1;
  
  FNamej= FName;
  if GNop
    if MaskOpt
      disp('Before cvt FNamej');
      % write image, thresh 0 , autonaming 
      [out1 out2 out3 FName] = vp_imcvt(FNamej,'g',2, 0, 1, mask);
      if out1<0, vp_note(['Normalization error for : ',FNamej]), return,
      else FName0=FName;
      end;
      
    else
      vp_note('Err: Must specify mask for global normalization\n',3);
      return;
    end
  
  else
    if MaskOpt
      % write image, thresh 0 , autonaming 
      [out1 out2 out3 FName] = vp_imcvt(FName,'m', 2, 0, 1, mask);
      if out1<0, vp_note(['Error masking : ',FNamej]), return,
      else FName0=FName;
      end;
    end % Mask Only
  end % Global Normalization and Masking
  
  %set(hnm,'string',['FNAME: ', FName]);
  set(hnm,'string',[FName]);
  
  if PlaneRpt | CompRpt
    q=max([find(FName=='\') 0]);
    q2=max([find(FName=='.') 0]);
    
    if q ~=0, 
     q=q+1;
    end
    
    if q2==0, 
    	q2=length(FName);
    else q2=q2-1;
    end
  
    subj=[FName(q:q2)] ;
  end
    
  
  if SASRpt
  	[sasfid1,Message]=vp_grouprpt('opensas',FName); 
  	if sasfid1 == -1
	  set(herror,'string',[' ',Message]);
	return, end
  end
  if SAS_cRpt
  	[sasfid2,Message]=vp_grouprpt('opensas_c',FName); 
  	if sasfid2 == -1
	  set(herror,'string',[' ',Message]);
	return, end
	
  end
  
  if CompRpt==1 | SUMRpt==1 
 	% Means=zeros(101,3,3); % nrois, 3 Orientations, 3(meansum,nthreshs,npixs)
 	Means=zeros(101,3,4); % nrois, 3 Orientations, 4(meansum,nthreshs,npixs, stdsum)
                         % Add 4th field for stdsum intermediate component of variance
  end
  
  if SUMRpt==1 & ~MockTime % Print SUM output file name and gloval values
  	if PlaneRpt
	  fprintf(sumfid1,'\n%s',subj);
	end
	if CompRpt
	  fprintf(sumfid2,'\n%5d\t%s\t',(snm-1),subj);
	  fprintf(sumnfid2,'\n%5d\t%s\t',(snm-1),subj);

	  vp_hread(FName);
	  %%if (VAL_OFFSET ~= 0), error(Message); end;
	  %[GMAX GMIN]=vp_roifuns('gminmax');
	  [out1, out2, GMIN, GMAX]=vp_volfuns('xyzdata',FName);

	  if or(strcmp(strtok(EXPTIM,':'),EXPTIM), isempty(str2num(EXPTIM(1)))), frmtim=0.00;
	  else
	    frmtim= [(str2num(EXPTIM(1:2))*60*60)+ (str2num(EXPTIM(4:5))*60) + ...
			 str2num(EXPTIM(7:8))] ; % Frame start time (secs)
			frmtim=(frmtim+DURATION/2)/60; % Mid time (mins); 
	  end
	  fprintf(sumfid2,'%.2f\t%.2f\t%.2f ',DURATION/60,frmtim,GMAX);
	  fprintf(sumnfid2,'%.2f\t%.2f\t%.2f ',DURATION/60,frmtim,GMAX);
	end
  end
  
  for k=1:repeats  % Repeat twice Only for 3D
    if k==repeats
    	ThreshTime=0;
    end
  
    for i=PlaneNo1:PlaneNo2
	if MockTime | ThreshTime
	 set(herror,'string',['WAIT FOR INITIAL PROCESSING']);
	end

  	RoiNo=0; ActRoi=0; % Reinitialize for each repeat
	LabNames=[]; LabIds=[];
  	LabNames=str2mat(blanks(40),blanks(40)); % First 2
  	LabIds=str2mat(blanks(4),blanks(4)); 
	LabAIds=[]; % for Atlas processing Zero out for each plane
	
        if SUMRpt==1 & PlaneRpt  
 		%fprintf(sumfid1,'\n%5d\t',i);
		len=length(Means)           % Zero out for each plane
 		PlanarMeans=zeros(len,3,3); %Same order as global Means
        end
  
	PlaneNo=i,
	
 	vp_fimage;
	
	if isempty(Message)
		PlaneNo=max(PlaneNo-1,1) ;
	end;
	
	if i==PlaneNo1 & k==1,
	  %[GMAX GMIN]=vp_roifuns('gminmax');
	  [out1, out2, GMIN, GMAX]=vp_volfuns('xyzdata',FName);

	  set(hgmnmx,'String',...
	    ['Global Min,Max: (' sprintf('%.2f, ',GMIN) sprintf('%.2f',GMAX) ')']);
	end
	
	if NameConvention==1
	  RoiFName=[roif,num2str(i),'.roi']
	elseif NameConvention==2
	  RoiFName=[roif,'.',num2str(i),'.roi']
	elseif NameConvention==3
	  % Same as atlas name
	else
  	  vp_note('INVALID TEMPLATE Name',3);
	  return;
	end
	
 	set(hname,'string', RoiFName);
	
	set(hpln,'string',num2str(PlaneNo));
	%set(hthr,'string',num2str(RoiThresh));
	
        drawnow;
	
        roino=RoiNo;
	
	if TemplateOpt ~= 4
	  [out1,Message]=vp_grouprpt('read',RoiFName); 
	else
	  [out1,Message]=vp_grouprpt('readatlas',AtlasNm,PlaneNo); 
	end
	
	if out1 < 0 , 
		%s=RoiFName;
		%while ~isempty(s), [x,s]=strtok(s,'\'); end;
		%set(herror,'string',[x,': ',Message]);
		x=vp_nm('nm',RoiFName);
		Message=[x,': ',Message];
		set(herror,'string',Message);
		vp_message(Message);
		if out1==-1, pause(1); delete(findobj('Name','Message')); 
		else,
			while(findobj('Name','Message')),pause(1),end;
			% wait to delete the error
		end;
		%return; Do not exit if an intermediate file doesn't exist;
	end;
	
%	if ThreshMode > 2  & ThreshMode < 5 & RoiNo > 0  & ~MockTime
	if ThreshMode > 2  & ThreshMode < 5 & RoiNo > 0  
		for rno=1:RoiNo
			Thresholds(rno)=FixedThresh;
		end
	end
	
        if ~Automatic & ~MockTime & RoiNo~=roino
	    
		GOsignal=0;
		set(grprogui,'Pointer','arrow');
    		set(herror,'string',['Press CONTINUE to resume processing']);
		set(hcont,'Enable','on');
		set(hmode,'Enable','on');
		set(hmapon,'Enable','on');
		set(hrpt,'Enable','on');
		set(hroimenu,'Enable','on');
	
		while ~GOsignal 
			pause(1);
		end;
  		delete(findobj('Name','REPORT'));
  		delete(findobj('Name','Threshold MAP'));
		set(grprogui,'Pointer','watch');
    		set(herror,'string',['PROCESSING']);
	end
	
	set(herror,'string',[' ',Message]);
	
        if out1 >= 0 % Read data OK 
	  if ThreshTime
	    if TemplateOpt ~= 4
	      [out1,Message]=vp_grouprpt('getmax'); 
	    else
	       [out1,Message]=vp_grouprpt('getmaxatlas',PlaneNo); 
	    end

	  else % Not Threshtime

	    if ~MockTime & ThreshMode == 2 & RoiNo > 0
		for rno=1:RoiNo
			[labno labLR]=strtok(LabIds(rno,:),'LR');
			labno=str2num(labno);
		
			if findstr(labLR,'L'), ori = 1;
			elseif findstr(labLR,'R'), ori=2; else ori=3; end;
			Thresholds(rno)=MinMaxs(labno,ori,1) ;
		end
	    end
	
	    if TemplRpt & ~MockTime & ~ThreshTime
	      [out1,Message]=vp_grouprpt('save0'); 
	      set(herror,'string',[' ',Message]);
	    end

	    if (PlaneRpt | CompRpt) & ~ThreshTime
	      if SUMRpt==1 fid=sumfid1;
	      else fid=sasfid1; end;
	      if TemplateOpt ~= 4
	        [out1,Message]=vp_grouprpt('planar',fid,(PlaneRpt+ 2*CompRpt),SUMRpt); 
	      else
	        [out1,Message]=vp_grouprpt('planaratlas',fid,(PlaneRpt+ 2*CompRpt),SUMRpt); 
	      end
	      set(herror,'string',[' ',Message]);
	    end
	  end
	end %if out1
	
    end  %for i planes	
	
  end %for k repeats
     
  if SASRpt
    fprintf(sasfid1,'                          INITIALS = %s\n',subj);
    [out1,Message]=vp_grouprpt('close',sasfid1); 
    set(herror,'string',[' ',Message]);
  end
  
	
  if SAS_cRpt
    [out1,Message]=vp_grouprpt('writesas_c',sasfid2); 
    set(herror,'string',[' ',Message]);
    fprintf(sasfid2,'                          INITIALS = %s\n',subj);
    [out1,Message]=vp_grouprpt('close',sasfid2); 
    set(herror,'string',[' ',Message]);
  end
	
  if SUMRpt == 1
    if CompRpt & ~MockTime
      [out1,Message]=vp_grouprpt('writesum_c',sumfid2,'data'); 
      set(herror,'string',[' ',Message]);
      [out1,Message]=vp_grouprpt('writesum_c',sumnfid2,'datan'); 
      set(herror,'string',[' ',Message]);
    end
  end

  if ~isempty(FName0),
    dos(['del ',FName0]);
    l=length(FName0); FName0=[FName0(1:l-4),'.hdr'];
    dos(['del ',FName0]); FName0=[];
  end;
  
end % for j names

if SUMRpt == 1
    if PlaneRpt
      fid=sumfid1;
      [out1,Message]=vp_grouprpt('writesum_c',fid,'key','pln'); 
      set(herror,'string',[' ',Message]);
      [out1,Message]=vp_grouprpt('close',fid); 
      set(herror,'string',[' ',Message]);
    end
    if CompRpt
      fid=sumfid2;
      [out1,Message]=vp_grouprpt('writesum_c',fid,'key','cmp'); 
      set(herror,'string',[' ',Message]);
      [out1,Message]=vp_grouprpt('close',fid); 
      set(herror,'string',[' ',Message]);
      fid=sumnfid2;
      [out1,Message]=vp_grouprpt('writesum_c',fid,'key','cmpn'); 
      set(herror,'string',[' ',Message]);
      [out1,Message]=vp_grouprpt('close',fid); 
      set(herror,'string',[' ',Message]);
    end
    
end
  
%if isempty(Message)
if  out1 >= 0
	Message=[' PROCESSING COMPLETE - CHECK WORKING and IMG DIR OUTPUT'];
	
	set(herror,'string',Message);
	vp_note(Message,3);
	set(hmode,'Enable','off');
end

disp('END');

set(grprogui,'Pointer','arrow');
	   
