function [out1, Message]=vp_grouprpt(action,in1,in2,in3,in4)
%_______________________________________________________________________
% vp_grouprpt.m   		C.0 Phoebe Spetsieris  Feb. 24 1999
%		Rev. 5.2	P.S.	Sept. 25, 2003
%		Rev. 5.8	P.S.	May 13, 2007
%		Rev. 6.0	P.S.	Nov 20, 2008
%		Rev. 6.4	P.S.	Aug 18, 2015
%
% Group Roi statistics save report 
% Opens and closes files, calls statistics routines, formats
% and saves data.
% in4: ROI ATLAS volume processing
% FORMAT function [out1, Message]=vp_grouprpt(action,in1,in2,in3,in4)

global LabIds LabNames Thresholds PlaneNo PlaneNo1 PlaneNo2 ThreshMode
global FName Message herr herror hed fname MinMaxs
global MeanReg RegTotal MeanLGT20 MeanRGT20 TotalLGT20 TotalRGT20
global Means NonStdLabs NonStdNo PlanarMeans MockTime CheckRois
global DIM ORIGIN VOX GMIN GMAX FixedThMin FixedThresh
global GNop GNStr MaskOpt MaskImg MaskStr
global RoiFNames TemplateOpt AtlasNm
global AVolXYZ LabAIds DATA AtlasNm RoiNo ALabNames ALabNos 

out1=0;
Message=['...........................'];

if strcmp(action,'figure') 
  delete(findobj('Name','Save Rois'));
       
  udata=0;
  
  hsavr = figure('Color','w','Name','Save Rois',...
	'NumberTitle','off','Position',[100,200,340,70],...
	'Pointer','arrow','UserData',[0],...
	'Units','Pixels','Visible','on');
	
  axis off;
	
  uicontrol(hsavr,'String','CANCEL',...
	'Position',[255 10 70 20],...
	'TooltipString','Do not save, return to the previous display',...
	'callback',[' ',...
	'delete(findobj(''Name'',''Save Rois''));']);

%	'delete(gcbf);']);
	
       
elseif strcmp(action,'save0') 
  %fname=[FName '.' num2str(PlaneNo) '.roi'];
  fname=[vp_nm('dnm',FName) '.' num2str(PlaneNo) '.roi'];
  [out1, Message]=vp_grouprpt('plane',fname);
	
elseif strcmp(action,'getmax') 

  lh=findobj('Tag','roi');
  
  if isempty(lh)
  	Message=['SAVE REPORT: No Rois Found'];
	out1=-1;
  return, end;
  
  nr=size(lh);
  
  for i= nr(1):-1:1
	
	udata=get(lh(i),'UserData');
	nroi=udata(1);
	
        [nt me sd ns mn mx]=vp_roifuns('stat',nroi,0);
	
	% Compute MinMaxs array
		
	[labno labLR]=strtok(LabIds(nroi,:),'LR');
	labno=str2num(labno);
		
	if findstr(labLR,'L'), ori = 1;
	elseif findstr(labLR,'R'), ori=2; else ori=3; end;
	
	% Don't save min because it is based only on the pixels found in the max region %.
     	if length(MinMaxs) >= labno
		if MinMaxs(labno,ori,2) < mx, MinMaxs(labno,ori,2) = mx;
			MinMaxs(labno,ori,1) = Thresholds(nroi);
		end ;
		
	else
		MinMaxs(labno,ori,2) = mx;
		MinMaxs(labno,ori,1) = Thresholds(nroi);
	end
		
   end % for i
   

elseif strcmp(action,'getmaxatlas') 


  natrois=length(LabAIds),
  if natrois == 0, return, end;

  AXYZPlane=AVolXYZ(:,:,PlaneNo);
  AXYZPlane=AXYZPlane';

  for nroi=1:natrois
	dataivec=[];
	atindex=LabAIds(nroi);
	[ativoxx,ativoxy]=find(AXYZPlane==atindex);
        k=1; noivoxs=length(ativoxx);
        for (k=1:noivoxs)
	  dataivec(k)=DATA(ativoxx(k),ativoxy(k));
	end; 
	
        [nt me sd ns mn mx]=vp_roifuns('stat',nroi,0,0,0,dataivec);
	
	% Compute MinMaxs array
		
	[labno labLR]=strtok(LabIds(nroi,:),'LR');
	labno=str2num(labno);
		
	if findstr(labLR,'L'), ori = 1;
	elseif findstr(labLR,'R'), ori=2; else ori=3; end;
	
	% Don't save min because it is based only on the pixels found in the max region %.
     	if length(MinMaxs) >= labno
		if MinMaxs(labno,ori,2) < mx, MinMaxs(labno,ori,2) = mx;
			MinMaxs(labno,ori,1) = Thresholds(nroi);
		end ;
		
	else
		MinMaxs(labno,ori,2) = mx;
		MinMaxs(labno,ori,1) = Thresholds(nroi);
	end
		
   end % for nroi
   

elseif strcmp(action,'planaratlas') 
   vp_grouprpt('planar',in1, in2, in3,'atlas');

elseif strcmp(action,'planar') 

   svar=0;
   if nargin < 5

 	lh=findobj('Tag','roi');
  
  	if isempty(lh)
  	Message=['SAVE REPORT: No Rois Found'];
	out1=-1;
  	return, end;
  
   nr=size(lh);
   nrs=nr(1);

   else % atlas processing
    natrois=length(LabAIds) ;
    if natrois == 0,
  	Message=['SAVE REPORT: No Rois Found'];
	out1=-1;
        return, 
    else
  	Message=['SAVE REPORT: ',num2str(natrois),' Rois Found'];
    end

    AXYZPlane=AVolXYZ(:,:,PlaneNo);
    AXYZPlane=AXYZPlane';

    nrs = natrois ;

   end %if 
  
   % Planar Reports
   if (in2==1 | in2==3) & ~MockTime,
  	fp=in1;
	if in3== 2
   		fprintf(fp,'%d                                 PLANE= %d\n',PlaneNo,PlaneNo);
	else
   		fprintf(fp,'\n%5d',PlaneNo);
	end
   end
   
  
   for j=1:nrs

        if (nargin == 5) % atlas processing
        	nroi=j;
		dataivec=[];
		atindex=LabAIds(nroi);
		[ativoxx,ativoxy]=find(AXYZPlane==atindex);
        	k=1; noivoxs=length(ativoxx);
        	for (k=1:noivoxs)
	  	  dataivec(k)=DATA(ativoxx(k),ativoxy(k));
		end; 
        else
		i= nrs -j + 1;
	
        	%for i= nr(1):-1:1
	
		udata=get(lh(i),'UserData');
		nroi=udata(1);
        	nroi;
        end % if 
	
	[labno labLR]=strtok(LabIds(nroi,:),'LR');
	labno=str2num(labno);
	if findstr(labLR,'L'), ori = 1;
	elseif findstr(labLR,'R'), ori=2; else ori=3; end;
		
		
	if (nargin==5) %ATLAS processing - get cumulative stats 
	   if (ThreshMode == 2 | ThreshMode ==4) & ~ MockTime  % Fixed or Variable 3D 
        	[nt me sd ns mn mx]=vp_roifuns('stat',nroi,1,...
			MinMaxs(labno,ori,1),MinMaxs(labno,ori,2),dataivec);
	   elseif (ThreshMode == 5)  % Fixed Minimum
        	[nt me sd ns mn mx]=vp_roifuns('stat',nroi,2,FixedThMin,[],dataivec);
	   else  % Fixed or Variable 2D
        	[nt me sd ns mn mx]=vp_roifuns('stat',nroi,0,[],[],dataivec);
	   end

           % evaluate variance for this vector (vvar) and the interim
           % component svar using a hypothetical constant mean=1;
           % which will be corrected when the cumulative mean is know.
	   % Use equation dvar=-2*(m-k)*sum(v) + n*(m*m-k*k), where
	   % v is the vector, and m,k are the real and hypothetical mean 

           vvar=sd*sd*(nt-1);
	   dvar=-2*(me -1)*(nt*me) + nt*(me*me -1);
           svar=vvar - dvar;

	else % Template processing
	   if (ThreshMode == 2 | ThreshMode ==4) & ~ MockTime
        	[nt me sd ns mn mx]=vp_roifuns('stat',nroi,1,...
			MinMaxs(labno,ori,1),MinMaxs(labno,ori,2));
	   elseif (ThreshMode == 5) & ~ MockTime
        	[nt me sd ns mn mx]=vp_roifuns('stat',nroi,2,FixedThMin,[]);
	   else
        	[nt me sd ns mn mx]=vp_roifuns('stat',nroi,0,[],[]);
	   end
	end % if nargin
	
	% Compute Means arrays - Any Composite or Summary Report
   	if in2==2 | in2==3 | in3==1
		%[labno labch]=strtok(LabIds(nroi,:),'LR'),
		
		%labno=str2num(labn);
		%labLR=char(labch);
		
		%if labLR=='L', ori = 1,
		%elseif labLR=='R', ori=2, else ori=3, end;
		
	     ntme= nt*me; % Mean Value times the No. of Threshold voxels 

	      
	    %%if length(Means,1) >= labno
	    if size(Means,1) >= labno % If this region was found before
			Means(labno,ori,1) = Means(labno,ori,1) + ntme ; % Sum with previous
			Means(labno,ori,2) = Means(labno,ori,2) + nt ;
			Means(labno,ori,3) = Means(labno,ori,3) + ns ;
			Means(labno,ori,4) = Means(labno,ori,4) + svar ; 

			if (in2 ~=2 & in3==1 ) % Planar SUMMARY Report
				PlanarMeans(labno,ori,1) = PlanarMeans(labno,ori,1) + ntme ;
				PlanarMeans(labno,ori,2) = PlanarMeans(labno,ori,2) + nt ;
				PlanarMeans(labno,ori,3) = PlanarMeans(labno,ori,3) + ns ;
			end
		else
			Means(labno,ori,1) = ntme ;
			Means(labno,ori,2) = nt ;
			Means(labno,ori,3) = ns ;
			Means(labno,ori,4) = svar ; 

			if (in2 ~=2 & in3==1 ) % Planar SUMMARY Report
				PlanarMeans(labno,ori,1) = ntme ;
				PlanarMeans(labno,ori,2) = nt ;
				PlanarMeans(labno,ori,3) = ns ;
			end
		end
		
		if in3==2 % SAS format
		  Means(100,ori,1) = Means(100,ori,1) + ntme ; % total
		  Means(100,ori,2) = Means(100,ori,2) + nt ;
		  Means(100,ori,3) = Means(100,ori,3) + ns ;
		
		  if labno > 20
			Means(99,ori,1) =Means(99,ori,1) + ntme ;
			Means(99,ori,2) =Means(99,ori,2) + nt ;
			Means(99,ori,3) =Means(99,ori,3) + ns ;
		  end
		end
	end
	
   	if (in2 ~= 2) & in3==2 % Planar SAS format
	   labid=sprintf('%.5s',LabIds(nroi,:));
	   labname=sprintf('%.23s',LabNames(nroi,:));
	
	   fprintf(fp,'  %.5s   %5d    %.2f    %5d    %s\n',...
			labid,nt,me,Thresholds(nroi),labname);
   	end
   
   end % for j
   
   if (in2==1 | in2==3) & in3==1 & ~MockTime  % Planar SUMMARY format

	orchar=['L','R',' '];

	for i=1:size(CheckRois,1)
	  	if i < 99 | i > 100
	    	  for j=1:3
	  	    if CheckRois(i,j) ~= 0 % Process all of these
		       if i <= length(PlanarMeans) % region number found up to this plane
		       	 pl=PlanarMeans(i,j,2); % Total thresholded 
		       else
		       	 pl= 0; % For regions existing on other planes
		       end
	  	       if pl ~= 0
	   		   fprintf(fp,'\t%.2f (%.0f)',PlanarMeans(i,j,1)/PlanarMeans(i,j,2),PlanarMeans(i,j,2));
		       else
	   		   fprintf(fp,'\t0.00       ');
		       end % if Planar
		    end % if CheckRois
	    	  end % for j
	  	end % if i
	end % for i
	
   end

elseif strcmp(action,'writesas_c') 

  	fp=in1;
	orchar=['L','R',' '];
	
	for i=1:length(Means)
	  if i < 99 | i > 100
	    for j=1:3
	      if Means(i,j,2) ~= 0
	   	orch=orchar(j);
		if i > 100
				labname=NonStdLabs(i-100,:);
		else
				labname=vp_roifuns('labname',i);
		end
	   	fprintf(fp,' %5d%c     %.2f (%.0f)   %s\n',i,orch,Means(i,j,1)/Means(i,j,2),Means(i,j,2),labname);
	      end
	    end
	  end
	end
	
        i=99;
	for j=1:3
	   if Means(i,j,2) ~= 0
	   	orch=orchar(j);
	   	% fprintf(fp,' %5d%c     %.2f (%.0f)   Total grey matter codes > 20\n',...
		% For old system grey matter was > 20, but atlas and user defined can be anything
	   	fprintf(fp,' %5d%c     %.2f (%.0f)   Total codes > 20\n',...
				i,orch,Means(i,j,1)/Means(i,j,2),Means(i,j,2));
	   end
	end
	  
	means100=0; meanstot=0;
	for j=1:3
	   means100=Means(100,j,1) + means100;
	   meanstot=Means(100,j,2) + meanstot;
	end
	
	if meanstot ~= 0
	   	fprintf(fp,'   100      %.2f (%.0f)   Total Brain\n\n',means100/meanstot,meanstot);
	end
	
	
elseif strcmp(action,'writesum_c') 

    fp=in1;
    orchar=['L','R',' '];

    if strcmp(in2,'data')
	for i=1:length(Means)
	  if i < 99 | i > 100
	    for j=1:3
	      if Means(i,j,3) ~= 0 %PS Total pixels
	        if Means(i,j,2) ~= 0, %PS Total thresholded pixels
	   	  fprintf(fp,'\t%.2f ',Means(i,j,1)/Means(i,j,2));
		else
	   	  fprintf(fp,'\t0.00 ');
		end
	      end
	    end
	  end
	end
	
    elseif strcmp(in2,'datan')
	for i=1:length(Means)
	  if i < 99 | i > 100
	    for j=1:3
	      if Means(i,j,3) ~= 0 %PS Total pixels
	        if Means(i,j,2) ~= 0, % Total thresholded pixels
		  if (TemplateOpt==4) % Atlas Processing 

		    % Get composite std from cumulative var of hypothetical mean=1 
                    CMean=Means(i,j,1)/Means(i,j,2); % Real Composite Mean 

	            % Use equation Dvar=-2*(M-K)*SUM + N*(M*M-K*K), where
	            % SUM is the cumulative value, M is the real mean and K=1;
		    % Mvar=Kvar + Dvar

                    Dvar=-2*(CMean-1)*Means(i,j,1) + Means(i,j,2)*(CMean^2 -1);
		    Mvar= Means(i,j,4) + Dvar;
	   	    if Means(i,j,2) > 1, Stdev=sqrt(Mvar/ (Means(i,j,2) -1));
		    else Stdev = 0; end;

	   	    fprintf(fp,'\t%.2f (%.0f, %.2f) ',Means(i,j,1)/Means(i,j,2),Means(i,j,2), Stdev);
		  else
	   	    fprintf(fp,'\t%.2f (%.0f)',Means(i,j,1)/Means(i,j,2),Means(i,j,2));
		  end
		else
	   	  fprintf(fp,'\t0.00       ');
		end
	      end
	    end
	  end
	end
	
	
    elseif strcmp(in2,'key')
	
	k=0;
   	fprintf(fp,'\n\n');
	
    	if strcmp(in3,'pln')
		k=1;
	   	fprintf(fp,'%5d\t%s\n',k,'Plane No');
	
    	elseif or(strcmp(in3,'cmp'), strcmp(in3, 'cmpn'))
		fprintf(fp,'     \t%s\n',GNStr);
		fprintf(fp,'     \t%s\n',MaskStr);
   		if (ThreshMode == 2 | ThreshMode ==4), N2D3D='3', else N2D3D='2', end;
		if (TemplateOpt==4)
		   if (ThreshMode == 3 | ThreshMode ==4),
		     fprintf(fp,'     \tTEMPLATE: %s, Planes %d - %d, Fixed %d%% of %sD reg. Max \n\n',vp_nm('nm',AtlasNm),PlaneNo1,PlaneNo2,FixedThresh,N2D3D);
		   elseif (ThreshMode ==5)
		     fprintf(fp,'     \tTEMPLATE: %s, Planes %d - %d, Fixed Thresh. Min: %d\n\n',vp_nm('nm',AtlasNm),PlaneNo1,PlaneNo2,FixedThMin);
		   end
		   if strcmp(in3,'cmpn')
		     fprintf(fp,'     \tROI VALUES: Mean (#of Thresh Voxels, Stdev of Thresh Voxels)\n\n');
		   end

		else
		  sztempl= size(RoiFNames) 
		  if sztempl(1) == 1
		   fprintf(fp,'     \tTEMPLATE: %s',vp_nm('nm',RoiFNames(1,:)));
		  else
		   fprintf(fp,'     \tTEMPLATES: %s ... %s',vp_nm('nm',RoiFNames(1,:)),vp_nm('nm',RoiFNames(2,:)) );
		  end
		  if (ThreshMode == 3 | ThreshMode ==4), fprintf(fp,', Fixed %d%% %sD reg. Max \n\n',FixedThresh,N2D3D);
		  elseif (ThreshMode == 5), fprintf(fp,', Fixed Thresh. Min: %d\n\n',FixedThMin);
		  else, fprintf(fp,', Variable %% of %sD reg. Max\n\n',N2D3D);
		  end;
		end
		k=1;
	   	fprintf(fp,'%5d\t%s\n',k,'Sequence No.');
		k=2;
	   	fprintf(fp,'%5d\t%s\n',k,'File Name');
		k=3;
	   	fprintf(fp,'%5d\t%s\n',k,'Scan Duration  (min)');
		k=4;
	   	fprintf(fp,'%5d\t%s\n',k,'Scan Mid Time  (min)');
		k=5;
	   	fprintf(fp,'%5d\t%s\n',k,'Global Max');
	end
	
	for i=1:length(Means)
	  if i < 99 | i > 100
	    for j=1:3
	      if Means(i,j,3) ~= 0 %PS List All Template Rois
	   	orch=orchar(j);
		if i > 100
			labname=NonStdLabs(i-100,:);
		else
			labname=vp_roifuns('labname',i);
		end
		k=k+1;
	   	fprintf(fp,'%5d\t%s\t%c\n',k,labname,orch);
	      end
	    end
	  end
	end
	
    end
	
	
elseif strcmp(action,'open') 
	%q=max([find(in1=='\') 0]);
	%roifilnm=[in1(1:q) num2str(PlaneNo) in1(q+1:length(in1)) '.roi']
	out1 = fopen(in1,'wt');
	if out1 <= 0, Message=['SAVE REPORT: fopen error'], return; end;

elseif strcmp(action,'opensum') 
	q=max([find(in1=='.') 0]);
	sumfilnm=[in1(1:q-1) '_SUM.txt'];
   	if (ThreshMode== 2|ThreshMode==4),sumfilnm=[in1(1:q-1) '_SUM3D.txt'];end;
	out1 = fopen(sumfilnm,'wt');
	if out1 <= 0, Message=['SAVE GROUP SUMMARY REPORT: fopen error'], return; end;
%	fprintf(out1,'\n');
	
elseif strcmp(action,'opensum_c') 
	q=max([find(in1=='.') 0]);
	sumfilnm=[in1(1:q-1) '_SUM_c.txt'];

   	if (ThreshMode== 2|ThreshMode==4),sumfilnm=[in1(1:q-1) '_SUM3D_c.txt'];end;
	out1 = fopen(sumfilnm,'wt');
	if out1 <= 0, Message=['SAVE GROUP SUM COMPOSITE REPORT: fopen error'], return; end;

elseif strcmp(action,'opensumn_c') 
	q=max([find(in1=='.') 0]);
	sumfilnm=[in1(1:q-1) '_SUMn_c.txt']
   	if (ThreshMode== 2|ThreshMode==4),sumfilnm=[in1(1:q-1) '_SUMn3D_c.txt'];end;
	out1 = fopen(sumfilnm,'wt');
	if out1 <= 0, Message=['SAVE GROUP SUM COMPOSITE REPORT: fopen error'], return; end;

elseif strcmp(action,'opensas') 
	q=max([find(in1=='.') 0]);
	sasfilnm=[in1(1:q-1) '_SAS.txt']
   	if (ThreshMode== 2|ThreshMode==4),sasfilnm=[in1(1:q-1) '_SAS3D.txt'];end;
	out1 = fopen(sasfilnm,'wt');
	if out1 <= 0, Message=['SAVE SAS REPORT: fopen error'], return; end;
%	fprintf(out1,'\n');
%	fprintf(out1,'  LABEL    NPX    MEAN       THR(%%)\n');
   
elseif strcmp(action,'opensas_c') 
	q=max([find(in1=='.') 0]);
	sasfilnm=[in1(1:q-1) '_SAS_c.txt']
   	if (ThreshMode== 2|ThreshMode==4),sasfilnm=[in1(1:q-1) '_SAS3D_c.txt'];end;
	out1 = fopen(sasfilnm,'wt');
	if out1 <= 0, Message=['SAVE SAS COMPOSITE REPORT: fopen error'], return; end;

elseif strcmp(action,'abort') 
	out1 = fclose(in1) ;
	if out1 ~= 0, Message=['SAVE REPORT: fclose error'], return; end;
	q=max([find(in2=='\') 0]);
	roifilnm=[in2(1:q) num2str(PlaneNo) in2(q+1:length(in2)) '.roi']
	doscd=['del ' roifilnm];
	out1=dos(doscd);
	Message=['SAVE REPORT: aborted'],
	
elseif strcmp(action,'close') 
	out1 = fclose(in1) ;
	if out1 ~= 0, Message=['SAVE REPORT: fclose error']; return; end;
	
elseif strcmp(action,'savexit') 

  vp_grouprpt('figure');

  hsavr=findobj('Name','Save Rois');
  %fname=[FName '.' num2str(PlaneNo) '.roi'];
  fname=[vp_nm('dnm',FName) '.' num2str(PlaneNo) '.roi'];
  
  cbsavedit=['fname=get(gcbo,''string''); ',...
  	'set(gcbf,''Pointer'',''watch''); ',...
  	'[out1, Message]=vp_grouprpt(''plane'',fname); ',...
  	'set(gcbo,''string'',Message); ',...
  	'set(gcbf,''Pointer'',''arrow''); ',...
  	'set([herror],''string'',Message); '];
	
  
  text(0,40,'File Name (*.roi) ','Units','pixels','FontWeight','bold');

  %hed=uicontrol(hsavr,'style','edit','string',[FName '.' num2str(PlaneNo) '.roi'],...
  %
  hed=uicontrol(hsavr,'style','edit','string',[vp_nm('dnm',FName) '.' num2str(PlaneNo) '.roi'],...
	'TooltipString','Enter return to save rois in template file',...
	'position',[10 10 325 25],'BackgroundColor',[0.9 .9 1.0],'callback',cbsavedit);
	
  
  cbnext= ['delete(findobj(''Tag'',''roi''));',...
  	'delete(findobj(''Name'',''REPORT''));',...
  	'delete(findobj(''Name'',''Statistics''));',...
  	'delete(findobj(''Name'',''Threshold MAP''));',...
	'delete(gcbf);',...
	'set(roigui,''Visible'',''on'');'];
	
%	'vp_roi'];
        
  uicontrol(hsavr,'String','NEXT IMAGE/PLANE',...
	'Position',[130 10 120 20],...
	'TooltipString','Do not save, go to next image or plane.',...
	'callback',cbnext);
       
%  uicontrol(hsavr,'String','SAVE',...
%	'Position',[45 10 80 20],...
%	'callback',[' ',...
%	'set(gcbf,''Pointer'',''watch''); ',...
%	'[out1, Message]=vp_grouprpt(''plane'',fname); ',...
%	'set(hed,''string'',Message); ',...
%	'set(gcbf,''Pointer'',''arrow''); ',...
%	'pause(1);',...
%	'set(herror,''string'',Message); ']);
	
elseif strcmp(action,'read') 

	[out1, Message]=vp_readrpt(in1);

elseif strcmp(action,'readatlas') 

	[out1, Message]=vp_readatlas(in1,in2);
	
elseif strcmp(action,'plane') 

  %roifname=in1;
  %fp=vp_grouprpt('open',roifname);
  %if fp <=0, out1=fp;, return, end;
  
  fp = fopen(in1,'wt');
  if fp <= 0, Message=['SAVE REPORT: fopen error'], return; end;
  
  
  lh=findobj('Tag','roi');
  
  if isempty(lh)
  	Message=['SAVE REPORT: No Rois Found'];
	out1=-1;
  return, end;
  
  nr=size(lh);
  
   if (ThreshMode == 2 | ThreshMode ==4), N2D3D='3', else N2D3D='2', end;
   fprintf(fp,'\n');
   %fprintf(fp,'ROI STATISTICS   %s\n\n',FName);
   fprintf(fp,'ROI STATISTICS (%cD) GLOBAL DATAMIN,MAX=(%.2f %.2f)\n\n',N2D3D,GMIN,GMAX);
   if ThreshMode==5,
     fprintf(fp,'FIXED GLOBAL THRESHOLD MINIMUM=%.2f\n\n',FixedThMin);
   end
   fprintf(fp,'%s\n\n',FName);
   fprintf(fp,'PLANE: %d   NRois: %d\n\n',PlaneNo,nr(1));
   
   fprintf(fp,'No.  TYPE      LABEL                     NPX   THR(%%)  ThPX    MX/MN    RMSD  MEAN\n\n');
   
  
   for i= nr(1):-1:1
	
	udata=get(lh(i),'UserData');
	nroi=udata(1);
	roityp=udata(2);
	[labno labLR]=strtok(LabIds(nroi,:),'LR');
	labno=str2num(labno);
		
	types=strvcat('Rec','Ell','Irr');
	type=types(roityp,:); 
	
	if findstr(labLR,'L'), ori = 1;
	elseif findstr(labLR,'R'), ori=2; else ori=3; end;
	
	
	%if roityp == 1, type ='Rec';
  	%  elseif roityp==2, type = 'Ell';
	%  else type= 'Irr';
	%end
	
	labname=sprintf('%.23s',LabNames(nroi,:));
	labid=sprintf('%.5s',LabIds(nroi,:));
	
	if (ThreshMode == 2 | ThreshMode ==4) & ~ MockTime
        	[nt me sd ns mn mx]=vp_roifuns('stat',nroi,1,...
			MinMaxs(labno,ori,1),MinMaxs(labno,ori,2));
	elseif (ThreshMode == 5) & ~ MockTime
        	[nt me sd ns mn mx]=vp_roifuns('stat',nroi,2,FixedThMin);
	else
        	[nt me sd ns mn mx]=vp_roifuns('stat',nroi,0);
	end
	
	[textstr,Message]=sprintf('%-4d %.3s  %.5s %.23s',...
			nroi,type,labid,labname);
	
 %       fprintf(fp,'%.30s',textstr);
        fprintf(fp,'%.42s ',textstr);
	
	fprintf(fp,'%5d  %5d  %5d   %.2f/%.2f  %.2f  %.2f\n',...
			ns,Thresholds(nroi),nt,mx,mn,sd,me);
   end
   
   fprintf(fp,'\n\nDIM ');
   
   fprintf(fp,'%d %d %d',DIM);
   
   fprintf(fp,' ORIGIN ');
   
   fprintf(fp,'%d %d %d',ORIGIN);
   
   fprintf(fp,' VOX ');
   
   fprintf(fp,'%f %f %f',VOX);
   
   fprintf(fp,'\nROI COORDINATES\n\n');
	
   %fprintf(fp,'%d %d ',DIM(1:2));
   %fprintf(fp,' ROI COORDINATES\n\n');
   %fprintf(fp,'\n\nROI COORDINATES\n\n');
	
   for i= nr(1):-1:1
	udata=get(lh(i),'UserData');
	nroi=udata(1);
	roityp=udata(2);
	xdata=get(lh(i),'XData');
	ydata=get(lh(i),'YData');
	
	if roityp == 1, type ='re';
	   
	  x0=xdata(1) ; y0=ydata(1);
	  xr=xdata(3) ; yr=ydata(3);
	  
  	elseif roityp==2, type = 'el';
	
	  x0=udata(3) ; y0=udata(4);
	  xr=udata(5) ; yr=udata(6);
	  r2=udata(7) ;
	  
	else type= 'ir';
	
	  len=length(xdata);
	  x0=xdata(1) ; y0=ydata(1);
	  
	end
	
	fprintf(fp,'%s %.5s ',type,LabIds(nroi,:));
	if roityp == 1,
		%fprintf(fp,'%.3f %.3f %.3f %.3f\n',x0,y0,xr,yr);
		fprintf(fp,'%.4f %.4f %.4f %.4f\n',x0,y0,xr,yr);
		
	elseif roityp == 2,
		%fprintf(fp,'%.3f %.3f %.3f %.3f %.3f\n',x0,y0,xr,yr,r2);
		fprintf(fp,'%.4f %.4f %.4f %.4f %.4f\n',x0,y0,xr,yr,r2);
	elseif roityp == 3,
		%fprintf(fp,'%.3f %.3f %d ',x0,y0,len);
		fprintf(fp,'%.4f %.4f %d ',x0,y0,len);
		for j= 1:len
		  %fprintf(fp,' %.3f %.3f',xdata(j)-x0, ydata(j)-y0);
		  fprintf(fp,' %.4f %.4f',xdata(j)-x0, ydata(j)-y0);
		end
		fprintf(fp,'\n');
	end
	
   end
   
	
   %out1 = vp_grouprpt('close',fp);
   out1 = fclose(fp) ;
   if out1 ~= 0, Message=['SAVE REPORT: fclose error']; return; end;
   
   if out1 == 0,
   	Message=['REPORT SAVED ' in1];
   end
    
end
