% vp_imtext.m
% Write text at point on an image
%
%___________________________________________________________________________
% vp_imtext.m	C.4.4	P. Spetsieris  Feb. 3, 2000

global HelpMode UFI
global TxtStr TxtCol TxtSiz 

if HelpMode, vp_help(mfilename), return ; end;

if  isempty(UFI),  
  vp_message('no image found');
  return;
end 

ftxt=findobj('Name','Image Text');

if findobj('Name','Image Text');
	figure(ftxt);
	return;
end

TxtStr='';

TxtCol='w';

TxtSiz=10;


ftxt = figure('Color','w','Name','Image Text',...
'NumberTitle','off','Position',[100,200,360,60],...
'Units','Pixels') ;
	
uicontrol(ftxt,'String','White',...
	'Position',[20 5 50 20],...
	'ForegroundColor','k',...
	'BackgroundColor','w',...
	'CallBack',['TxtCol=''w'';']);
	
uicontrol(ftxt,'String','Black',...
	'Position',[80 5 50 20],...
	'ForegroundColor','w',...
	'BackgroundColor','k',...
	'CallBack',['TxtCol=''k'';']);
	
uicontrol(ftxt,'String','Size+',...
	'Callback',['TxtSiz=TxtSiz+1;',...
	'set(findobj(''tag'',''txtsiz''),''string'',num2str(TxtSiz));'],...
	'Position',[135 5 35 20]);
	
uicontrol(ftxt,'String',num2str(TxtSiz),...
	'style','edit','tag','txtsiz',...
	'Position',[170 5 40 20],...
	'CallBack',['TxtSiz=str2num(get(gco,''string''));']);
	
uicontrol(ftxt,'String','--',...
	'Callback',['TxtSiz=TxtSiz-1;',...
	'set(findobj(''tag'',''txtsiz''),''string'',num2str(TxtSiz));'],...
	'Position',[210 5 25 20]);
	
	
uicontrol(ftxt,'String','PLACE',...
	'Position',[245 5 50 20],...
	'CallBack',['figure(UFI);',...
	'gtext(TxtStr,''color'',TxtCol,''FontSize'',TxtSiz);']);
	
uicontrol(ftxt,'String','EXIT',...
	'Position',[305 5 50 20],...
	'CallBack',['delete(findobj(''Name'',''Image Text''));']);
	

htext = uicontrol(ftxt,'string',TxtStr,'style','edit',...
	'position',[05 30 350 25],...
	'Callback',['TxtStr=get(gco,''string'');',...
	'figure(UFI); gtext(TxtStr,''color'',TxtCol,''FontSize'',TxtSiz);']);
	
%	'figure(FI); gtext(TxtStr,''color'',TxtCol);']);


