% vp_imz.m
% Sets Window Format, Initial and Final Planes for sectional display
% of a Statistical/background Map occupying the upper half of the 
% display range for data and the lower half for background.
% 
% Displays statistical map images in three orthogonal views through
% the origin. The user has the option to modify the point through 
% which the orthogonal sections are displayed and/or display multiple
% sequential sections with various formating and skip options.
%__________________________________________________________________________
% vp_imz.m	C.0	P. Spetsieris  April 1, 1999

global WinView  WinFormat Plane0 MaxPlane MaxDim Opt FName Time Message
global DIM VOX SCALE TYPE OFFSET ORIGIN GCM SliceDelta
global nameimgA hrname BgrndFName
global HelpMode Ecolor

if HelpMode, vp_help(mfilename), return ; end;
	
%set image ui controls
vp_imui;
       
uicontrol(imviewgui,'string', 'Help',...
	'TooltipString','Help displayed in MATLAB window',...
	'BackgroundColor',Ecolor,...
	'position',[200 218 40 15],'callback','vp_help(''vp_imz'');');
	
	
hrname=uicontrol(imviewgui,'style','text','string',FName,...
	'horizontalalignment','right',...
	'position',[5 185 235 25],'BackgroundColor',[.6 .6 1]);

uicontrol(imviewgui,'String','DISPLAY',...
	'Position',[180 10 60 25],...
	'CallBack',['Opt=2; vp_imzpro; set(imviewgui,''UserData'',1);']);
	
%	'CallBack',['set(imviewgui,''UserData'',1)']);

cb2D3Dopts = [' ClustOpt=get(hclustmenu,''Value''); ',...
	'if ClustOpt== 2, ',...
	'vp_remclust(''0'',2,2,3,BgrndFName); ',...
	'elseif ClustOpt== 3, ',...
	'vp_remclust(''vp_imzpro'',2,3,5,nameimgA,BgrndFName); ',...
	'else ; end; '];
	
hclustmenu=uicontrol(imviewgui,'Style','PopUp','String',['Remove Clusters|',...
	'Del 2D Clust Semi Range|',...
	'Del 3D Clust A & B'],...
	'TooltipString',['1: Remove 2D clusters |',...
	'2: Remove 3D clusters - A & B '],...
	'Position',[73 10 105 20],...
	'CallBack', cb2D3Dopts,...
	'BackgroundColor',bkgcolor);
	
Opt=1; Time=Time+1; vp_imzpro;
set(hrname,'string',FName);
set(hview,'string',WinView);
set(hform,'string',WinFormat);
set(hplane0,'string',Plane0);
set(hmaxpln,'string',MaxPlane);
if isempty(Message), Message=Message0; end;
