% vp_imzpro
% multi slice statistical image display processing
%_______________________________________________________________________
% vp_imzpro is a routine that displays consecutive sectional slices from
% a statistical/background ANALYZE format image in various multi-figure
% multi-subwindow display formats.
%_______________________________________________________________________
% vp_imzpro		C.0		P. Spetsieris	4/30/98


global Message PlaneNo FName WinView WinFormat MaxPlane Plane0 Opt Time MaxDim
global DIM VOX SCALE TYPE OFFSET ORIGIN DESCRIP GLMAX GLMIN DESCRIP
global EXPTIM DURATION MATYPE DATAMIN DATAMAX GENTIM SUBID EXPDATE
global GCM SliceDelta XYZDATA XYZOR MinThresh MaxThresh NumLabels PhyLabels
global VAL_OFFSET

%FName      = get_file(1,'.img','please select image',[]);

Message=[];

if Opt == 1

vp_hread(FName);
 
P=FName;
q     = length(P);
if P(q - 3) == '.'; P = P(1:(q - 4)); end
FName=P;

if(Time==1)

  WinView=1;
  WinFormat=4 ;
  Plane0 = 1;
  MaxPlane = DIM(3) ;
  MaxDim=DIM(3);
else
  if WinView==1
  	if DIM(3) < MaxDim, MaxPlane=DIM(3);
  	else MaxPlane=min(MaxPlane,DIM(3)); end;
  elseif WinView==2
  	if DIM(1) < MaxDim, MaxPlane=DIM(1);
  	else MaxPlane=min(MaxPlane,DIM(1)); end;
  elseif WinView==3
  	if DIM(2) < MaxDim, MaxPlane=DIM(2);
  	else MaxPlane=min(MaxPlane,DIM(2)); end;
  end
  
  if Plane0 > MaxPlane, Plane0=1; end;
 
end


vp_imzorth;

return;


elseif Opt==2



%FNimg = [FName '.img'];
%[fid,errmessage] = fopen(FNimg,'r');
%if (fid == -1 )
%	errmessage
%	return;
%end


if isempty(PlaneNo)
	PlaneNo0= [];
else
	PlaneNo0= PlaneNo;
end

PlaneNo = 1; 


FWID=WinFormat*DIM(1);
FHGT=WinFormat*DIM(2);
xmax = DIM(1)/FWID ;
ymax = DIM(2)/FHGT ;
ImageSize=DIM(1)*DIM(2);
WMax=WinFormat*WinFormat;
MaxDim = DIM(3);

DATA=zeros(DIM(1),DIM(2));

 
%fseek(fid,0,'bof');

  %if WinView ~= 1
%	XYZDATA=zeros(DIM(1),DIM(2),DIM(3));
%  	for PlaneNo = 1:DIM(3) ,
%		XYZDATA(:,:,PlaneNo) = fread(fid,[DIM(1),DIM(2)],'uchar');
%	end %While
	if WinView == 2
		MaxDim= DIM(1);
		DATA=zeros(DIM(2),DIM(3));
		FWID=WinFormat*DIM(2);
		FHGT=WinFormat*DIM(3);
		xmax = DIM(2)/FWID ;
		ymax = DIM(3)/FHGT ;
	elseif WinView == 3
		MaxDim= DIM(2);
		DATA=zeros(DIM(1),DIM(3));
		FWID=WinFormat*DIM(1);
		FHGT=WinFormat*DIM(3);
		xmax = DIM(1)/FWID ;
		ymax = DIM(3)/FHGT ;
	end
  %end

  %fseek(fid,ImageSize*(Plane0-1),'bof');
  %fclose(fid);
  
  PlaneNo=Plane0 ;
  txti=5;
  %txtj=-5 ;
  txtj= 10 - 3*WinFormat ;
  %txtj=15;
  %txtj=8 ;
  while PlaneNo <= min(MaxPlane,MaxDim) ,

	WNo = 1;

	%FI = figure('Color',[1 1 1]*.8
	FI = figure('Color',[.2 .4 .6],'Name',FName,...
	'Position',[100,20,512,512],...
	'Units','Pixels');
	
	while WNo <= max(1,WMax-1) ,
	if(PlaneNo > MaxDim), break; end;
	if(PlaneNo > MaxPlane), break; end;
	
	if WinView == 1
		DATA = XYZDATA(:,:,PlaneNo);
		%DATA	= fread(fid,[DIM(1),DIM(2)],'uchar');
		
		DATA = DATA';
	elseif WinView == 2
		DATA=zeros(DIM(2),DIM(3));
		for ix=1:DIM(2)
		  for iy=1:DIM(3)
		  	DATA(ix,iy)=XYZDATA(PlaneNo,ix,iy);
		  end
		end
	elseif WinView == 3
		DATA=zeros(DIM(1),DIM(3));
		for ix=1:DIM(1)
		  for iy=1:DIM(3)
		  	DATA(ix,iy)=XYZDATA(ix,PlaneNo,iy);
		  end
		end
	end

%subDATA = DATA
   	if PlaneNo >= Plane0,
	%	rect=[ i j xmax ymax];
	%	Ax=axes('Position',rect,'Visible','off');
	%	imh=image([i,(i+xmax)], [j,(j+ymax)], DATA);
		Ax(PlaneNo-Plane0+1)=subplot(WinFormat,WinFormat,WNo);
	%	imh=image(DATA);
		if WinView ~= 1
			%DATA=rot90(DATA);
			DATA=DATA';
		end
		%DATA=flipud(DATA);
		%DATA=DATA*SCALE;
		%imh=imagesc(DATA,[0 SCALE*255]);
		%imh=imagesc(DATA,[DATAMIN MaxThresh]);
		imh=imagesc(DATA,[DATAMIN DATAMAX]);
		axis off image xy
 		colormap(GCM);
		
		%Correct for aspect ratio
		vp_aspect(WinView,VOX);
		
		if NumLabels,
		  PlaneNoStr=num2str(PlaneNo);
		  thdl=text(txti-2,txtj+8,PlaneNoStr,'Color',[0.9 0.9 0.8],...
	  	    'FontName','Times','FontSize',7);
		end
		
		%Display Coordinate
		if PhyLabels,
		  if WinView == 1
		    ZCoord=(PlaneNo-XYZOR(3))*Dz;
		    titlestr=num2str((PlaneNo-XYZOR(3))*Dz);
		    text(txti+10,txtj-8,['z=',titlestr],...
	  	    'FontName','Times','FontSize',11,...
		    'Color',[1.0 1.0 1.0]);
		  elseif WinView == 2
		    XCoord=(PlaneNo-XYZOR(1))*Dx ;
		    titlestr=num2str((PlaneNo-XYZOR(1))*Dx);
		    text(txti+10,txtj-8,['x=',titlestr],...
	  	    'FontName','Times','FontSize',11,...
		    'Color',[1.0 1.0 1.0]);
		  elseif WinView == 3
		    YCoord=(PlaneNo-XYZOR(2))*Dy;
		    titlestr=num2str((PlaneNo-XYZOR(2))*Dy);
		    text(txti+10,txtj-8,['y=',titlestr],...
	  	    'FontName','Times','FontSize',11,...
		    'Color',[1.0 1.0 1.0]);
		  end
		end
		
		set(Ax(PlaneNo-Plane0+1),'UserData',[WinView PlaneNo VOX XYZOR]);
		%if WNo==1, colormap(GCM); end;
		drawnow;
		WNo = WNo + 1;
   	end % if PlaneNo
	PlaneNo = PlaneNo + SliceDelta ;
	
	end % While WNo
	
        vp_controls(gcf,mfilename,1);
	
   	vp_statbar(2,DATAMIN,DATAMAX,MinThresh,MaxThresh);
	
   	colormap(GCM);
   
   	drawnow;

   end % while
   
   PlaneNo=PlaneNo0;	% Restore Original value;
   fprintf('\n\n> '); 

end %if Opt
