% vp_interbatch.m
% Continuation of vp_interp.m processing for multiple files.
% Allows user to change the size of an Analyze image by specifying
% new voxel or new file dimensions and using linear or nearest 
% neighbor interpolation.
% The change can be applied to multiple files. The new dimensions
% and changed Origin coordinates and file dimensions are saved
% in the header. The images are assigned an 'I' prefix.
%
% The Original (DIM1, VOX1, ORIG1) and Changed Parameters (DIM2,VOX2, ORIG2)
% are specified in the previous module.
%
% DIM     : Image Width, Height(Pixels), No of slices
% VOX     : Voxel Width, Height(mm), Interslice distance 
%___________________________________________________________________________
% vp_interbatch.m	ScAnVP ver 6.1	P. Spetsieris  May 1, 2011 

global HelpMode Ecolor MATYPE Message
global DIM VOX SCALE TYPE OFFSET ORIGIN DESCRIP GLMAX GLMIN EXPTIM DURATION


if HelpMode, vp_help(mfilename), return ; end;

FNames=get_file;

for i=1:size(FNames,1)
 fnm=FNames(i,:),
 DIM=DIM1; VOX=VOX1; ORIGIN=ORIG1;
 vp_interpro(fnm, DIM2, VOX2, ORIG2, 2);
end
