function  datout=vp_interp2D(datin,ntimes)
% Perform image interpolation on  2D data to ntimes the original diminensions 
%_______________________________________________________________________
%
% vp_interp2D performs linear interpolation
% in the X and Y diminensions of 2D data by first
% replicating the border column and row, then
% performing interpolation using the MATLAB 'interp2'
% function and then reducing the output size to
% match the input diminensions*ntimes. The resulting
% 2D matrix is returned.
% .
%_______________________________________________________________________
% vp_interp2D		C.4.7	P. Spetsieris	4/30/01

global HelpMode

if HelpMode, vp_help(mfilename), return ; end;

h=waitbar(0.1,['Processing image 2D linear interpolation ...']);

datout=[];

waitbar(.15,h);

%Replicate edge values

dimin=size(datin);

datin(:,(dimin(2)+1),:)=datin(:,dimin(2),:);

datin((dimin(1)+1),:,:)=datin(dimin(1),:,:);

waitbar(.3,h);

%call Matlab function
datout=interp2(datin,ntimes);

waitbar(.9,h);

%Reduce edge values

dimout=size(datout);

datout=datout(1:(dimout(1)-1),1:(dimout(2)-1));

waitbar(1,h); pause(1); close(h);

return;
