function  keyin=vp_keyin(prompt,default)
%function keyin=vp_keyin(prompt,default)
%
% Displays a prompt, provides a Keyin field, with a user default
% and halts execution until a Keyin is provided and accepted.
% If not cancelled, the global Keyin is set, otherwise,
% the global is set to null. The return value is set to the global.
%_______________________________________________________________________
% vp_keyin.m  		C.4.6 Phoebe Spetsieris  Feb. 8, 2001
%  

global Keyin
% note this function won't return the right value unless it is a global
  
  if ~ischar(default), default=' '; end;

  Keyin=default;
  
  delete(findobj('Name','Keyin'));
       
  keywid=8*(length(prompt)+ 4);
  keywid=max(keywid,340);

  hsavr = figure('Color','w','Name','Keyin',...
	'NumberTitle','off','Position',[100,200,keywid,90],...
	'Pointer','arrow','UserData',default,...
	'Units','Pixels','Visible','on');
	
  text(0,65,prompt,'Units','pixels','FontWeight','bold');
  axis off;

  hedit=uicontrol(hsavr,'style','edit','string',Keyin,...
	'position',[10 35 325 25],'BackgroundColor',[0.9 .9 1.0],...
	'callback',['Keyin=get(gco,''string''); ',...
	'set(gcf,''UserData'',Keyin); ']);
	
  uicontrol(hsavr,'String','OK',...
	'Position',[180 10 40 20],...
	'TooltipString','Accept Keyin',...
	'callback',[' ',...
  	'Keyin=get(gcf,''UserData'');',...
  	'delete(findobj(''name'',''Keyin'')); ']);

  uicontrol(hsavr,'String','CANCEL',...
	'Position',[260 10 70 20],...
	'TooltipString','return to the previous display',...
	'callback',['Keyin= ''''; ',...
	'set(gcf,''UserData'',Keyin); ',...
  	'delete(findobj(''name'',''Keyin'')); ']);

  waitfor(findobj('name','Keyin'));
  keyin=Keyin;
  

	
