% vp_matcolor
% Set colormap from .mat file
%_______________________________________________________________________
% vp_matcolor allows the user to read a colormap from a .mat file and
% sets the active colormap global CM.
%_______________________________________________________________________
% vp_matcolor		ScAnVP	C.4.6	P. Spetsieris	4/18/00
% 		        Rev. 6.2.2	P. Spetsieris   8/14/13	

global CM

%CM=zeros(255,3) + 1;
CM=[];
figsav=gcf;

% get the colormap filename  
%-----------------------------------------------------------------------
w=which('scanvp');
coldir=[w(1:(max(findstr(w,'\'))-4)),'col'];
	
FNcol      = get_file(1,'.mat','please select color file',coldir,0);
if isempty(FNcol), return, end;

FNcol      = FNcol(FNcol ~= ' ');

load(FNcol);

figure(figsav);
colormap(CM);

drawnow;

fprintf('\n\n> '); 

% Restore default get_file directory to user directory.
eval(cbPreDirUpdate);

