function [out1,out2,out3] = vp_math(action, vec1)
%_______________________________________________________________________
% vp_math.m  		C.0 Phoebe Spetsieris  Jan. 28 1999
%
% Math functions
% Calculate Mean and Standard Deviation of a vector including
% zero values and excluding zero values
% vec1 = input vector
% out1=n, out2=mean, out3=stdev
% action:
%	'stat' : n=number of elements, mean, stdev 
%	'statNo0' : n=number of non-zero elements, mean, stdev 
%	'mean' : n=number of elements, mean only 
%_______________________________________________________________________

out1=0;
out2=0 ;
out3=0 ;


% Mean and Standard Deviation
if strcmp(action,'stat') 
	n=length(vec1);
	mean=sum(vec1)/n;
	
	stdev=0;
	if n> 1
		stdev=sqrt(sum((vec1-mean).^2)/(n-1));
	end
	
	out1=n;
        out2=mean; out3=stdev;

elseif strcmp(action,'statNo0') 

  	% Don't count 0's
	[index1, dump2, vec2] = find(vec1); 

	n=length(vec2);
	mean=sum(vec2)/n;
	
	stdev=0;
	if n> 1
		stdev=sqrt(sum((vec2-mean).^2)/(n-1));
	end
	
	out1=n;
        out2=mean; out3=stdev;
	
% Mean value
elseif strcmp(action,'mean') 
	n=length(vec1);
	out2=sum(vec1)/n;
	out1=n;
end	



