% function [out1,dirname,dir,nm,sfx]=vp_nm(action,fname);
%
% This function parses a file name into directory, name
% and suffix string elements. All elements are returned in sequence
% after the first output argument. The first argument depends
% on the specified action and is repeated as one of the remaining
% output arguments. The default action is 'dnm' but fname must be
% specified.
%
% Input action:
%	dnm: out1= directory\name
%	dir: out1= directory
%	nm: out1= name
%	sfx: out1= sfx
%
% Output: [out1,directory\name,directory,name,sfx]
%_______________________________________________________________________
% vp_nm.m	ScAnVP 5.2  Phoebe Spetsieris  Nov. 13, 2003

function [out1,dirname,dir,nm,sfx]=vp_nm(action,fname)

global HelpMode 

if HelpMode, vp_help(mfilename), return ; end;

out1=[]; sfx=[]; 
dir=[];

p=deblank(fname);
q     = length(p);

s=max([findstr(p,'\') 0]);
if s~=0, dir=p(1:s); end;

p=p(s+1:q); q=length(p);
r = max([findstr(p,'.') 0]);
if r ~= 0; sfx=p(r+1:q); p = p(1:r-1); end
dirname=[dir,p];
nm=p;

out1=dirname;
if strcmp(action,'dnm'), out1=dirname; end;
if strcmp(action,'dir'), out1=dir; end;
if strcmp(action,'nm'), out1=nm; end;
if strcmp(action,'sfx'), out1=sfx; end;


