function vp_note(notestr,timeon,callfun);
% vp_note.m
% Display brief note 
%
% Displays a note given by notestr, for timeon seconds
% and then calls callfun. The last two arguments are
% optional. If not entered, the note is diplayed until
% the user clicks on the OK button. If the timeon argument
% is negative, the OK button is not displayed.
% The global Message is set to notestr.
%
% FORMAT function vp_note(notestr,timeon,callfun);
%___________________________________________________________________________
% vp_note.m	C.4.6	P. Spetsieris  Jan. 23, 2001

global Ecolor Message 

delete(findobj('Name','Note'));

Message=notestr;
disp(notestr);

notewid=max(7*length(notestr),40);
figwid=notewid+8; 
if (nargin > 1 & timeon <0 ) fighgt=30;
else fighgt=50; end; 

fnote = figure('Color','w','Name','Note',...
'NumberTitle','off','Position',[100,200,figwid,fighgt],...
'Units','Pixels') ;
pos=get(gcf,'position');
figwid=pos(3);	
offset=(figwid-notewid)/2;

%	'Callback','set(gco,''string'',get(gco,''string''))',...
%
uicontrol(fnote,'string', notestr,...
	'position',[offset fighgt-25 notewid 20],...
	'BackgroundColor',Ecolor);

if (nargin > 1 & timeon <0 ); 
else
 uicontrol(fnote,'String','OK',...
	'Position',[figwid/2-20 5 40 15],...
	'CallBack',['delete(findobj(''Name'',''Note''));']);
end
%	'Position',[notewid/2-21 5 50 15]

if nargin > 2
 eval(callfun);
end

if (nargin > 1 & timeon >= 0)
  pause(timeon); delete(findobj('Name','Note'));
end

end
