function  opt=vp_opt(default,prompt,opt1,tip1,opt2,tip2,opt3,tip3,opt4,tip4,opt5,tip5,opt6,tip6)
%function  opt=vp_opt(default,prompt,opt1,tip1,opt2,tip2,opt3,tip3,opt4,tip4,opt5,tip5,opt6,tip6)
%
% Displays a prompt and provides up to 6 options and a default.
% Displays buttons with labels provided by the input options 
% and halts execution until an option is selected.
% The global Opt is set to the default until a selection is made.
% The default is not displayed but is returned if cancelled.
% The return value is set to the global Opt.
%_______________________________________________________________________
% vp_opt.m  		C.4.7.7 Phoebe Spetsieris  Mar. 5, 2002
% 	  		5.1 Phoebe Spetsieris  Jul. 18, 2003

global POpt
% Note this function won't return the right value unless it is the global Opt
  
  if ~ischar(default), default=' '; end;

  if nargin < 6
   vp_note('Must enter at least 2 options',2); return;
  elseif nargin > 14 
   vp_note('Too many options for vp_opt (max=6)',2); return;
  end
  
  POpt=default;
  
  delete(findobj('Name','opt'));
   
  uopts=char(opt1,opt2);
  opt1wid=8*(length(opt1)+ 2);
    if isempty(tip1),tip1=opt1; end;
  opt2wid=8*(length(opt2)+ 2);
    if isempty(tip2),tip2=opt2; end;
  opt3wid=0; opt4wid=0; opt5wid=0; opt6wid=0;
  if nargin > 6
    opt3wid=8*(length(opt3)+ 2);
    uopts=char(uopts,opt3);
    if isempty(tip3),tip3=opt3; end;
  end
  if nargin > 8
    opt4wid=8*(length(opt4)+ 2);
    uopts=char(uopts,opt4);
    if isempty(tip4),tip4=opt4; end;
  end
  if nargin > 10 
    opt5wid=8*(length(opt5)+ 2);
    uopts=char(uopts,opt5);
    if isempty(tip5),tip5=opt5; end;
  end
  if nargin > 12 
    opt6wid=8*(length(opt6)+ 2);
    uopts=char(uopts,opt6);
    if isempty(tip6),tip6=opt6; end;
  end
  
  keywid=(opt1wid+opt2wid+opt3wid+opt4wid+opt5wid+opt6wid+40+(nargin-3)*10);
  %keywid=max(keywid,100);
  
  if isempty(prompt),
   prompt=['Select An Option :'];
  end;
  
  promptwid=8*(length(prompt)+ 4);
  
  keywid=max(keywid,promptwid);
  figwid=keywid; fighgt=50;
  hopt = figure('Color',[0.6,.7,0.7],'Name','opt',...
	'NumberTitle','off','Position',[50,100,figwid,fighgt],...
	'Pointer','arrow','UserData',uopts,...
	'Units','Pixels','Visible','on');
	
       
  %text(0,35,prompt,'Units','pixels','FontWeight','bold');
  %axis off;
  
  %uicontrol(hopt,'String',prompt,...
  %	'units','normalized',...
  %	'Position',[0 30/fighgt (promptwid)/figwid 20/fighgt],...
  %	'BackgroundColor','w',...
  %	'TooltipString','Select Option');

%hedit=uicontrol(hopt,'style','edit','string',opt,...
%'position',[10 35 325 25],'BackgroundColor',[0.9 .9 1.0],...
%'callback',['opt=get(gco,''string''); ',...
%'set(gcf,''UserData'',opt); ']);
	
  uicontrol(hopt,'String',opt1,...
  	'units','normalized',...
	'Position',[20/figwid 10/fighgt opt1wid/figwid 20/fighgt],...
	'TooltipString',tip1,...
	'callback',[' ',...
  	'opts=get(gcf,''UserData''); POpt=opts(1,:),',...
  	'delete(findobj(''name'',''opt'')); ']);

  uicontrol(hopt,'String',opt2,...
  	'units','normalized',...
	'Position',[(30+opt1wid)/figwid 10/fighgt opt2wid/figwid 20/fighgt],...
	'TooltipString',tip2,...
	'callback',[' ',...
  	'opts=get(gcf,''UserData''); POpt=opts(2,:),',...
  	'delete(findobj(''name'',''opt'')); ']);

  if nargin > 6
    uicontrol(hopt,'String',opt3,...
  	'units','normalized',...
	'Position',[(40+opt1wid+opt2wid)/figwid 10/fighgt opt3wid/figwid 20/fighgt],...
	'TooltipString',tip3,...
	'callback',[' ',...
  	'opts=get(gcf,''UserData''); POpt=opts(3,:),',...
  	'delete(findobj(''name'',''opt'')); ']);
  end

  if nargin > 8
    uicontrol(hopt,'String',opt4,...
  	'units','normalized',...
	'Position',[(50+opt1wid+opt2wid+opt3wid)/figwid 10/fighgt opt4wid/figwid 20/fighgt],...
	'TooltipString',tip4,...
	'callback',[' ',...
  	'opts=get(gcf,''UserData''); POpt=opts(4,:),',...
  	'delete(findobj(''name'',''opt'')); ']);
  end

  if nargin > 10 
    uicontrol(hopt,'String',opt5,...
  	'units','normalized',...
	'Position',[(60+opt1wid+opt2wid+opt3wid+opt4wid)/figwid 10/fighgt opt5wid/figwid  20/fighgt],...
	'TooltipString',tip5,...
	'callback',[' ',...
  	'opts=get(gcf,''UserData''); POpt=opts(5,:),',...
  	'delete(findobj(''name'',''opt'')); ']);
  end

  if nargin > 12 
    uicontrol(hopt,'String',opt6,...
  	'units','normalized',...
	'Position',[(70+opt1wid+opt2wid+opt3wid+opt4wid+opt5wid)/figwid 10/fighgt opt6wid/figwid  20/fighgt],...
	'TooltipString',tip6,...
	'callback',[' ',...
  	'opts=get(gcf,''UserData''); POpt=opts(6,:),',...
  	'delete(findobj(''name'',''opt'')); ']);
  end

  text(0,40/fighgt,prompt,'HorizontalAlignment','left','Units','normalized','FontWeight','bold');
  pos=get(gca,'position');
  set(gca,'position',[20/figwid pos(2) pos(3) pos(4)]);
  axis off;
 
  waitfor(findobj('name','opt'));
  
  POpt=deblank(POpt);
  opt=POpt;
  

	
