% function [out1] = vp_plot(X,Y,st,lw,msz,xlab,ylab,ptitle,fontsize);
%
% General ScAnVP plot function 
%
% X=input x values
% Y=input y values
% st=line style attributes
% lw=linewidth
% msz=marker size
% xlab= x axis label
% ylab= y axis label
% ptitle=plot title;
% fontsize=fontsize;
%_______________________________________________________________________
% vp_plot.m 	ScAnVP ver. 6.2 Phoebe Spetsieris  July 12, 2012

function [out1] = vp_plot(X,Y,st,lw,msz,xlab,ylab,ptitle,fontsize);

global HelpMode 

if HelpMode, vp_help(mfilename), return ; end;

out1=0; 

txcolor=[0.8 0.2 1];
	
pf=figure;

if nargin < 1, vp_note('Plot: Insufficient Arguments',3); out1=-1; return; end;
% Assign defaults
if nargin < 9, fontsize=14; end;
if nargin < 8, ptitle=''; end;
if nargin < 7, ylab='Y'; end;
if nargin < 6, xlab='X'; end;
if nargin < 5, msz=10; end;
if nargin < 4, lw=2; end;
if nargin < 3, st='k-'; end;
if nargin ==1, Y=X; X=1;length(Y); end; 

plot(X,Y,st,'LineWidth',lw,'MarkerSize',msz);

%set(gca,'xlim',[0 4]);
%set(gca,'xtick',[0 1 2 3 4]);

if ~isempty(ptitle), title(ptitle,'FontSize',fontsize); end;
xlabel(xlab,'FontSize',fontsize);
ylabel(ylab,'FontSize',fontsize);









