function [out1, Message]=vp_readrpt(in1)
%_______________________________________________________________________
% vp_readrpt.m  		C.0 Phoebe Spetsieris  Mar. 13, 1999
% Roi read statistics-template report 

global LabIds LabNames Thresholds PlaneNo
global Message RoiNo FI
global NonStdLabs NonStdNo NonStdLabStr
global DIM ORIGIN VOX TemplDIM TemplORIGIN TemplVOX Fitting Flipping

   out1=0;
   Message=['.........................'];

   figure(FI);
  
   tag=['roi'];
  
   fp = fopen(in1,'rt');
   if fp <= 0, Message=['READ REPORT: fopen error'],
   out1=-1;
   return; end;
  
   dumpstr=fscanf(fp,'%s',3);
   dumpstr=fscanf(fp,'%s',1);
   while(~strcmp(dumpstr,'PLANE:'))
   	dumpstr=fscanf(fp,'%s',1);
   end;
   planeno=fscanf(fp,'%d',1);
   dumpstr=fscanf(fp,'%s',1);
   nrs=fscanf(fp,'%d',1) ,
   dumpstr=fscanf(fp,'%s',9);
   
   %if ~isa(nrs,'double'), Message=['Invalid Roi File '], nrs,
   if isempty(nrs)| nrs<0 , Message=['Invalid Roi File '], nrs,
     out1=-5;
   return; end;
  
   DIM, ORIGIN, VOX, Fitting,
   
   for i= 1:nrs
   
  	dumpno=fscanf(fp,'%d',1);  %No.
  	dumchr=fscanf(fp,'%c',1); 
 	type=fscanf(fp,'%s',1) ;    %Type
  	dumchr=fscanf(fp,'%c',2); 
	if strcmp(type,'Rec'), typ(i)=1;
	elseif strcmp(type,'Ell'), typ(i)=2;
	elseif strcmp(type,'Irr'), typ(i)=3;
	else 
   		Message=['REPORT READ Invalid Type ' type],
		out1=-6; fclose(fp); return;
	end;
	
 	labid=fscanf(fp,'%s',1);    %LabId
	if i > 1,
	  labids=strvcat(labids,labid);
	else
	  labids=labid;
	end
 	dumpch=fscanf(fp,'%c',1);
	while dumpch==' '
	 dumpch=fscanf(fp,'%c',1);
	end
	
 	%labname=fscanf(fp,'%c',23) %LabName
	
 	restofnm=fscanf(fp,'%c',22); %LabName
	
	labname=[dumpch restofnm];
	
	if i > 1,
	  labnames=strvcat(labnames,labname);
	else
	  labnames=labname;
	end
   
 	npx=fscanf(fp,'%d',1);	      %NPX
 	thresh(i)=fscanf(fp,'%d',1);   %THRESH
 	dumpstr=fscanf(fp,'%s',4);
	
%       fscanf(fp,'%d %s %s %s %d %d\n',&dumpno,type,labid,labname,&dumpno,&thresh);
%	dumpno,type,labid,labname,dumpno,thresh
	
   end
   
   labids, labnames,
   
   % READ IMAGE DIMENSIONS and ROI COORDINATES
   
   dumpstr=fscanf(fp,'%s',1), % 'DIM' or 'ROI'
   
   XScale=1.0; YScale=1.0;
   if(strcmp(dumpstr,'DIM'))
  	TemplDIM=fscanf(fp,'%d',3),  %  DIM(1:2:3)
	TemplDIM=TemplDIM',
	
   	dumpstr=fscanf(fp,'%s',1), % 'ORIGIN'
   	if(~strcmp(dumpstr,'ORIGIN'))
   		out1 = -2, Message=['READ REPORT: TEMPLATE ORIGIN NOT FOUND'], dumpstr,
		fclose(fp); return; 
	end
	
  	TemplORIGIN=fscanf(fp,'%d',3),  %  ORIGIN(1:2:3)
	TemplORIGIN=TemplORIGIN',
	
   	dumpstr=fscanf(fp,'%s',1), % 'VOX'
   	if(~strcmp(dumpstr,'VOX'))
   		out1 = -3, Message=['READ REPORT: TEMPLATE VOX NOT FOUND'], dumpstr,
		fclose(fp); return; 
	end
	
  	TemplVOX=fscanf(fp,'%f',3),  %  VOX(1:2:3)
	TemplVOX=TemplVOX',
	
	
	if TemplVOX(1) == 0 | TemplVOX(2) == 0
   		out1 = -4, Message=['READ REPORT: INVALID TEMPL VOX'], VOX,
		fclose(fp); return; 
	end
	
	%if Fitting & (TemplVOX ~= VOX)
	if Fitting 
		
		XScale=TemplVOX(1)/VOX(1),
		YScale=TemplVOX(2)/VOX(2),
	end
	
   	dumpstr=fscanf(fp,'%s',2);   % 'ROI COORDINATES'
	
   else % got 'ROI'
     dumpstr=fscanf(fp,'%s',1); % 'COORDINATES'
     TemplDIM=DIM;
     TemplORIGIN=ORIGIN;
     TemplVOX=VOX;
   end
   
   
   %LabNames=strvcat(LabNames,labnames);
   %LabIds=strvcat(LabIds,labids);
   
   for i= 1:nrs
     dumpstr=fscanf(fp,'%s',2); % No. TYPE
     RoiNo=RoiNo+1;
     Thresholds(RoiNo)=thresh(i);
     len=length(labnames(i,:));
     LabNames(RoiNo,:)=[labnames(i,:) blanks(40-len)];
     
     labid=labids(i,:);
     [labno,ret]=sscanf(labid,'%d%c',2);
     if labno(1) > 100
     	if ret > 1, ori=labid(length(labid));
	else ori=' '; end;
	nid=NonStdNo+1;
	for j=1:NonStdNo-100
		if strcmp(LabNames(RoiNo,:),NonStdLabs(j,:))
		   nid=j+100;
		end
	end
	if nid==NonStdNo+1,
		NonStdNo=nid;
		NonStdLabs=str2mat(NonStdLabs,LabNames(RoiNo,:));
		NonStdLabStr=strcat(NonStdLabStr,'|',LabNames(RoiNo,:));
		set(findobj('Tag','RoiMenu2'),'String',NonStdLabStr);
	end
   	labid=[num2str(nid),ori];
   	LabIds(RoiNo,:)=[labid blanks(4-length(labid))];
     else
     	len=length(labids(i,:));
     	LabIds(RoiNo,:)=[labids(i,:) blanks(4-len)];
     end
     
     ory=ORIGIN(2); tory=TemplORIGIN(2);
     %if Flipping , ory=DIM(2)-ORIGIN(2); tory=TemplDIM(2)-TemplORIGIN(2); end;
     
     if typ(i) == 1, 
     	
     	xarr=fscanf(fp,'%f',4);
	
	x0=xarr(1) ; y0=xarr(2);
	Xr=xarr(3); Yr=xarr(4);
	
	x=[x0 x0 Xr Xr x0];
	y=[y0 Yr Yr y0 y0];
	
	
	%if XScale ~=1.0 , x=x*XScale; end;
	%if YScale ~=1.0 , y=y*YScale; end;
	%if Fitting, x=x*XScale; y=y*YScale; end;
	
        if Flipping , y=TemplDIM(2)-y; end;
	if Fitting,
	 x=ORIGIN(1) + (x-TemplORIGIN(1))*XScale;
	 %y=ORIGIN(2) + (y-TemplORIGIN(2))*YScale;
	 y=ory + (y-tory)*YScale;
	end;
	
	Lh=line(x,y,'Tag',tag,'erase','xor','color',[1 1 1],...
	'UserData',[RoiNo 1],...
	'ButtonDownFcn',['RoiTyp = ''r''; vp_aniroi pick']);
	
     elseif typ(i) == 2, 
     	xarr=fscanf(fp,'%f',5);
	x0=xarr(1); y0=xarr(2);
	Xr=xarr(3); Yr=xarr(4);
	r2=xarr(5);
	
       
        if Flipping, y0=TemplDIM(2)-y0; Yr=TemplDIM(2)-Yr; end;
        %if XScale ~= 1.0  | YScale ~= 1.0, 
	if Fitting,
		r1=sqrt((Yr-y0)^2 + (Xr-x0)^2);
		r2=r2/r1*sqrt(((Yr-y0)*XScale)^2 + ((Xr-x0)*YScale)^2);
		%x0=x0*XScale; y0=y0*YScale;
		%Xr=Xr*XScale; Yr=Yr*YScale;
		
	 	x0=ORIGIN(1) + (x0-TemplORIGIN(1))*XScale;
	 	%y0=ORIGIN(2) + (y0-TemplORIGIN(2))*YScale;
		y0=ory + (y0-tory)*YScale;
		
	 	Xr=ORIGIN(1) + (Xr-TemplORIGIN(1))*XScale;
	 	%Yr=ORIGIN(2) + (Yr-TemplORIGIN(2))*YScale;
		Yr=ory + (Yr-tory)*YScale;
	end
	
	
	[x,y,out1,Message]=vp_graphics('elli',x0,y0,Xr,Yr,r2);
	if out1 < 0, fclose(fp); return; end;
	
	Lh=line(x,y,'Tag',tag,'erase','xor','color',[1 1 1],...
		'UserData',[RoiNo 2 x0 y0 Xr Yr r2],...
		'ButtonDownFcn',['RoiTyp=''e''; vp_aniroi pick']);
		
     elseif typ(i) == 3, 
     	xori=fscanf(fp,'%f',2);
     	npts=fscanf(fp,'%d',2);
     	xarr=fscanf(fp,'%f',2*npts(1));
	
	k=1;
	x=[];
	y=[];
	for j= 1:npts(1)
	  x(j)=xarr(k)+xori(1);
	  k=k+1;
	  y(j)=xarr(k)+xori(2);
	  k=k+1;
	end
	
	%if XScale ~=1.0 , x=x*XScale; end;
	%if YScale ~=1.0 , y=y*YScale; end;
	
        if Flipping , y=TemplDIM(2)-y; end;
	if Fitting,
	 x=ORIGIN(1) + (x-TemplORIGIN(1))*XScale;
	 %y=ORIGIN(2) + (y-TemplORIGIN(2))*YScale;
	 y=ory + (y-tory)*YScale;
	end;
	
	Lh=line(x,y,'Tag',tag,'erase','xor','color',[1 1 1],...
		'UserData',[RoiNo 3],...
		'ButtonDownFcn',['RoiTyp=''i''; vp_aniroi pick']);
     end
   
   end
   
  
   out1 = fclose(fp) ;
   
   if out1 ~= 0, Message=['READ REPORT: fclose error'], return; end;
   
   if out1 == 0,
   	Message=['REPORT READ ' in1],
   end
   
   
  % set(hroimenu,'Visible','on','Enable','on','Value',1);
