% vp_setthresh.m
% set Threshold value
%__________________________________________________________________________
% vp_setthresh.m	C.4.6 	P. Spetsieris	 Dec 27, 2000

global RoiThresh
global hthrerror Message Ecolor 

global RoiThresh hthrerror hthrslider


setthreshgui=findobj('Name','setthreshgui');
if ~isempty(setthreshgui)
	if(strcmp(get(setthreshgui,'Visible'),'on'))
		figure(setthreshgui);
	end
	return
end

Message0=['MSG: ......................................... '];
Message=Message0;

frmcolor=[0.5 0.7 0.8];

setthreshgui = figure('Color',frmcolor,'Name','setthreshgui',...
'NumberTitle','off','Position',[100,370,260,85],...
'Units','Pixels');
	
Bcolor = [.8,1,1];


cbRoiThresh=['RoiThresh=str2num(get(hRoiThresh,''string'')); ',...
	['if(RoiThresh >= 0) & (RoiThresh <= 100 ),',...
	'Message=Message0; set(hthrslider,''Value'',RoiThresh);',...
	'else, Message=''Error: Threshold Out of Bounds''; end; '],...
		'set(hthrerror,''string'',['' '',Message]);'];

cbSliRoiThresh=['RoiThresh=ceil(get(gco,''Value''));, set(hRoiThresh,''string'',RoiThresh);',...
	['if(RoiThresh < 0) | (RoiThresh > 100) Message=''Error: Threshold Out of Bounds'';',...
	'else Message=Message0; end; '],...
		'set(hthrerror,''string'',['' '',Message]);'];

uicontrol(setthreshgui,'Style','text','string', 'THRESHOLD 0-100',...
	'position',[10 55 100 20],'BackgroundColor',frmcolor);
	
hthrslider=uicontrol(setthreshgui,'Style','slider', 'Position', [10 35 200 25], 'Min',0,'Max',100,...
	'Value',RoiThresh,'Callback',cbSliRoiThresh);
	
hRoiThresh=uicontrol(setthreshgui,'style','edit','string',RoiThresh,...
	'position',[210 35 40 25],'BackgroundColor',Bcolor,'callback',cbRoiThresh);

hthrerror = uicontrol(setthreshgui,'string', ['MSG: ..............................'],...
	'position',[10 10 170 25],...
	'CallBack',['set(hthrerror,''string'',['' '',Message]);'],...
	'BackgroundColor',Ecolor);

uicontrol(setthreshgui,'String','RETURN',...
	'Position',[180 10 70 25],...
	'CallBack',['if RoiThresh > 0 & RoiThresh <=100, delete(gcbf);',...
	'vp_note(''Pick regions and then UPDATE GIS MAP'',3); ',...
	'else, Message=''Error: Threshold Out of Bounds''; set(hthrerror,''string'',Message); end;']);
	
