% vp_roistat
%_______________________________________________________________________
% vp_roistat.m  		C.0 Phoebe Spetsieris  Jan. 25 1999
% Display roi statistics

global ActRoi RoiTyp LabIds LabNames Picking Thresholds

TxColor=[0.6 0.2 1];
%Picking='OFF';
      
	
	lh=findobj('Tag','roi');
	nr=size(lh);
	for i=(1:nr(1))
		if lh(i)~=gco
    			set(lh(i),'Color',[1 1 1],'LineWidth',[0.5]);
		end
	end
%	udata=get(hand,'UserData');
%	ActRoi=udata(1)
	
	hroigui=findobj('Name','gROIgui');
	set(hroigui,'Visible','off'); 
       
	delete(findobj('Name','Statistics'));
	
        hstat = figure('Color','w','Name','Statistics',...
	'NumberTitle','off','Position',[100,370,280,120],...
	'Units','Pixels','Visible','on');
	
	axis off;
	
        textstr=strcat('No. ',num2str(ActRoi));
	if RoiTyp == 'e', type ='Elliptical';
	elseif RoiTyp=='r', type = 'Rectangular';
	else type= 'Irregular';
	end
	thresh=num2str(Thresholds(ActRoi));
        textstr=['No. ',num2str(ActRoi),'  ',type,'  Thresh: ',thresh];
	text(0.0,.92, textstr,...
	'FontName','Times','FontSize',10,...
	'VerticalAlignment','Middle',...
	'HorizontalAlignment','Left',...
	'Color',TxColor);
	
	labname=deblank(LabNames(ActRoi,:));
	labid=deblank(LabIds(ActRoi,:));
	textstr=['Label :   ',labid,'    ',labname];
	text(0.0,.77, textstr,...
	'FontName','Times','FontSize',10,...
	'VerticalAlignment','Middle',...
	'HorizontalAlignment','Left',...
	'Color',TxColor);

        [nt mn sd]=vp_roifuns('stat',ActRoi,0);
	textstr=['Nt: ',num2str(nt),' Mean: ',...
		num2str(mn),' StDev: ',num2str(sd)];
	text(0.0,.62, textstr,...
	'FontName','Times','FontSize',10,...
	'VerticalAlignment','Middle',...
	'HorizontalAlignment','Left',...
	'Color',TxColor);
	
        uicontrol(hstat,'String','RETURN',...
	'Position',[140 30 80 20],...
	'CallBack',['set(findobj(''Name'',''gROIgui''),''Visible'',''on''); ',...
	'delete(findobj(''Name'',''Statistics''));',...
	'Picking=''ON''; vp_aniroi stop;'] );
       
	



