function [out1] = vp_savmask(action, in1, in2)
%_______________________________________________________________________
% vp_savmask.m  ScAnVP Ver. C.0 Phoebe Spetsieris  Jan. 1999
%			Revision 5.7.w P. Spetsieris  Nov. 10, 2006
%           Rev. 7.0 P. Spetsieris  Jan. 20, 2016

global DATA WTotal NRTotal Message
global DIM VOX SCALE TYPE OFFSET ORIGIN DESCRIP
global EXPTIM DURATION MATYPE GENTIM SUBID EXPDATE
global HelpMode DisplayOrient InputOrient

	
out1=0;

if strcmp(action,'open') 
	q=max([find(in1=='\') 0]);
	%    mskfilnm=[in1(1:q) 'msk' in1(q+1:length(in1)) '.img']
    mskfilnm=[in1(1:q) 'mask' in1(q+1:length(in1)) '.img']
	out1 = fopen(mskfilnm,'wb');
	if out1 <= 0, Message=['fopen error'], return; end;

elseif strcmp(action,'abort') 
	out1 = fclose(in1) ;
	if out1 ~= 0, Message=['fclose error'], return; end;
	q=max([find(in2=='\') 0]);
	mskfilnm=[in2(1:q) 'mask' in2(q+1:length(in2)) '.img']
	doscd=['del ' mskfilnm];
	out1=dos(doscd);
	Message=['Mask aborted']
	
elseif strcmp(action,'close') 
	out1 = fclose(in1) ;
	if out1 ~= 0, Message=['fclose error']; return; end;
	q=max([find(in2=='\') 0]);
	if NRTotal <= 0   
		mskfilnm=[in2(1:q) 'mask' in2(q+1:length(in2)) '.img'];
		doscd=['del ' mskfilnm];
		dos(doscd);
		Message=['Empty mask removed']
		return;
	else
 	  mskfilnm=[in2(1:q) 'mask' in2(q+1:length(in2)) '.hdr']
	  TYPE=2;
	  SCALE=1.0;
	  out1=vp_hwrite(mskfilnm,DIM,VOX,SCALE,TYPE,OFFSET,ORIGIN,['0-1 Mask'],...
	  EXPTIM,DURATION,GENTIM,SUBID,EXPDATE);
	  if out1 ~= 348, Message=['header write error'], end;
	end	
	
elseif strcmp(action,'save') 
	
	if WTotal >= DIM(1)*DIM(2)*DIM(3), return, end; 
	lh=findobj('Tag','roi');
	nr=size(lh);
	bw=uint8(zeros(size(DATA)));
	for i=(1:nr(1))
		x=get(lh(i),'XData');
		y=get(lh(i),'YData');
		rp=roipoly(DATA,x,y);
		rw=uint8(rp);
		%bw=bitor(bw,roipoly(DATA,x,y));
		bw=bitor(bw,rw);
	end
	NRTotal = NRTotal+ nr(1);
	datsiz=size(bw);
	nel=datsiz(1)*datsiz(2);
	
	%convert to uchar
	cw=DATA;
	for i=1:nel
		cw(i)=bw(i) ;
	end;
	
	% save
	%cw=flipud(cw);
    
    if (InputOrient ~= DisplayOrient), cw=fliplr(cw); end; 
	cw=cw';
	out1=fwrite(in1,cw,'uchar');
	WTotal=WTotal+out1;
	if out1 ~= nel, Message=lasterr(''); end;
	
elseif strcmp(action,'skip') 
	if WTotal >= DIM(1)*DIM(2)*DIM(3), return, end; 
	bw=zeros(size(DATA));
	datsiz=size(bw);
	nel=datsiz(1)*datsiz(2);
	
	%convert to uchar
	cw=DATA;
	for i=1:nel
		cw(i)=bw(i) ;
	end;
	
	% save
	%nskip=in2
	%cw=flipud(cw);
	cw=cw';
	for i=1:in2
	  out1=fwrite(in1,cw,'uchar');
	  WTotal=WTotal+out1;
	  if out1 ~= nel, Message=lasterr(''); nwr0=out1, return; end;
	end
	
end	




