% vp_spmlike
% Display spm like results for general types of statistical images
%_______________________________________________________________________
% User interface for SPM like results for statistical output
% Analyze images including non-SPM statistical volumes created by
% SSM analysis such as SSM GIS pixel based output or ROI based
% output that is processed by the 'GIS ROI Pixel Map' routine.
% Images must be in spm normalized space.
% Not all operations available in spm_results are operational here.
% For thresholding and cluster removal options, the data can be pre-
% processed by the 'Statistical Map' routine.
% Calls the routine vp_spmresults that is based on spm_results
% (see help spm_results)
%_______________________________________________________________________
% vp_spmlike.m  	4.7.7	 Phoebe Spetsieris Nov. 19,2001

global HelpMode POpt
global SSM VOL

if HelpMode, vp_help(mfilename); return; end;

POpt=vp_opt('X','','Display SPM-like Results for Statistical Images','','Help','');

if(strcmp(POpt,'X'))return; end;
if(strcmp(POpt,'Help')),
  vp_help('vp_spmlike'); vp_spmlike;
  return;
end

[hReg, SSM, VOL ]=vp_spmresults;
