       
%function [out1]=vp_statbar(pos,datamin,datamax,threshmin,threshmax)
%___________________________________________________________
% vp_statbar.m	ScAnVP C.4.4	P.Spetsieris  Feb. 1,2000
%
% Draws an upper half statistical output colorbar given
% an option for determining its size and position and
% the data range and threshold limits.
% pos=1: medium, lower right, pos=2: small far right
% Datamin, datamax corresponds to the background and any stored
% data values up to the maximum statistical value.
% The lower half of the full range (datamin, datamax) corresponds
% to the background image and the upper half includes the data range.
%___________________________________________________________

function [out1]=vp_statbar(pos,datamin,datamax,threshmin,threshmax)

   out1=0;
   
   data=[];
   
   outdelta=datamax-datamin;
   
   %if datop,
   % outmax=threshmax;
   %else
   % outmax=datamax;
   %end
   
   delta=outdelta/2;
   statmin=datamin+delta;
   %statmin=datamax-delta;
   dinc=delta/128;
   
   %for i=1:129, data(i)=outmax-(i-1)*dinc; end;
   for i=1:129, data(i)=datamax-(i-1)*dinc; end;
   data = data';
	
   if pos==1,
    barx=0.75;
    bary=0.11;
    barwidth=.04;
    barheight=.30;
   else,
    barx=0.82;
    bary=0.015;
    barwidth=.03;
    barheight=.18;
   end
   
   rect=[barx, bary, barwidth, barheight];
   axes('position',rect);
   imagesc(data,[datamin datamax]);
   %imagesc(data,[datamin outmax]);
   
   axis off;
	
   %NoStr=['Max ', num2str(datamax)];
   %[t,r]=strtok(NoStr,'.');
   %if ~isempty(r), r=r(1:min(3,length(r))); NoStr=[t,r]; end;
   %if pos==1,
    % axes('position',[.80, (bary + barheight) , .20, .02]);
   %else,
    % axes('position',[.85, (bary + barheight) , .08, .006]);
   %end
   %text(0,0,NoStr,'Color',[1.0 1.0 1.0]);
   %axis off;
   
   NoStr=['ThMax ', num2str(threshmax)];
   [t,r]=strtok(NoStr,'.');
   if ~isempty(r), r=r(1:min(3,length(r))); NoStr=[t,r]; end;
   if pos==1,
     axes('position',[.80, (bary + ((threshmax-statmin)/delta)*barheight) , .20, .02]);
   else,
     axes('position',[.85, (bary + ((threshmax-statmin)/delta)*barheight) , .08, .006]);
    % axes('position',[.85, (bary + (threshold/datamax)*barheight) , .08, .006]);
   end
   
   text(0,0,NoStr,'Color',[1.0 1.0 1.0],'FontWeight','Bold','FontSize',14);
   axis off;
  
   NoStr=['ThMin ', num2str(threshmin)];
   [t,r]=strtok(NoStr,'.');
   if ~isempty(r), r=r(1:min(3,length(r))); NoStr=[t,r]; end;
   if pos==1,
     axes('position',[.80, (bary + ((threshmin-statmin)/delta)*barheight) , .20, .02]);
   else,
     axes('position',[.85, (bary + ((threshmin-statmin)/delta)*barheight) , .08, .006]);
    % axes('position',[.85, (bary + (threshold/datamax)*barheight) , .08, .006]);
   end
   
   text(0,0,NoStr,'Color',[1.0 1.0 1.0],'FontWeight','Bold','FontSize',14);
   axis off;
  
   %w=which('scanvp');
   %cf=[w(1:(max(findstr(w,'\'))-4)),'col\graycols'];
   %load(cf); colormap(graycols); GCM=colormap;

   drawnow;
   
