% vp_tfactgui.m
% Get transparency factor for PET/MRI image 
%__________________________________________________________________________
% vp_tfactgui.m	C.4.6 	P. Spetsieris	 Mar. 28, 2001

global TFact
global herror Message Ecolor 

global TFact herror hslider


tfactgui=findobj('Name','tfactgui');
if ~isempty(tfactgui)
	if(strcmp(get(tfactgui,'Visible'),'on'))
		figure(tfactgui);
	end
	return
end



Message0=['MSG: ............................................ '];
Message=Message0;

frmcolor=[0.5 0.7 0.8];

tfactgui = figure('Color',frmcolor,'Name','tfactgui',...
'NumberTitle','off','Position',[100,370,260,85],...
'Units','Pixels');
	
Bcolor = [.8,1,1];


cbTFact=['TFact=str2num(get(hTFact,''string'')); ',...
	['if(TFact >= 0) & (TFact <= 1 ),',...
	'Message=Message0; set(hslider,''Value'',TFact);',...
	'else, Message=''Error: Factor Out of Bounds''; end; '],...
		'set(herror,''string'',['' '',Message]);'];

cbSliTFact=['TFact=get(gco,''Value'');, set(hTFact,''string'',TFact);',...
	['if(TFact < 0) | (TFact > 1) Message=''Error: Factor Out of Bounds'';',...
	'else Message=Message0; end; '],...
		'set(herror,''string'',['' '',Message]);'];

uicontrol(tfactgui,'Style','text','string', 'Transparency Factor 0-1',...
	'position',[10 55 100 20],'BackgroundColor',frmcolor);
	
hslider=uicontrol(tfactgui,'Style','slider', 'Position', [10 35 200 25], 'Min',0,'Max',1,...
	'Value',TFact,'Callback',cbSliTFact);
	
hTFact=uicontrol(tfactgui,'style','edit','string',TFact,...
	'position',[210 35 40 25],'BackgroundColor',Bcolor,'callback',cbTFact);

uicontrol(tfactgui,'String','RETURN',...
	'Position',[180 10 70 25],...
	'CallBack',['if TFact >= 0 & TFact <=1, delete(gcbf); ',...
	'else, Message=''Error: Transparency Factor Out of Bounds''; set(herror,''string'',Message); end;']);
	
