% vp_thresh.m
% Get Threshold value
%__________________________________________________________________________
% vp_thresh.m	C.0 	P. Spetsieris	 June 8, 1999
% 			rev. 5.8 P.S.	 May 11, 2007

global FixedThresh
global herror Message Ecolor 

global FixedThresh herror hslider


threshgui=findobj('Name','threshgui');
if ~isempty(threshgui)
	if(strcmp(get(threshgui,'Visible'),'on'))
		figure(threshgui);
	end
	return
end

roigui=findobj('Name','GROUP ROIgui');
if ~isempty(roigui)
	set(roigui,'Visible','off');
end


Message0=['MSG: ............................................ '];
Message=Message0;

frmcolor=[0.5 0.7 0.8];

threshgui = figure('Color',frmcolor,'Name','threshgui',...
'NumberTitle','off','Position',[100,370,260,85],...
'Units','Pixels');
	
Bcolor = [.8,1,1];


cbFixedThresh=['FixedThresh=str2num(get(hFixedThresh,''string'')); ',...
	['if(FixedThresh >= 0) & (FixedThresh <= 100 ),',...
	'Message=Message0; set(hslider,''Value'',FixedThresh);',...
	'else, Message=''Error: Threshold Out of Bounds''; end; '],...
		'set(herror,''string'',['' '',Message]);'];

cbSliFixedThresh=['FixedThresh=ceil(get(gco,''Value''));, set(hFixedThresh,''string'',FixedThresh);',...
	['if(FixedThresh < 0) | (FixedThresh > 100) Message=''Error: Threshold Out of Bounds'';',...
	'else Message=Message0; end; '],...
		'set(herror,''string'',['' '',Message]);'];

uicontrol(threshgui,'Style','text','string', 'THRESHOLD 0-100',...
	'position',[10 55 100 20],'BackgroundColor',frmcolor);
	
hslider=uicontrol(threshgui,'Style','slider', 'Position', [10 35 200 25], 'Min',0,'Max',100,...
	'Value',FixedThresh,'Callback',cbSliFixedThresh);
	
hFixedThresh=uicontrol(threshgui,'style','edit','string',FixedThresh,...
	'position',[210 35 40 25],'BackgroundColor',Bcolor,'callback',cbFixedThresh);

herror = uicontrol(threshgui,'string', ['MSG: ..............................'],...
	'position',[10 10 170 25],...
	'CallBack',['set(herror,''string'',['' '',Message]);'],...
	'BackgroundColor',Ecolor);

uicontrol(threshgui,'String','RETURN',...
	'Position',[180 10 70 25],...
	'CallBack',['if FixedThresh >= 0 & FixedThresh <=100, delete(gcbf); ',...
	'  roigui=findobj(''Name'',''GROUP ROIgui'');',...
	'  if ~isempty(roigui), set(roigui,''Visible'',''on''); end;',...
	'else, Message=''Error: Threshold Out of Bounds''; set(herror,''string'',Message); end;']);
	
