% vp_transpro
% multi window transparent image display processing 
%_______________________________________________________________________
% vp_transpro is a routine that displays transparent consecutive sectional
% slices from an ANALYZE format image in various multi-figure multi-subwindow
% display formats.
%_______________________________________________________________________
% vp_transpro		C.4.6		P. Spetsieris	3/28/01

global Message PlaneNo FName WinView WinFormat MaxPlane Plane0 Opt Time MaxDim
global DIM VOX SCALE TYPE OFFSET ORIGIN DESCRIP GLMAX GLMIN DESCRIP
global EXPTIM DURATION MATYPE DATAMIN DATAMAX GENTIM SUBID EXPDATE
global CF CF0 CB GCM SliceDelta XYZDATA FDATA BDATA XYZOR NumLabels PhyLabels
global FRName BGName BDATMIN BDATMAX FDATMIN FDATMAX TFact
global ViewLowVal

%FName      = get_file(1,'.img','please select image',[]);

Message=[];

if Opt == 1

vp_hread(FName);
 
P=FName;
q     = length(P);
if P(q - 3) == '.'; P = P(1:(q - 4)); end
FName=P;

if(Time==1)

  WinView=1;
  WinFormat=4 ;
  Plane0 = 1;
  MaxPlane = DIM(3) ;
  MaxDim=DIM(3);
  TFact=.5;
  
else
  if WinView==1
  	if DIM(3) < MaxDim, MaxPlane=DIM(3);
  	else MaxPlane=min(MaxPlane,DIM(3)); end;
  elseif WinView==2
  	if DIM(1) < MaxDim, MaxPlane=DIM(1);
  	else MaxPlane=min(MaxPlane,DIM(1)); end;
  elseif WinView==3
  	if DIM(2) < MaxDim, MaxPlane=DIM(2);
  	else MaxPlane=min(MaxPlane,DIM(2)); end;
  end
  
  if Plane0 > MaxPlane, Plane0=1; end;
 
end

vp_imvorth;

return;


elseif Opt==2


%FNimg = [FName '.img'];
%[fid,errmessage] = fopen(FNimg,'r');
%if (fid == -1 )
%	errmessage
%	return;
%end


if isempty(PlaneNo)
	PlaneNo0= [];
else
	PlaneNo0= PlaneNo;
end

PlaneNo = 1; 


FWID=WinFormat*DIM(1);
FHGT=WinFormat*DIM(2);
xmax = DIM(1)/FWID ;
ymax = DIM(2)/FHGT ;
ImageSize=DIM(1)*DIM(2);
WMax=WinFormat*WinFormat;
MaxDim = DIM(3);

DATA=zeros(DIM(1),DIM(2));

 
%fseek(fid,0,'bof');

% if WinView ~= 1
%	XYZDATA=zeros(DIM(1),DIM(2),DIM(3));
%	for PlaneNo = 1:DIM(3) ,
%		if TYPE==2
%		  XYZDATA(:,:,PlaneNo) = fread(fid,[DIM(1),DIM(2)],'uchar');
%		elseif TYPE==4
%		  XYZDATA(:,:,PlaneNo) = fread(fid,[DIM(1),DIM(2)],'int16');
%		  XYZDATA(:,:,PlaneNo)=XYZDATA(:,:,PlaneNo)/displscale;
%		end
%	end %for
	if WinView == 2
		MaxDim= DIM(1);
		DATA=zeros(DIM(2),DIM(3));
		FWID=WinFormat*DIM(2);
		FHGT=WinFormat*DIM(3);
		xmax = DIM(2)/FWID ;
		ymax = DIM(3)/FHGT ;
	elseif WinView == 3
		MaxDim= DIM(2);
		DATA=zeros(DIM(1),DIM(3));
		FWID=WinFormat*DIM(1);
		FHGT=WinFormat*DIM(3);
		xmax = DIM(1)/FWID ;
		ymax = DIM(3)/FHGT ;
	end
%  end

%  fseek(fid,ImageSize*(Plane0-1),'bof');
%  fclose(fid);
  
  PlaneNo=Plane0 ;
  txti=5;
  %txtj=-5 ;
  txtj= 10 - 3*WinFormat ;
  %txtj=15;
  %txtj=8 ;
  while PlaneNo <= min(MaxPlane,MaxDim) ,

	WNo = 1;

	%FI = figure('Color',[1 1 1]*.8
	FI = figure('Color',[.2 .4 .6],'Name',FName,...
	'Position',[100,10,512,512],...
	'Units','Pixels');
	
	while WNo <= WMax ,
	if(PlaneNo > MaxDim), break; end;
	if(PlaneNo > MaxPlane), break; end;
	
	if WinView == 1
  		%fseek(fid,ImageSize*(Plane-1),'bof');
		%if TYPE==2
		  %DATA	= fread(fid,[DIM(1),DIM(2)],'uchar');
		%elseif TYPE==4
		  %DATA  = fread(fid,[DIM(1),DIM(2)],'int16');
		  %DATA  = DATA/displscale;
		%end
		
		DATA=XYZDATA(:,:,PlaneNo);
		DATA = DATA';
	elseif WinView == 2
		DATA=zeros(DIM(2),DIM(3));
		for ix=1:DIM(2)
		  for iy=1:DIM(3)
		  	DATA(ix,iy)=XYZDATA(PlaneNo,ix,iy);
		  end
		end
	elseif WinView == 3
		DATA=zeros(DIM(1),DIM(3));
		for ix=1:DIM(1)
		  for iy=1:DIM(3)
		  	DATA(ix,iy)=XYZDATA(ix,PlaneNo,iy);
		  end
		end
	end

%subDATA = DATA
   	if PlaneNo >= Plane0,
	%	rect=[ i j xmax ymax];
	%	Ax=axes('Position',rect,'Visible','off');
	%	imh=image([i,(i+xmax)], [j,(j+ymax)], DATA);
		Ax(PlaneNo-Plane0+1)=subplot(WinFormat,WinFormat,WNo);
	%	imh=image(DATA);
		if WinView ~= 1
			%DATA=rot90(DATA);
			DATA=DATA';
		end
		%DATA=flipud(DATA);
		%imh=imagesc(DATA,[0 255]);
		imh=imagesc(DATA,[DATAMIN DATAMAX]);
		axis off image xy
 		colormap(GCM);
		
		%Correct for aspect ratio
		vp_aspect(WinView,VOX);
		
		%PlaneNoStr=num2str(PlaneNo);
		%thdl=text(txti,txtj,PlaneNoStr,'Color',[1.0 1.0 1.0]);
		
		if NumLabels,
		  PlaneNoStr=num2str(PlaneNo);
		  thdl=text(txti-2,txtj+8,PlaneNoStr,'Color',[0.9 0.9 0.8],...
	  	    'FontName','Times','FontSize',7);
		end
		
		%Display Coordinate
		if PhyLabels,
		  if WinView == 1
		    ZCoord=(PlaneNo-XYZOR(3))*Dz;
		    titlestr=num2str((PlaneNo-XYZOR(3))*Dz);
		    text(txti+10,txtj-8,['z=',titlestr],...
	  	    'FontName','Times','FontSize',11,...
		    'Color',[1.0 1.0 1.0]);
		  elseif WinView == 2
		    XCoord=(PlaneNo-XYZOR(1))*Dx ;
		    titlestr=num2str((PlaneNo-XYZOR(1))*Dx);
		    text(txti+10,txtj-8,['x=',titlestr],...
	  	    'FontName','Times','FontSize',11,...
		    'Color',[1.0 1.0 1.0]);
		  elseif WinView == 3
		    YCoord=(PlaneNo-XYZOR(2))*Dy;
		    titlestr=num2str((PlaneNo-XYZOR(2))*Dy);
		    text(txti+10,txtj-8,['y=',titlestr],...
	  	    'FontName','Times','FontSize',11,...
		    'Color',[1.0 1.0 1.0]);
		  end
		end
		
		set(Ax(PlaneNo-Plane0+1),'UserData',[WinView PlaneNo VOX XYZOR]);
		
		drawnow;
		WNo = WNo + 1;
   	end % if PlaneNo
	PlaneNo = PlaneNo + SliceDelta ;
	
	end % While WNo
	
	vp_controls(gcf,mfilename,1);
	
   end % while
   
   PlaneNo=PlaneNo0;	% Restore Original value;
   fprintf('\n\n> '); 
   
   
elseif Opt==3

if isempty(PlaneNo)
	PlaneNo0= [];
else
	PlaneNo0= PlaneNo;
end

PlaneNo = 1; 


FWID=WinFormat*DIM(1);
FHGT=WinFormat*DIM(2);
xmax = DIM(1)/FWID ;
ymax = DIM(2)/FHGT ;
ImageSize=DIM(1)*DIM(2);
WMax=WinFormat*WinFormat;
MaxDim = DIM(3);

DATA=zeros(DIM(1),DIM(2));
DATAB=zeros(DIM(2),DIM(1),3);
DATAF=zeros(DIM(2),DIM(1),3);


lenf=length(CF);
lenb=length(CB);
deltf=(FDATMAX-FDATMIN)/lenf;
deltb=(BDATMAX-BDATMIN)/lenb;
CF0=CF;
if ~ViewLowVal, CF0(1,:)=[0 0 0]; end;
	
	if WinView == 2
		MaxDim= DIM(1);
		DATA=zeros(DIM(2),DIM(3));
		FWID=WinFormat*DIM(2);
		FHGT=WinFormat*DIM(3);
		xmax = DIM(2)/FWID ;
		ymax = DIM(3)/FHGT ;
		DATAB=zeros(DIM(3),DIM(2),3);
		DATAF=zeros(DIM(3),DIM(2),3);
	elseif WinView == 3
		MaxDim= DIM(2);
		DATA=zeros(DIM(1),DIM(3));
		FWID=WinFormat*DIM(1);
		FHGT=WinFormat*DIM(3);
		xmax = DIM(1)/FWID ;
		ymax = DIM(3)/FHGT ;
		DATAB=zeros(DIM(3),DIM(1),3);
		DATAF=zeros(DIM(3),DIM(1),3);
	end
  
  PlaneNo=Plane0 ;
  txti=5;
  txtj= 10 - 3*WinFormat ;
  while PlaneNo <= min(MaxPlane,MaxDim) ,

	WNo = 1;

	FI = figure('Color',[.2 .4 .6],'Name',FName,...
	'Position',[100,10,512,512],...
	'Units','Pixels');
	
	while WNo <= WMax ,
	if(PlaneNo > MaxDim), break; end;
	if(PlaneNo > MaxPlane), break; end;
	
	if WinView == 1
		DATA=FDATA(:,:,PlaneNo);
		for ix=1:DIM(1)
		  for iy=1:DIM(2)
		  	n=max(1,round((DATA(ix,iy)-FDATMIN)/deltf)); 
			n=min(n,lenf);
		  	DATAF(iy,ix,:)= CF0(n,:);
		  end
		end
		
		DATA=BDATA(:,:,PlaneNo);
		for ix=1:DIM(1)
		  for iy=1:DIM(2)
		  	n=max(1,round((DATA(ix,iy)-BDATMIN)/deltb)); 
			n=min(n,lenb);
		  	DATAB(iy,ix,:)= CB(n,:);
		  end
		end
		
	elseif WinView == 2
		%DATA=zeros(DIM(2),DIM(3));
		for ix=1:DIM(2)
		  for iy=1:DIM(3)
		  	DATA(ix,iy)=FDATA(PlaneNo,ix,iy);
		  end
		end
		
		for ix=1:DIM(2)
		  for iy=1:DIM(3)
		  	n=max(1,round((DATA(ix,iy)-FDATMIN)/deltf)); 
			n=min(n,lenf);
		  	DATAF(iy,ix,:)= CF0(n,:);
		  end
		end
		
		for ix=1:DIM(2)
		  for iy=1:DIM(3)
		  	DATA(ix,iy)=BDATA(PlaneNo,ix,iy);
		  end
		end
		
		for ix=1:DIM(2)
		  for iy=1:DIM(3)
		  	n=max(1,round((DATA(ix,iy)-BDATMIN)/deltb)); 
			n=min(n,lenb);
		  	DATAB(iy,ix,:)= CB(n,:);
		  end
		end
		
	elseif WinView == 3
		%DATA=zeros(DIM(1),DIM(3));
		for ix=1:DIM(1)
		  for iy=1:DIM(3)
		  	DATA(ix,iy)=FDATA(ix,PlaneNo,iy);
		  end
		end
		
		for ix=1:DIM(1)
		  for iy=1:DIM(3)
		  	n=max(1,round((DATA(ix,iy)-FDATMIN)/deltf)); 
			n=min(n,lenf);
		  	DATAF(iy,ix,:)= CF0(n,:);
		  end
		end
		
		for ix=1:DIM(1)
		  for iy=1:DIM(3)
		  	DATA(ix,iy)=BDATA(ix,PlaneNo,iy);
		  end
		end
		
		for ix=1:DIM(1)
		  for iy=1:DIM(3)
		  	n=max(1,round((DATA(ix,iy)-BDATMIN)/deltb)); 
			n=min(n,lenb);
		  	DATAB(iy,ix,:)= CB(n,:);
		  end
		end
	end

%subDATA = DATA
   	if PlaneNo >= Plane0,
		Ax(PlaneNo-Plane0+1)=subplot(WinFormat,WinFormat,WNo);
		
		image(TFact*DATAF + (1-TFact)*DATAB);
		axis off image xy;
		
		%Correct for aspect ratio
		vp_aspect(WinView,VOX);
		
		if NumLabels,
		  PlaneNoStr=num2str(PlaneNo);
		  thdl=text(txti-2,txtj+8,PlaneNoStr,'Color',[0.9 0.9 0.8],...
	  	    'FontName','Times','FontSize',7);
		end
		
		if PhyLabels,
		  if WinView == 1
		    ZCoord=(PlaneNo-XYZOR(3))*Dz;
		    titlestr=num2str((PlaneNo-XYZOR(3))*Dz);
		    text(txti+10,txtj-8,['z=',titlestr],...
	  	    'FontName','Times','FontSize',11,...
		    'Color',[1.0 1.0 1.0]);
		  elseif WinView == 2
		    XCoord=(PlaneNo-XYZOR(1))*Dx ;
		    titlestr=num2str((PlaneNo-XYZOR(1))*Dx);
		    text(txti+10,txtj-8,['x=',titlestr],...
	  	    'FontName','Times','FontSize',11,...
		    'Color',[1.0 1.0 1.0]);
		  elseif WinView == 3
		    YCoord=(PlaneNo-XYZOR(2))*Dy;
		    titlestr=num2str((PlaneNo-XYZOR(2))*Dy);
		    text(txti+10,txtj-8,['y=',titlestr],...
	  	    'FontName','Times','FontSize',11,...
		    'Color',[1.0 1.0 1.0]);
		  end
		end
		
		set(Ax(PlaneNo-Plane0+1),'UserData',[WinView PlaneNo VOX XYZOR]);
		
		drawnow;
		WNo = WNo + 1;
   	end % if PlaneNo
	PlaneNo = PlaneNo + SliceDelta ;
	
	end % While WNo
	
	vp_controls(gcf,mfilename,1);
	
   end % while
   
   PlaneNo=PlaneNo0;	% Restore Original value;
   fprintf('\n\n> '); 
   
end %if Opt
