% function vp_write_srpfile(name,roi_max,file_list,srp)
%
% This function creates an SSM output file (name) of the subject residual 
% profile values (srp) corresponding to roi_max number of regions listed
% for each subject. It is also used for SSF output listings.
% 
% write_srp_file (main)                   Yilong Ma, Ph.D.        4/24/2003
% vp_write_srpfile (revision) ScAnVP 5.1  P.Spetsieris, Ph.D.     5/08/2003
%_______________________________________________________________________
function vp_write_srpfile(name,roi_max,file_list,srp)

global HelpMode 

if HelpMode, vp_help(mfilename), return ; end;

chlist=char(file_list);
mxfield=size(chlist,2);
skipstr=char(' '.*ones(1,mxfield));

fd = fopen(name,'wt');
   
sub = length(file_list);
for i = 1:sub
   chskip=mxfield-length(char(file_list{i}));
   fprintf(fd,'%c%c',file_list{i},skipstr(1:chskip));
   for j = 1:roi_max
      fprintf(fd,'%10.3f',srp(i,j));
   end
   fprintf(fd,'\n');
end   
fclose(fd);
