% function val=vp_xyzcoord(fi);
%
% Pick a point on a data image and return its coordinates
%_______________________________________________________________________
% vp_xyzcoord.m  		C.4.7.8 Phoebe Spetsieris  Aug. 30, 2002

function [out1,xmm,ymm,zmm] = vp_xyzcoord(fi)

global HelpMode 

if HelpMode, vp_help(mfilename), return ; end;

out1=0; 
viewno=0;

TxColor=[0.8 0.2 1];

	
figure(fi);
       
[x,y]=ginput(1);

if strcmp(get(gco,'type'),'image')
  
  x=round(x), y=round(y),
  udata=get(gca,'UserData');
  if ~isempty(udata),
  
    viewno=udata(1); plno=udata(2); vox=udata(3:5); xyzor=udata(6:8);
    if viewno==1
  	xmm=(x-xyzor(1))*vox(1); ymm=(y-xyzor(2))*vox(2);
	zmm=(plno-xyzor(3))*vox(3);
    elseif viewno==2,
  	ymm=(x-xyzor(2))*vox(2); zmm=(y-xyzor(3))*vox(3);
	xmm=(plno-xyzor(1))*vox(1);
    elseif viewno==3,
  	xmm=(x-xyzor(1))*vox(1); zmm=(y-xyzor(3))*vox(3);
	ymm=(plno-xyzor(2))*vox(2);
    end
  end
  
else
	out1=-1;
	vp_message('Not an ''image'' point');
	return;
end

	






