% vp_zeronegs
% Zero Negatives of ANALYZE Format images
%_______________________________________________________________________
% vp_zeronegs allows the user to set all negatives to zero for
% a set of ANALYZE format images.
% If negatives are found, the processed images are assigned a 'Z'
% suffix.
%_______________________________________________________________________
% vp_zeronegs		C.4.4	P. Spetsieris	1/13/00

global HelpMode FMenu Message NameLst

if HelpMode, vp_help(mfilename), return ; end;

out1=0;
op='Z';

%NameLst      = get_file(Inf,'.img','Select images to Zero Negatives',[]);
if vp_filesui(Inf,'.img','Select images to ZERO Negatives',mfilename) < 0 ,return; end;

m= size(NameLst,1);
dim3=0;

if m <=0,
  return;
end;

set(FMenu,'Pointer','Watch');
h=waitbar(0.1,'Processing Zero Negatives ...');

	
for i=1:m

  	FName=deblank(NameLst(i,:));
	
	waitbar((i-.8)/m, h);
	
	[out1]=vp_imcvt(FName,op,2);
	
	if out1 < 0, 
	  vp_note(Message);
	  %disp(['vp_zeronegs ABORTED ']);

	  waitfor(findobj('Name','Note'));
	  %while(findobj('Name','Message')), pause(1); end;
	else
	  %while(~isempty(findobj('Tag','imcvtgui'))), pause(1); end;
	end
end

waitbar(1,h); pause(1); close(h);
set(FMenu,'Pointer','Arrow');
%disp('END vp_zeronegs');
vp_note('Zero Negs. PROCESSING COMPLETE');


